# -*- coding: utf-8 -*-
# Auto-generated code by cachemaker.py
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
apicache = {u'authorize': {u'securitygroupingress': {u'name': u'authorizeSecurityGroupIngress', u'related': [u'authorizeSecurityGroupEgress'], u'isasync': True, u'params': [{u'name': u'securitygroupname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The name of the security group. Mutually exclusive with securityGroupName parameter'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list associated'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'TCP is default. UDP is the other supported protocol'}, {u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'end port for this ingress rule'}, {u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'start port for this ingress rule'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project of the security group'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the security group. If the account parameter is used, domainId must also be used.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the security group. Must be used with domainId.'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'securitygroupid', u'required': False, u'related': [u'listSecurityGroups', u'createSecurityGroup'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the security group. Mutually exclusive with securityGroupName parameter'}, {u'name': u'usersecuritygrouplist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'user to security group mapping'}], u'requiredparams': [], u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}], u'description': u'Authorizes a particular ingress rule for this security group'}, u'securitygroupegress': {u'name': u'authorizeSecurityGroupEgress', u'related': [], u'isasync': True, u'params': [{u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'start port for this egress rule'}, {u'name': u'usersecuritygrouplist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'user to security group mapping'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'TCP is default. UDP is the other supported protocol'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list associated'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project of the security group'}, {u'name': u'securitygroupname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The name of the security group. Mutually exclusive with securityGroupName parameter'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the security group. If the account parameter is used, domainId must also be used.'}, {u'name': u'securitygroupid', u'required': False, u'related': [u'listSecurityGroups'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the security group. Mutually exclusive with securityGroupName parameter'}, {u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the security group. Must be used with domainId.'}, {u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'end port for this egress rule'}], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'description': u'Authorizes a particular egress rule for this security group'}}, u'restore': {u'virtualmachine': {u'name': u'restoreVirtualMachine', u'related': [u'listVirtualMachines', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Virtual Machine ID'}, {u'name': u'templateid', u'required': False, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'an optional template Id to restore vm from the new template. This can be an ISO id in case of restore vm deployed using ISO'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}], u'name': u'securitygroup'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}], u'description': u'Restore a VM to original template/ISO or new template/ISO'}}, u'suspend': {u'project': {u'name': u'suspendProject', u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listProjects', u'createProject', u'updateProject', u'suspendProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to be suspended'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}], u'description': u'Suspends a project'}}, u'revoke': {u'securitygroupingress': {u'name': u'revokeSecurityGroupIngress', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The ID of the ingress rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a particular ingress rule from this security group'}, u'securitygroupegress': {u'name': u'revokeSecurityGroupEgress', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'authorizeSecurityGroupEgress'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the egress rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a particular egress rule from this security group'}}, u'disassociate': {u'ipaddress': {u'name': u'disassociateIpAddress', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the id of the public ip address to disassociate'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Disassociates an ip address from the account.'}}, u'migrate': {u'volume': {u'name': u'migrateVolume', u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'volumeid', u'required': True, u'related': [u'migrateVolume', u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the volume'}, {u'name': u'storageid', u'required': True, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'enableStorageMaintenance', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'destination storage pool ID to migrate the volume to'}, {u'name': u'livemigrate', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if the volume should be live migrated when it is attached to a running vm'}], u'requiredparams': [u'volumeid', u'storageid'], u'response': [{u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}], u'description': u'Migrate volume'}, u'systemvm': {u'name': u'migrateSystemVm', u'related': [u'scaleSystemVm', u'listSystemVms', u'rebootSystemVm'], u'isasync': True, u'params': [{u'name': u'hostid', u'required': True, u'related': [u'listHosts', u'listExternalLoadBalancers'], u'length': 255, u'type': u'uuid', u'description': u'destination Host ID to migrate VM to'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'rebootSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}], u'requiredparams': [u'hostid', u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}], u'description': u'Attempts Migration of a system virtual machine to the host specified.'}, u'virtualmachine': {u'name': u'migrateVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'storageid', u'required': False, u'related': [u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'Destination storage pool ID to migrate VM volumes to. Required for migrating the root disk volume'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'Destination Host ID to migrate VM to. Required for live migrating a VM from host to host'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}], u'description': u'Attempts Migration of a VM to a different host or Root volume of the vm to a different storage pool'}, u'virtualmachinewithvolume': {u'name': u'migrateVirtualMachineWithVolume', u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}, {u'name': u'migrateto', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'Map of pool to which each volume should be migrated (volume/pool pair)'}, {u'name': u'hostid', u'required': True, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'Destination Host ID to migrate VM to.'}], u'requiredparams': [u'virtualmachineid', u'hostid'], u'response': [{u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}], u'name': u'nic'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}], u'name': u'affinitygroup'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}], u'description': u'Attempts Migration of a VM with its volumes to a different host'}}, u'lock': {u'account': {u'name': u'lockAccount', u'related': [u'listAccounts', u'listAccounts', u'ldapCreateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'isasync': False, u'params': [{u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Locks the specified account.'}, {u'name': u'domainid', u'required': True, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Locks the specified account on this domain.'}], u'requiredparams': [u'account', u'domainid'], u'response': [{u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}], u'name': u'user'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}], u'description': u'Locks an account'}, u'user': {u'name': u'lockUser', u'related': [u'listUsers'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'lockUser', u'listUsers'], u'length': 255, u'type': u'uuid', u'description': u'Locks user by user ID.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}], u'description': u'Locks a user account'}}, u'copy': {u'iso': {u'name': u'copyIso', u'related': [u'listIsos', u'listTemplates', u'listIsos', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'Template ID.'}, {u'name': u'sourcezoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'ID of the zone the template is currently hosted on. If not specified and template is cross-zone, then we will sync this template to region wide image store.'}, {u'name': u'destzoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'ID of the zone the template is being copied to.'}], u'requiredparams': [u'id', u'destzoneid'], u'response': [{u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}], u'description': u'Copies an iso from one zone to another.'}, u'template': {u'name': u'copyTemplate', u'related': [u'listTemplates', u'prepareTemplate', u'createTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'createTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'copyTemplate', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'Template ID.'}, {u'name': u'destzoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'ID of the zone the template is being copied to.'}, {u'name': u'sourcezoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'ID of the zone the template is currently hosted on. If not specified and template is cross-zone, then we will sync this template to region wide image store.'}], u'requiredparams': [u'id', u'destzoneid'], u'response': [{u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}], u'description': u'Copies a template from one zone to another.'}}, u'replace': {u'networkacllist': {u'name': u'replaceNetworkACLList', u'related': [], u'isasync': True, u'params': [{u'name': u'aclid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL'}, {u'name': u'gatewayid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the private gateway'}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network'}], u'requiredparams': [u'aclid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Replaces ACL associated with a Network or private gateway'}}, u'list': {u'lbhealthcheckpolicies': {u'name': u'listLBHealthCheckPolicies', u'related': [u'createLBHealthCheckPolicy', u'updateLBHealthCheckPolicy'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}], u'requiredparams': [u'lbruleid'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain of the HealthCheck policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the HealthCheck policy'}, {u'description': u'the list of healthcheckpolicies', u'type': u'list', u'response': [{u'type': u'int', u'name': u'healthcheckinterval', u'description': u'Amount of time between health checks'}, {u'type': u'int', u'name': u'responsetime', u'description': u'Time to wait when receiving a response from the health check'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'int', u'name': u'healthcheckthresshold', u'description': u'Number of consecutive health check success before declaring an instance healthy'}, {u'type': u'int', u'name': u'unhealthcheckthresshold', u'description': u'Number of consecutive health check failures before declaring an instance unhealthy.'}, {u'type': u'string', u'name': u'pingpath', u'description': u'the pingpath  of the healthcheck policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB HealthCheck policy ID'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the healthcheck policy'}], u'name': u'healthcheckpolicy'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the HealthCheck policy'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the HealthCheck policy belongs to'}], u'description': u'Lists load balancer HealthCheck policies.'}, u'apis': {u'name': u'listApis', u'related': [], u'isasync': False, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'API name'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'isasync', u'description': u'true if api is asynchronous'}, {u'type': u'string', u'name': u'since', u'description': u'version of CloudStack the api was introduced in'}, {u'description': u'the list params the api accepts', u'type': u'set', u'response': [{u'type': u'boolean', u'name': u'required', u'description': u'true if this parameter is required for the api request'}, {u'type': u'int', u'name': u'length', u'description': u'length of the parameter'}, {u'type': u'string', u'name': u'related', u'description': u'comma separated related apis to get the parameter'}, {u'type': u'string', u'name': u'type', u'description': u'parameter type'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the api parameter'}, {u'type': u'string', u'name': u'description', u'description': u'description of the api parameter'}, {u'type': u'string', u'name': u'since', u'description': u'version of CloudStack the api was introduced in'}], u'name': u'params'}, {u'type': u'string', u'name': u'type', u'description': u'response field type'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the api command'}, {u'type': u'string', u'name': u'description', u'description': u'description of the api'}, {u'description': u'api response fields', u'type': u'set', u'response': [{u'type': u'string', u'name': u'type', u'description': u'response field type'}, {u'type': u'string', u'name': u'description', u'description': u'description of the api response field'}, {u'type': u'set', u'name': u'response', u'description': u'api response fields'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the api response field'}], u'name': u'response'}, {u'type': u'string', u'name': u'related', u'description': u'comma separated related apis'}], u'description': u'lists all available apis on the server, provided by the Api Discovery plugin'}, u'instancegroups': {u'name': u'listInstanceGroups', u'related': [u'createInstanceGroup', u'updateInstanceGroup'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'id', u'required': False, u'related': [u'createInstanceGroup', u'updateInstanceGroup', u'listInstanceGroups'], u'length': 255, u'type': u'uuid', u'description': u'list instance groups by ID'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list instance groups by name'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the instance group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the instance group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'date', u'name': u'created', u'description': u'time and date the instance group was created'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the instance group'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the instance group'}], u'description': u'Lists vm groups'}, u'ucsmanagers': {u'name': u'listUcsManagers', u'related': [u'addUcsManager'], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'addUcsManager', u'listUcsManagers'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the ucs manager'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the zone id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of ucs manager'}, {u'type': u'string', u'name': u'url', u'description': u'the url of ucs manager'}, {u'type': u'string', u'name': u'name', u'description': u'the name of ucs manager'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ucs manager'}], u'description': u'List ucs manager'}, u'physicalnetworks': {u'name': u'listPhysicalNetworks', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list physical network by id'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'search by name'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the physical network'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'networkspeed', u'description': u'the speed of the physical network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the physical network owner'}, {u'type': u'string', u'name': u'tags', u'description': u'comma separated tag'}, {u'type': u'string', u'name': u'name', u'description': u'name of the physical network'}, {u'type': u'string', u'name': u'isolationmethods', u'description': u'isolation methods'}, {u'type': u'string', u'name': u'vlan', u'description': u'the vlan of the physical network'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of the physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the physical network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the physical network'}, {u'type': u'string', u'name': u'broadcastdomainrange', u'description': u'Broadcast domain range of the physical network'}], u'description': u'Lists physical networks'}, u'vmsnapshot': {u'name': u'listVMSnapshot', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'state of the virtual machine snapshot'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists snapshot by snapshot name or display name'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'vmsnapshotid', u'required': False, u'related': [u'listVMSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the VM snapshot'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the vm'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'parent', u'description': u'the parent ID of the vm snapshot'}, {u'type': u'string', u'name': u'type', u'description': u'VM Snapshot type'}, {u'type': u'date', u'name': u'created', u'description': u'the create date of the vm snapshot'}, {u'type': u'string', u'name': u'displayname', u'description': u'the display name of the vm snapshot'}, {u'type': u'string', u'name': u'parentName', u'description': u'the parent displayName of the vm snapshot'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the vm snapshot'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the vm snapshot'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the vm snapshot'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the vm ID of the vm snapshot'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the vm snapshot'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the vm snapshot'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'boolean', u'name': u'current', u'description': u'indiates if this is current snapshot'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}], u'description': u'List virtual machine snapshot by conditions'}, u'ldapconfigurations': {u'name': u'listLdapConfigurations', u'related': [u'addLdapConfiguration', u'deleteLdapConfiguration'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'hostname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'port', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Port'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'hostname', u'description': u'hostname'}, {u'type': u'int', u'name': u'port', u'description': u'port'}], u'description': u'Lists all LDAP configurations'}, u'capabilities': {u'name': u'listCapabilities', u'related': [], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'userpublictemplateenabled', u'description': u'true if user and domain admins can set templates to be shared, false otherwise'}, {u'type': u'boolean', u'name': u'kvmsnapshotenabled', u'description': u'true if snapshot is supported for KVM host, false otherwise'}, {u'type': u'integer', u'name': u'apilimitinterval', u'description': u'time interval (in seconds) to reset api count'}, {u'type': u'long', u'name': u'customdiskofferingmaxsize', u'description': u'maximum size that can be specified when create disk from disk offering with custom size'}, {u'type': u'long', u'name': u'customdiskofferingminsize', u'description': u'minimum size that can be specified when create disk from disk offering with custom size'}, {u'type': u'boolean', u'name': u'allowusercreateprojects', u'description': u'true if regular user is allowed to create projects'}, {u'type': u'boolean', u'name': u'projectinviterequired', u'description': u'If invitation confirmation is required when add account to project'}, {u'type': u'string', u'name': u'cloudstackversion', u'description': u'version of the cloud stack'}, {u'type': u'integer', u'name': u'apilimitmax', u'description': u'Max allowed number of api requests within the specified interval'}, {u'type': u'boolean', u'name': u'securitygroupsenabled', u'description': u'true if security groups support is enabled, false otherwise'}, {u'type': u'string', u'name': u'supportELB', u'description': u'true if region supports elastic load balancer on basic zones'}, {u'type': u'boolean', u'name': u'regionsecondaryenabled', u'description': u'true if region wide secondary is enabled, false otherwise'}], u'description': u'Lists capabilities'}, u'storagetags': {u'name': u'listStorageTags', u'related': [], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'poolid', u'description': u'the pool ID of the storage tag'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage tag'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the storage tag'}], u'description': u'Lists storage tags'}, u'clusters': {u'name': u'listClusters', u'related': [u'updateCluster'], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'lists clusters by Zone ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'managedstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'whether this cluster is managed by cloudstack'}, {u'name': u'showcapacities', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'flag to display the capacity of the clusters'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists clusters by hypervisor type'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'lists clusters by Pod ID'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists clusters by allocation state'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists clusters by the cluster name'}, {u'name': u'clustertype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists clusters by cluster type'}, {u'name': u'id', u'required': False, u'related': [u'updateCluster', u'listClusters'], u'length': 255, u'type': u'uuid', u'description': u'lists clusters by the cluster ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the cluster'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'type': u'string', u'name': u'name', u'description': u'the cluster name'}, {u'type': u'string', u'name': u'memoryovercommitratio', u'description': u'The memory overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the type of the cluster'}, {u'description': u'the capacity of the Cluster', u'type': u'list', u'response': [{u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the cluster'}, {u'type': u'string', u'name': u'hypervisortype', u'description': u'the hypervisor type of the cluster'}, {u'type': u'string', u'name': u'managedstate', u'description': u'whether this cluster is managed by cloudstack'}, {u'type': u'string', u'name': u'cpuovercommitratio', u'description': u'The cpu overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the cluster'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the cluster'}, {u'type': u'string', u'name': u'id', u'description': u'the cluster ID'}], u'description': u'Lists clusters.'}, u'resourcelimits': {u'name': u'listResourceLimits', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'resourcetype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Type of resource to update. Values are 0, 1, 2, 3, and 4.0 - Instance. Number of instances a user can create. 1 - IP. Number of public IP addresses an account can own. 2 - Volume. Number of disk volumes an account can own.3 - Snapshot. Number of snapshots an account can own.4 - Template. Number of templates an account can register/create.5 - Project. Number of projects an account can own.6 - Network. Number of networks an account can own.7 - VPC. Number of VPC an account can own.8 - CPU. Number of CPU an account can allocate for his resources.9 - Memory. Amount of RAM an account can allocate for his resources.10 - Primary Storage. Amount of Primary storage an account can allocate for his resoruces.11 - Secondary Storage. Amount of Secondary storage an account can allocate for his resources.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Lists resource limits by ID.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type. Values include 0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11. See the resourceType parameter for more information on these values.'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the resource limit'}, {u'type': u'long', u'name': u'max', u'description': u'the maximum number of the resource. A -1 means the resource currently has no limit.'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the resource limit'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the resource limit'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the resource limit'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the resource limit'}], u'description': u'Lists resource limits.'}, u'firewallrules': {u'name': u'listFirewallRules', u'related': [u'createFirewallRule', u'listEgressFirewallRules', u'updateFirewallRule'], u'isasync': False, u'params': [{u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list firewall rules for ceratin network'}, {u'name': u'ipaddressid', u'required': False, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the id of IP address of the firwall services'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'Lists rule with the specified ID.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}], u'description': u'Lists all firewall rules for an IP address.'}, u'dedicatedzones': {u'name': u'listDedicatedZones', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the zone'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account associated with the zone. Must be used with domainId.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'affinitygroupid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list dedicated zones by affinity group'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the Zone'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account Id to which the Zone is dedicated'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Name of the Zone'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID to which the Zone is dedicated'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the zone'}], u'description': u'List dedicated zones.'}, u'supportednetworkservices': {u'name': u'listSupportedNetworkServices', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'service', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'network service name to list providers and capabilities of'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'provider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'network service provider name'}], u'requiredparams': [], u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'description': u'Lists all network services provided by CloudStack or for the given Provider.'}, u'loadbalancerrules': {u'name': u'listLoadBalancerRules', u'related': [u'createLoadBalancerRule'], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'publicipid', u'required': False, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the public IP address id of the load balancer rule '}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the load balancer rule'}, {u'name': u'id', u'required': False, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine of the load balancer rule'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the availability zone ID'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list by network id the rule belongs to'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}], u'description': u'Lists load balancer rules.'}, u'autoscalepolicies': {u'name': u'listAutoScalePolicies', u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy'], u'isasync': False, u'params': [{u'name': u'vmgroupid', u'required': False, u'related': [u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup', u'createAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale vm group'}, {u'name': u'conditionid', u'required': False, u'related': [u'listConditions'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the condition of the policy'}, {u'name': u'action', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the action to be executed if all the conditions evaluate to true for the specified duration.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy', u'listAutoScalePolicies'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale policy'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'action', u'description': u'the action to be executed if all the conditions evaluate to true for the specified duration.'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the autoscale policy'}, {u'type': u'integer', u'name': u'quiettime', u'description': u'the cool down period for which the policy should not be evaluated after the action has been taken'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id autoscale policy'}, {u'type': u'list', u'name': u'conditions', u'description': u'the list of IDs of the conditions that are being evaluated on every interval'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the autoscale policy'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the autoscale policy'}, {u'type': u'integer', u'name': u'duration', u'description': u'the duration for which the conditions have to be true before action is taken'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale policy ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the autoscale policy'}], u'description': u'Lists autoscale policies.'}, u'niciranvpdevices': {u'name': u'listNiciraNvpDevices', u'related': [u'addNiciraNvpDevice'], u'isasync': False, u'params': [{u'name': u'nvpdeviceid', u'required': False, u'related': [u'listNiciraNvpDevices', u'addNiciraNvpDevice'], u'length': 255, u'type': u'uuid', u'description': u'nicira nvp device ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'l3gatewayserviceuuid', u'description': u'this L3 gateway service Uuid'}, {u'type': u'string', u'name': u'niciradevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'hostname', u'description': u'the controller Ip address'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this Nirica Nvp belongs to'}, {u'type': u'string', u'name': u'nvpdeviceid', u'description': u'device id of the Nicire Nvp'}, {u'type': u'string', u'name': u'transportzoneuuid', u'description': u'the transport zone Uuid'}], u'description': u'Lists Nicira NVP devices'}, u'f5loadbalancernetworks': {u'name': u'listF5LoadBalancerNetworks', u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'lbdeviceid', u'required': True, u'related': [u'addF5LoadBalancer'], u'length': 255, u'type': u'uuid', u'description': u'f5 load balancer device ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}], u'description': u'lists network that are using a F5 load balancer device'}, u'templatepermissions': {u'name': u'listTemplatePermissions', u'related': [u'listIsoPermissions', u'listIsoPermissions', u'listTemplatePermissions'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIsoPermissions', u'listIsoPermissions', u'listTemplatePermissions', u'listTemplatePermissions'], u'length': 255, u'type': u'uuid', u'description': u'the template ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'list', u'name': u'account', u'description': u'the list of accounts the template is available for'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'list', u'name': u'projectids', u'description': u'the list of projects the template is available for'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}], u'description': u'List template visibility and all accounts that have permissions to view this template.'}, u'projects': {u'name': u'listProjects', u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list projects by state'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list projects by display text'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list projects by project ID'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list projects by name'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List projects by tags (key/value pairs)'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}], u'description': u'Lists projects and provides detailed information for listed projects'}, u'systemvms': {u'name': u'listSystemVms', u'related': [u'scaleSystemVm', u'rebootSystemVm'], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'scaleSystemVm', u'listSystemVms', u'rebootSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the system VM'}, {u'name': u'systemvmtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the system VM type. Possible types are "consoleproxy" and "secondarystoragevm".'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the system VM'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the state of the system VM'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the system VM'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID of the system VM'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'the host ID of the system VM'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'storageid', u'required': False, u'related': [u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u"the storage ID where vm's volumes belong to"}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}], u'description': u'List system virtual machines.'}, u'portforwardingrules': {u'name': u'listPortForwardingRules', u'related': [u'listIpForwardingRules', u'createPortForwardingRule'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'networkid', u'required': False, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list port forwarding rules for ceratin network'}, {u'name': u'ipaddressid', u'required': False, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the id of IP address of the port forwarding services'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'Lists rule with the specified ID.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the port forwarding rule'}, {u'type': u'string', u'name': u'publicport', u'description': u"the starting port of port forwarding rule's public port range"}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'the VM display name for the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the VM ID for the port forwarding rule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the port forwarding rule'}, {u'type': u'string', u'name': u'vmguestip', u'description': u'the vm ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'privateport', u'description': u"the starting port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'publicendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'the VM name for the port forwarding rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the port forwarding rule belongs to'}, {u'type': u'string', u'name': u'privateendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is firewall for display to the regular user'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the port forwarding rule'}], u'description': u'Lists all port forwarding rules for an IP address.'}, u'bigswitchvnsdevices': {u'name': u'listBigSwitchVnsDevices', u'related': [], u'isasync': False, u'params': [{u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'vnsdeviceid', u'required': False, u'related': [u'listBigSwitchVnsDevices'], u'length': 255, u'type': u'uuid', u'description': u'bigswitch vns device ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this BigSwitch Vns belongs to'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'bigswitchdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'vnsdeviceid', u'description': u'device id of the BigSwitch Vns'}, {u'type': u'string', u'name': u'hostname', u'description': u'the controller Ip address'}], u'description': u'Lists BigSwitch Vns devices'}, u'networkacllists': {u'name': u'listNetworkACLLists', u'related': [u'createNetworkACLList'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'id', u'required': False, u'related': [u'listNetworkACLLists', u'createNetworkACLList'], u'length': 255, u'type': u'uuid', u'description': u'Lists network ACL with the specified ID.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'networkid', u'required': False, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list network ACLs by network Id'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'list network ACLs by Vpc Id'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network ACLs by specified name'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the Name of the ACL'}, {u'type': u'string', u'name': u'description', u'description': u'Description of the ACL'}, {u'type': u'string', u'name': u'vpcid', u'description': u'Id of the VPC this ACL is associated with'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ACL'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is ACL for display to the regular user'}], u'description': u'Lists all network ACLs'}, u'storageproviders': {u'name': u'listStorageProviders', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'type', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the type of storage provider: either primary or image'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'type'], u'response': [{u'type': u'string', u'name': u'type', u'description': u'the type of the storage provider: primary or image provider'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage provider'}], u'description': u'Lists storage providers.'}, u'vpngateways': {u'name': u'listVpnGateways', u'related': [u'createVpnGateway', u'updateVpnGateway'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'id of vpc'}, {u'name': u'id', u'required': False, u'related': [u'createVpnGateway', u'listVpnGateways', u'updateVpnGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of the vpn gateway'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn gateway for display to the regular user'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'string', u'name': u'vpcid', u'description': u'the vpc id of this gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}], u'description': u'Lists site 2 site vpn gateways'}, u'events': {u'name': u'listEvents', u'related': [], u'isasync': False, u'params': [{u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the event type (see event types)'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'duration', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the duration of the event'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'enddate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'the end date range of the list you want to retrieve (use format "yyyy-MM-dd" or the new format "yyyy-MM-dd HH:mm:ss")'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'level', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the event level (INFO, WARN, ERROR)'}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'the start date range of the list you want to retrieve (use format "yyyy-MM-dd" or the new format "yyyy-MM-dd HH:mm:ss")'}, {u'name': u'id', u'required': False, u'related': [u'listEvents'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the event'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'entrytime', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the time the event was entered'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'parentid', u'description': u'whether the event is parented'}, {u'type': u'string', u'name': u'username', u'description': u"the name of the user who performed the action (can be different from the account if an admin is performing an action for a user, e.g. starting/stopping a user's virtual machine)"}, {u'type': u'date', u'name': u'created', u'description': u'the date the event was created'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the event'}, {u'type': u'string', u'name': u'domainid', u'description': u"the id of the account's domain"}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'level', u'description': u'the event level (INFO, WARN, ERROR)'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the event (see event types)'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the event'}, {u'type': u'string', u'name': u'domain', u'description': u"the name of the account's domain"}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'account', u'description': u'the account name for the account that owns the object being acted on in the event (e.g. the owner of the virtual machine, ip address, or security group)'}, {u'type': u'string', u'name': u'description', u'description': u'a brief description of the event'}], u'description': u'A command to list events.'}, u'hosttags': {u'name': u'listHostTags', u'related': [], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the host tag'}, {u'type': u'long', u'name': u'hostid', u'description': u'the host ID of the host tag'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host tag'}], u'description': u'Lists host tags'}, u'hosts': {u'name': u'listHosts', u'related': [], u'isasync': False, u'params': [{u'name': u'resourcestate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list hosts by resource state. Resource state represents current state determined by admin of host, valule can be one of [Enabled, Disabled, Unmanaged, PrepareForMaintenance, ErrorInMaintenance, Maintenance, Error]'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'hahost', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, list only hosts dedicated to HA'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the host type'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'lists hosts in the same cluster as this VM and flag hosts with enough CPU/RAm to host this VM'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the state of the host'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the host'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'comma separated list of host details requested, value can be a list of [ min, all, capacity, events, stats]'}, {u'name': u'id', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'the id of the host'}, {u'name': u'clusterid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'lists hosts existing in particular cluster'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of host: XenServer,KVM,VMware,Hyperv,BareMetal,Simulator'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the host'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the host'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}, {u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}], u'name': u'vgpu'}], u'name': u'gpugroup'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}], u'description': u'Lists hosts.'}, u'hypervisorcapabilities': {u'name': u'listHypervisorCapabilities', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the hypervisor for which to restrict the search'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [u'listHypervisorCapabilities'], u'length': 255, u'type': u'uuid', u'description': u'ID of the hypervisor capability'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the hypervisor capabilities row'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'integer', u'name': u'maxhostspercluster', u'description': u'the maximum number of Hosts per cluster for this hypervisor'}, {u'type': u'boolean', u'name': u'securitygroupenabled', u'description': u'true if security group is supported'}, {u'type': u'boolean', u'name': u'storagemotionenabled', u'description': u'true if storage motion is supported'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the hypervisor type'}, {u'type': u'integer', u'name': u'maxdatavolumeslimit', u'description': u'the maximum number of Data Volumes that can be attached for this hypervisor'}, {u'type': u'long', u'name': u'maxguestslimit', u'description': u'the maximum number of guest vms recommended for this hypervisor'}], u'description': u'Lists all hypervisor capabilities.'}, u'deploymentplanners': {u'name': u'listDeploymentPlanners', u'related': [], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'Deployment Planner name'}], u'description': u'Lists all DeploymentPlanners available.'}, u'configurations': {u'name': u'listConfigurations', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'storageid', u'required': False, u'related': [u'createStoragePool', u'listStoragePools', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Storage pool to update the parameter value for corresponding storage pool'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists configuration by name'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone to update the parameter value for corresponding zone'}, {u'name': u'category', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists configurations by category'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Cluster to update the parameter value for corresponding cluster'}, {u'name': u'accountid', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Account to update the parameter value for corresponding account'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the configuration'}, {u'type': u'long', u'name': u'id', u'description': u'the value of the configuration'}, {u'type': u'string', u'name': u'category', u'description': u'the category of the configuration'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the configuration'}, {u'type': u'string', u'name': u'value', u'description': u'the value of the configuration'}, {u'type': u'string', u'name': u'scope', u'description': u'scope(zone/cluster/pool/account) of the parameter that needs to be updated'}], u'description': u'Lists all configurations.'}, u'paloaltofirewalls': {u'name': u'listPaloAltoFirewalls', u'related': [u'configurePaloAltoFirewall'], u'isasync': False, u'params': [{u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'fwdeviceid', u'required': False, u'related': [u'listPaloAltoFirewalls', u'configurePaloAltoFirewall'], u'length': 255, u'type': u'uuid', u'description': u'Palo Alto firewall device ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the Palo Alto firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this Palo Alto firewall belongs to'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}], u'description': u'lists Palo Alto firewall devices in a physical network'}, u'usagerecords': {u'name': u'listUsageRecords', u'related': [], u'isasync': False, u'params': [{u'name': u'usageid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List usage records for the specified usage UUID. Can be used only together with TYPE parameter.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'List usage records for the specified domain.'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'List usage records for the specified usage type'}, {u'name': u'startdate', u'required': True, u'related': [], u'length': 255, u'type': u'date', u'description': u'Start date range for usage record query. Use yyyy-MM-dd as the date format, e.g. startDate=2009-06-01.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'enddate', u'required': True, u'related': [], u'length': 255, u'type': u'date', u'description': u'End date range for usage record query. Use yyyy-MM-dd as the date format, e.g. startDate=2009-06-03.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'List usage records for specified project'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List usage records for the specified user.'}, {u'name': u'accountid', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'updateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'List usage records for the specified account'}], u'requiredparams': [u'startdate', u'enddate'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the resource'}, {u'type': u'string', u'name': u'description', u'description': u'description of the usage record'}, {u'type': u'string', u'name': u'offeringid', u'description': u'offering ID'}, {u'type': u'string', u'name': u'type', u'description': u'resource type'}, {u'type': u'string', u'name': u'startdate', u'description': u'start date of the usage record'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'True if the IPAddress is system IP - allocated during vm deploy or lb rule create'}, {u'type': u'string', u'name': u'accountid', u'description': u'the user account Id'}, {u'type': u'string', u'name': u'rawusage', u'description': u'raw usage in hours'}, {u'type': u'string', u'name': u'usageid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'enddate', u'description': u'end date of the usage record'}, {u'type': u'boolean', u'name': u'issourcenat', u'description': u'True if the IPAddress is source NAT'}, {u'type': u'string', u'name': u'name', u'description': u'virtual machine name'}, {u'type': u'long', u'name': u'size', u'description': u'resource size'}, {u'type': u'string', u'name': u'templateid', u'description': u'template ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain the resource is associated with'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID'}, {u'type': u'long', u'name': u'cpunumber', u'description': u'number of cpu of resource'}, {u'type': u'integer', u'name': u'usagetype', u'description': u'usage type ID'}, {u'type': u'string', u'name': u'usage', u'description': u'usage in hours'}, {u'type': u'string', u'name': u'account', u'description': u'the user account name'}, {u'type': u'long', u'name': u'virtualsize', u'description': u'virtual size of resource'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'True if the resource is default'}, {u'type': u'string', u'name': u'networkid', u'description': u'id of the network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'virtual machine ID'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the resource'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'speed of each cpu of resource'}, {u'type': u'long', u'name': u'memory', u'description': u'memory allocated for the resource'}], u'description': u'Lists usage records for accounts'}, u'storagepools': {u'name': u'listStoragePools', u'related': [u'findStoragePoolsForMigration'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the storage pool'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the storage pool'}, {u'name': u'scope', u'required': False, u'related': [u'listStoragePools', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'string', u'description': u'the ID of the storage pool'}, {u'name': u'id', u'required': False, u'related': [u'listStoragePools', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the storage pool'}, {u'name': u'path', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the storage pool path'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the IP address for the storage pool'}, {u'name': u'clusterid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list storage pools belongig to the specific cluster'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the storage pool'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}, {u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}], u'description': u'Lists storage pools.'}, u'ucsblades': {u'name': u'listUcsBlades', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'ucsmanagerid', u'required': True, u'related': [u'addUcsManager'], u'length': 255, u'type': u'uuid', u'description': u'ucs manager id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'ucsmanagerid'], u'response': [{u'type': u'string', u'name': u'bladedn', u'description': u'ucs blade dn'}, {u'type': u'string', u'name': u'hostid', u'description': u'cloudstack host id this blade associates to'}, {u'type': u'string', u'name': u'profiledn', u'description': u'associated ucs profile dn'}, {u'type': u'string', u'name': u'id', u'description': u'ucs blade id'}, {u'type': u'string', u'name': u'ucsmanagerid', u'description': u'ucs manager id'}], u'description': u'List ucs blades'}, u'snapshots': {u'name': u'listSnapshots', u'related': [u'createSnapshot', u'revertSnapshot'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'volumeid', u'required': False, u'related': [u'listVolumes', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'intervaltype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'valid values are HOURLY, DAILY, WEEKLY, and MONTHLY.'}, {u'name': u'id', u'required': False, u'related': [u'createSnapshot', u'listSnapshots', u'revertSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'lists snapshot by snapshot ID'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'snapshottype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'valid values are MANUAL or RECURRING.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists snapshot by snapshot name'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'list snapshots by zone id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the snapshot'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the snapshot. BackedUp means that snapshot is ready to be used; Creating - the snapshot is being allocated on the primary storage; BackingUp - the snapshot is being backed up on secondary storage'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the snapshot'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the snapshot'}, {u'type': u'string', u'name': u'volumetype', u'description': u'type of the disk volume'}, {u'type': u'string', u'name': u'zoneid', u'description': u'id of the availability zone'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the snapshot'}, {u'type': u'string', u'name': u'volumename', u'description': u'name of the disk volume'}, {u'type': u'boolean', u'name': u'revertable', u'description': u'indicates whether the underlying storage supports reverting the volume to this snapshot'}, {u'type': u'string', u'name': u'name', u'description': u'name of the snapshot'}, {u'type': u'string', u'name': u'snapshottype', u'description': u'the type of the snapshot'}, {u'type': u'date', u'name': u'created', u'description': u'  the date the snapshot was created'}, {u'description': u'the list of resource tags associated with snapshot', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'intervaltype', u'description': u'valid types are hourly, daily, weekly, monthy, template, and none.'}, {u'type': u'string', u'name': u'domainid', u'description': u"the domain ID of the snapshot's account"}, {u'type': u'string', u'name': u'volumeid', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'domain', u'description': u"the domain name of the snapshot's account"}], u'description': u'Lists all available snapshots for the account.'}, u'vmwaredcs': {u'name': u'listVmwareDcs', u'related': [], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'Id of the CloudStack zone.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'zoneid'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'The VMware Datacenter name'}, {u'type': u'string', u'name': u'id', u'description': u'The VMware Datacenter ID'}, {u'type': u'long', u'name': u'zoneid', u'description': u'the Zone ID associated with this VMware Datacenter'}, {u'type': u'string', u'name': u'vcenter', u'description': u'The VMware vCenter name/ip'}], u'description': u'Retrieves VMware DC(s) associated with a zone.'}, u'dedicatedguestvlanranges': {u'name': u'listDedicatedGuestVlanRanges', u'related': [u'dedicateGuestVlanRange'], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account with which the guest VLAN range is associated. Must be used with the domainId parameter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID with which the guest VLAN range is associated.  If used with the account parameter, returns all guest VLAN ranges for that account in the specified domain.'}, {u'name': u'guestvlanrange', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the dedicated guest vlan range'}, {u'name': u'id', u'required': False, u'related': [u'listDedicatedGuestVlanRanges', u'dedicateGuestVlanRange'], u'length': 255, u'type': u'uuid', u'description': u'list dedicated guest vlan ranges by id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'zone of the guest VLAN range'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'physical network id of the guest VLAN range'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'project who will own the guest VLAN range'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'zoneid', u'description': u'the zone of the guest vlan range'}, {u'type': u'long', u'name': u'physicalnetworkid', u'description': u'the physical network of the guest vlan range'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the guest vlan range'}, {u'type': u'string', u'name': u'guestvlanrange', u'description': u'the guest VLAN range'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the guest VLAN range'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the guest VLAN range'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the guest VLAN range'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the guest VLAN range'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the guest vlan range'}], u'description': u'Lists dedicated guest vlan ranges'}, u'serviceofferings': {u'name': u'listServiceOfferings', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'ID of the service offering'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine. Pass this in if you want to see the available service offering that a virtual machine can be changed to.'}, {u'name': u'systemvmtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the system VM type. Possible types are "consoleproxy", "secondarystoragevm" or "domainrouter".'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the service offering'}, {u'name': u'issystem', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'is this a system vm offering'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the service offering'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory in MB'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'map', u'name': u'serviceofferingdetails', u'description': u'additional key/value details tied with this service offering'}, {u'type': u'boolean', u'name': u'offerha', u'description': u'the ha support in the service offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the service offering.'}, {u'type': u'boolean', u'name': u'defaultuse', u'description': u'is this a  default system vm offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the service offering'}, {u'type': u'boolean', u'name': u'isvolatile', u'description': u'true if the vm needs to be volatile, i.e., on every reboot of vm from API root disk is discarded and creates a new root disk'}, {u'type': u'string', u'name': u'hosttags', u'description': u'the host tag for the service offering'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'is true if the offering is customized'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'is this a system vm offering'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}, {u'type': u'string', u'name': u'deploymentplanner', u'description': u'deployment strategy used to deploy VM.'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'is this a the systemvm type for system vm offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the service offering'}, {u'type': u'date', u'name': u'created', u'description': u'the date this service offering was created'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the service offering'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the service offering'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the service offering'}, {u'type': u'boolean', u'name': u'limitcpuuse', u'description': u'restrict the CPU usage to committed service offering'}, {u'type': u'string', u'name': u'domain', u'description': u'Domain name for the offering'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of CPU'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the clock rate CPU speed in Mhz'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the service offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this service offering'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the service offering'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the service offering'}], u'description': u'Lists all available service offerings.'}, u'ciscoasa1000vresources': {u'name': u'listCiscoAsa1000vResources', u'related': [u'addCiscoAsa1000vResource'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'hostname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname or ip address of the Cisco ASA 1000v appliance.'}, {u'name': u'resourceid', u'required': False, u'related': [u'listCiscoAsa1000vResources', u'addCiscoAsa1000vResource'], u'length': 255, u'type': u'uuid', u'description': u'Cisco ASA 1000v resource ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}], u'requiredparams': [], u'response': [{}, {}, {}, {}, {}], u'description': u'Lists Cisco ASA 1000v appliances'}, u'brocadevcsdevices': {u'name': u'listBrocadeVcsDevices', u'related': [u'addBrocadeVcsDevice'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'vcsdeviceid', u'required': False, u'related': [u'listBrocadeVcsDevices', u'addBrocadeVcsDevice'], u'length': 255, u'type': u'uuid', u'description': u'Brocade VCS switch ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'hostname', u'description': u'the principal switch Ip address'}, {u'type': u'string', u'name': u'vcsdeviceid', u'description': u'device id of the Brocade Vcs'}, {u'type': u'string', u'name': u'brocadedevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical Network to which this Brocade VCS belongs to'}], u'description': u'Lists Brocade VCS Switches'}, u'affinitygrouptypes': {u'name': u'listAffinityGroupTypes', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}], u'description': u'Lists affinity group types available'}, u'publicipaddresses': {u'name': u'listPublicIpAddresses', u'related': [u'updateIpAddress', u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'isasync': False, u'params': [{u'name': u'associatednetworkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'lists all public IP addresses associated to the network specified'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'lists all public IP addresses by physical network id'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'lists all public IP addresses by Zone ID'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'vlanid', u'required': False, u'related': [u'createVlanIpRange', u'listVlanIpRanges', u'dedicatePublicIpRange'], u'length': 255, u'type': u'uuid', u'description': u'lists all public IP addresses by VLAN ID'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'List ips belonging to the VPC'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists all public IP addresses by state'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isstaticnat', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list only static nat ip addresses'}, {u'name': u'forvirtualnetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'the virtual network for the IP address'}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists the specified IP address'}, {u'name': u'id', u'required': False, u'related': [u'updateIpAddress', u'listPublicIpAddresses', u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'lists ip address by id'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'forloadbalancing', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list only ips used for load balancing'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'allocatedonly', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'limits search results to allocated public IP addresses'}, {u'name': u'issourcenat', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list only source nat ip addresses'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'description': u'the list of resource tags associated with ip address', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'isportable', u'description': u'is public IP portable across the zones'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if this ip is system ip (was allocated as a part of deployVm or createLbRule)'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the public IP address is associated with'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'vmipaddress', u'description': u'virutal machine (dnat) ip address (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'associatednetworkid', u'description': u'the ID of the Network associated with the IP address'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the IP address'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'virutal machine display name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the public IP address was acquired'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain the public IP address is associated with'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'vlanname', u'description': u'the VLAN associated with the IP address'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'virutal machine id the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'purpose', u'description': u'purpose of the IP address. In Acton this value is not null for Ips with isSystem=true, and can have either StaticNat or LB value'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'associatednetworkname', u'description': u'the name of the Network associated with the IP address'}, {u'type': u'boolean', u'name': u'issourcenat', u'description': u'true if the IP address is a source nat address, false otherwise'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is public ip for display to the regular user'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'type': u'string', u'name': u'id', u'description': u'public IP address id'}, {u'type': u'string', u'name': u'account', u'description': u'the account the public IP address is associated with'}, {u'type': u'string', u'name': u'vlanid', u'description': u'the ID of the VLAN associated with the IP address. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'virutal machine name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'boolean', u'name': u'isstaticnat', u'description': u'true if this ip is for static nat, false otherwise'}], u'description': u'Lists all public ip addresses'}, u'networkserviceproviders': {u'name': u'listNetworkServiceProviders', u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list providers by state'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list providers by name'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'description': u'Lists network serviceproviders for a given physical network.'}, u'capacity': {u'name': u'listCapacity', u'related': [], u'isasync': False, u'params': [{u'name': u'fetchlatest', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'recalculate capacities and fetch the latest'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'lists capacity by type* CAPACITY_TYPE_MEMORY = 0* CAPACITY_TYPE_CPU = 1* CAPACITY_TYPE_STORAGE = 2* CAPACITY_TYPE_STORAGE_ALLOCATED = 3* CAPACITY_TYPE_VIRTUAL_NETWORK_PUBLIC_IP = 4* CAPACITY_TYPE_PRIVATE_IP = 5* CAPACITY_TYPE_SECONDARY_STORAGE = 6* CAPACITY_TYPE_VLAN = 7* CAPACITY_TYPE_DIRECT_ATTACHED_PUBLIC_IP = 8* CAPACITY_TYPE_LOCAL_STORAGE = 9.'}, {u'name': u'sortby', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Sort the results. Available values: Usage'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'lists capacity by the Zone ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'lists capacity by the Cluster ID'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'lists capacity by the Pod ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}], u'description': u'Lists all the system wide capacities.'}, u'diskofferings': {u'name': u'listDiskOfferings', u'related': [u'createDiskOffering'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain of the disk offering.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the disk offering'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listDiskOfferings', u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'ID of the disk offering'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk offering'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the disk offering'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this disk offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the disk offering.'}, {u'type': u'long', u'name': u'disksize', u'description': u'the size of the disk offering in GB'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the disk offering'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'true if disk offering uses custom size, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name this disk offering belongs to. Ignore this information as it is not currently applicable.'}, {u'type': u'date', u'name': u'created', u'description': u'the date this disk offering was created'}, {u'type': u'boolean', u'name': u'displayoffering', u'description': u'whether to display the offering to the end user or not.'}, {u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk offering'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID this disk offering belongs to. Ignore this information as it is not currently applicable.'}, {u'type': u'string', u'name': u'id', u'description': u'unique ID of the disk offering'}, {u'type': u'string', u'name': u'cacheMode', u'description': u'the cache mode to use for this disk offering. none, writeback or writethrough'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}], u'description': u'Lists all available disk offerings.'}, u'loadbalancerruleinstances': {u'name': u'listLoadBalancerRuleInstances', u'related': [u'listLoadBalancerRuleInstances'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'applied', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if listing all virtual machines currently applied to the load balancer rule; default is true'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'lbvmips', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if lb rule vm ip information to be included; default is false'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'id'], u'response': [{u'type': u'list', u'name': u'lbvmipaddresses', u'description': u'IP addresses of the vm set of lb rule'}, {u'type': u'uservmresponse', u'name': u'loadbalancerruleinstance', u'description': u'the user vm set for lb rule'}], u'description': u'List all virtual machine instances that are assigned to a load balancer rule.'}, u'lbstickinesspolicies': {u'name': u'listLBStickinessPolicies', u'related': [u'createLBStickinessPolicy'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'createLBStickinessPolicy', u'listLBStickinessPolicies'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer stickiness policy'}, {u'name': u'lbruleid', u'required': False, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Stickiness policy'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the Stickiness policy'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Stickiness policy'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the Stickiness policy belongs to'}, {u'description': u'the list of stickinesspolicies', u'type': u'list', u'response': [{u'type': u'map', u'name': u'params', u'description': u'the params of the policy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB Stickiness policy ID'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}, {u'type': u'string', u'name': u'methodname', u'description': u'the method name of the Stickiness policy'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}], u'name': u'stickinesspolicy'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}], u'description': u'Lists LBStickiness policies.'}, u'srxfirewallnetworks': {u'name': u'listSrxFirewallNetworks', u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'lbdeviceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'netscaler load balancer device ID'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}], u'description': u'lists network that are using SRX firewall device'}, u'networks': {u'name': u'listNetworks', u'related': [u'listBrocadeVcsDeviceNetworks', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'specifyipranges', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if need to list only networks which support specifying ip ranges'}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of the traffic'}, {u'name': u'supportedservices', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list networks supporting certain services'}, {u'name': u'displaynetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list networks by id'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the type of the network. Supported values are: Isolated and Shared'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'issystem', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network is system, false otherwise'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the network'}, {u'name': u'acltype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list networks by ACL (access control list) type. Supported values are Account and Domain'}, {u'name': u'forvpc', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'the network belongs to vpc'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'list networks by physical network id'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'canusefordeploy', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list networks available for vm deployment'}, {u'name': u'restartrequired', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list networks by restartRequired'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'List networks by VPC'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}], u'description': u'Lists all available networks.'}, u'brocadevcsdevicenetworks': {u'name': u'listBrocadeVcsDeviceNetworks', u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'vcsdeviceid', u'required': True, u'related': [u'listBrocadeVcsDevices', u'addBrocadeVcsDevice'], u'length': 255, u'type': u'uuid', u'description': u'brocade vcs switch ID'}], u'requiredparams': [u'vcsdeviceid'], u'response': [{u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}], u'description': u'lists network that are using a brocade vcs switch'}, u'securitygroups': {u'name': u'listSecurityGroups', u'related': [], u'isasync': False, u'params': [{u'name': u'securitygroupname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists security groups by name'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'lists security groups by virtual machine id'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'id', u'required': False, u'related': [u'listSecurityGroups'], u'length': 255, u'type': u'uuid', u'description': u'list the security group by the id provided'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}], u'description': u'Lists security groups'}, u'ovselements': {u'name': u'listOvsElements', u'related': [u'configureOvsElement'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'enabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list network offerings by enabled state'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'configureOvsElement', u'listOvsElements'], u'length': 255, u'type': u'uuid', u'description': u'list ovs elements by id'}, {u'name': u'nspid', u'required': False, u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'list ovs elements by network service provider id'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the ovs'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the service provider'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the provider'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the provider'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the provider'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the provider'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}], u'description': u'Lists all available ovs elements.'}, u'baremetaldhcp': {u'name': u'listBaremetalDhcp', u'related': [u'addBaremetalDhcp'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'dhcpservertype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Type of DHCP device'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'DHCP server device ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this external dhcp device belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'device id of '}, {u'type': u'string', u'name': u'dhcpservertype', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'url', u'description': u'url'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}], u'description': u'list baremetal dhcp servers'}, u'conditions': {u'name': u'listConditions', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'policyid', u'required': False, u'related': [u'createAutoScalePolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the policy'}, {u'name': u'counterid', u'required': False, u'related': [u'createCounter'], u'length': 255, u'type': u'uuid', u'description': u'Counter-id of the condition.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listConditions'], u'length': 255, u'type': u'uuid', u'description': u'ID of the Condition.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'relationaloperator', u'description': u'Relational Operator to be used with threshold.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the Condition.'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the Condition'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of counter'}, {u'type': u'long', u'name': u'threshold', u'description': u'Threshold Value for the counter.'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the Condition.'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the Condition'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the Condition owner'}, {u'type': u'list', u'name': u'counter', u'description': u'Details of the Counter.'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner.'}], u'description': u'List Conditions for the specific user'}, u'swifts': {u'name': u'listSwifts', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'the id of the swift'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}], u'description': u'List Swift.'}, u'counters': {u'name': u'listCounters', u'related': [u'createCounter'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the counter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'createCounter', u'listCounters'], u'length': 255, u'type': u'uuid', u'description': u'ID of the Counter.'}, {u'name': u'source', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Source of the counter.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'zone id of counter'}, {u'type': u'string', u'name': u'value', u'description': u'Value in case of snmp or other specific counters.'}, {u'type': u'string', u'name': u'name', u'description': u'Name of the counter.'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the Counter'}, {u'type': u'string', u'name': u'source', u'description': u'Source of the counter.'}], u'description': u'List the counters'}, u'tags': {u'name': u'listTags', u'related': [u'listResourceDetails'], u'isasync': False, u'params': [{u'name': u'resourcetype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by resource type'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'value', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by value'}, {u'name': u'customer', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by customer name'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'resourceid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by resource id'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'key', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by key'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'description': u'List resource tag(s)'}, u'routers': {u'name': u'listRouters', u'related': [u'destroyRouter', u'changeServiceForRouter', u'startInternalLoadBalancerVM', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter', u'stopRouter'], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'suspendProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster', u'addCluster', u'listClusters'], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID of the router'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the state of the router'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'networkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'listNiciraNvpDeviceNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list by network id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the router'}, {u'name': u'id', u'required': False, u'related': [u'addNicToVirtualMachine', u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk router'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the router'}, {u'name': u'forvpc', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true is passed for this parameter, list only VPC routers'}, {u'name': u'version', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list virtual router elements by version'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID of the router'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID of the router'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'List networks by VPC'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}], u'description': u'List routers.'}, u'traffictypes': {u'name': u'listTrafficTypes', u'related': [u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}], u'requiredparams': [u'physicalnetworkid'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}], u'description': u'Lists traffic types of a given physical network.'}, u'projectinvitations': {u'name': u'listProjectInvitations', u'related': [], u'isasync': False, u'params': [{u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list invitations by state'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'activeonly', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, list only active invitations - having Pending state and ones that are not timed out yet'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list by project id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listProjectInvitations'], u'length': 255, u'type': u'uuid', u'description': u'list invitations by id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'email', u'description': u'the email the invitation was sent to'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the invitation'}, {u'type': u'string', u'name': u'project', u'description': u'the name of the project'}, {u'type': u'string', u'name': u'state', u'description': u'the invitation state'}, {u'type': u'string', u'name': u'projectid', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}], u'description': u'Lists project invitations and provides detailed information for listed invitations'}, u'isos': {u'name': u'listIsos', u'related': [u'listTemplates', u'listIsos', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list all isos by name'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the ISO is publicly available to all users, false otherwise.'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the hypervisor for which to restrict the search'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'showremoved', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'show removed ISOs as well'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'isready', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this ISO is ready to be deployed'}, {u'name': u'bootable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the ISO is bootable, false otherwise'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'id', u'required': False, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'list ISO by id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone'}, {u'name': u'isofilter', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'possible values are "featured", "self", "selfexecutable","sharedexecutable","executable", and "community". * featured : templates that have been marked as featured and public. * self : templates that have been registered or created by the calling user. * selfexecutable : same as self, but only returns templates that can be used to deploy a new VM. * sharedexecutable : templates ready to be deployed that have been granted to the calling user by another user. * executable : templates that are owned by the calling user, or public templates, that can be used to deploy a VM. * community : templates that have been marked as public but not featured. * all : all templates (only usable by admins).'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}], u'description': u'Lists all available ISO files.'}, u'users': {u'name': u'listUsers', u'related': [], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List user by the username'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'accounttype', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'List users by account type. Valid types include admin, domain-admin, read-only-admin, or user.'}, {u'name': u'id', u'required': False, u'related': [u'listUsers'], u'length': 255, u'type': u'uuid', u'description': u'List user by ID.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List users by state of the user account.'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}], u'description': u'Lists user accounts'}, u'sshkeypairs': {u'name': u'listSSHKeyPairs', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'A key pair name to look for'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'fingerprint', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'A public key fingerprint to look for'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'Name of the keypair'}, {u'type': u'string', u'name': u'fingerprint', u'description': u'Fingerprint of the public key'}], u'description': u'List registered keypairs'}, u'privategateways': {u'name': u'listPrivateGateways', u'related': [u'createPrivateGateway'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list gateways by vlan'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'list gateways by vpc'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list gateways by state'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'id', u'required': False, u'related': [u'createPrivateGateway', u'listPrivateGateways'], u'length': 255, u'type': u'uuid', u'description': u'list private gateway by id'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list gateways by ip address'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'state', u'description': u'State of the gateway, can be Creating, Ready, Deleting'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the private gateway'}, {u'type': u'string', u'name': u'netmask', u'description': u"the private gateway's netmask"}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the private gateway'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the private gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the private gateway'}, {u'type': u'string', u'name': u'ipaddress', u'description': u"the private gateway's ip address"}, {u'type': u'string', u'name': u'vlan', u'description': u'the network implementation uri for the private gateway'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the private gateway'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id set for private gateway'}, {u'type': u'boolean', u'name': u'sourcenatsupported', u'description': u'Souce Nat enable status'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the private gateway'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the private gateway belongs to'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the private gateaway belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the private gateway'}], u'description': u'List private gateways'}, u'internalloadbalancervms': {u'name': u'listInternalLoadBalancerVMs', u'related': [], u'isasync': False, u'params': [{u'name': u'hostid', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'the host ID of the Internal LB VM'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Internal LB VM'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'forvpc', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true is passed for this parameter, list only VPC Internal LB VMs'}, {u'name': u'id', u'required': False, u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Internal LB VM'}, {u'name': u'vpcid', u'required': False, u'related': [u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'List Internal LB VMs by VPC'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list by network id'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the state of the Internal LB VM'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID of the Internal LB VM'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the Internal LB VM'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}], u'description': u'List internal LB VMs.'}, u'dedicatedpods': {u'name': u'listDedicatedPods', u'related': [u'dedicatePod'], u'isasync': False, u'params': [{u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the pod'}, {u'name': u'affinitygroupid', u'required': False, u'related': [u'listAffinityGroups', u'createAffinityGroup'], u'length': 255, u'type': u'uuid', u'description': u'list dedicated pods by affinity group'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the pod'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account associated with the pod. Must be used with domainId.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the pod'}, {u'type': u'string', u'name': u'podname', u'description': u'the Name of the Pod'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account Id to which the Pod is dedicated'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'podid', u'description': u'the ID of the Pod'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID to which the Pod is dedicated'}], u'description': u'Lists dedicated pods.'}, u'dedicatedclusters': {u'name': u'listDedicatedClusters', u'related': [u'dedicateCluster'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account associated with the cluster. Must be used with domainId.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'affinitygroupid', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'uuid', u'description': u'list dedicated clusters by affinity group'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the cluster'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the cluster'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the cluster'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account ID of the cluster'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the cluster'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster'}], u'description': u'Lists dedicated clusters.'}, u'usagetypes': {u'name': u'listUsageTypes', u'related': [], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'usagetypeid', u'description': u'usage type'}, {u'type': u'string', u'name': u'description', u'description': u'description of usage type'}], u'description': u'List Usage Types'}, u'domainchildren': {u'name': u'listDomainChildren', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list children domains by name'}, {u'name': u'id', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'list children domain by parent domain ID.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'to return the entire tree, use the value "true". To return the first level children, use the value "false".'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'path', u'description': u'the path of the domain'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the domain'}, {u'type': u'boolean', u'name': u'haschild', u'description': u'whether the domain has one or more sub-domains'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'parentdomainname', u'description': u'the domain name of the parent domain'}, {u'type': u'integer', u'name': u'level', u'description': u'the level of the domain'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the domain'}, {u'type': u'string', u'name': u'parentdomainid', u'description': u'the domain ID of the parent domain'}], u'description': u'Lists all children domains belonging to a specified domain'}, u'domains': {u'name': u'listDomains', u'related': [u'listDomainChildren', u'updateDomain'], u'isasync': False, u'params': [{u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'List domain by domain ID.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'level', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'List domains by domain level.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List domain by domain name.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'path', u'description': u'the path of the domain'}, {u'type': u'string', u'name': u'parentdomainname', u'description': u'the domain name of the parent domain'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'boolean', u'name': u'haschild', u'description': u'whether the domain has one or more sub-domains'}, {u'type': u'integer', u'name': u'level', u'description': u'the level of the domain'}, {u'type': u'string', u'name': u'parentdomainid', u'description': u'the domain ID of the parent domain'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the domain'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the domain'}], u'description': u'Lists domains and provides detailed information for listed domains'}, u'networkisolationmethods': {u'name': u'listNetworkIsolationMethods', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'Network isolation method name'}], u'description': u'Lists supported methods of network isolation'}, u'netscalerloadbalancers': {u'name': u'listNetscalerLoadBalancers', u'related': [], u'isasync': False, u'params': [{u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'lbdeviceid', u'required': False, u'related': [u'listNetscalerLoadBalancers'], u'length': 255, u'type': u'uuid', u'description': u'netscaler load balancer device ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'list', u'name': u'podids', u'description': u"Used when NetScaler device is provider of EIP service. This parameter represents the list of pod's, for which there exists a policy based route on datacenter L3 router to route pod's subnet IP to a NetScaler device."}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the netscaler load balancer'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this netscaler device belongs to'}, {u'type': u'boolean', u'name': u'gslbprovider', u'description': u'true if NetScaler device is provisioned to be a GSLB service provider'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'gslbproviderpublicip', u'description': u'public IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'string', u'name': u'gslbproviderprivateip', u'description': u'private IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}, {u'type': u'boolean', u'name': u'isexclusivegslbprovider', u'description': u'true if NetScaler device is provisioned exclusively to be a GSLB service provider'}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}], u'description': u'lists netscaler load balancer devices'}, u'baremetalrct': {u'name': u'listBaremetalRct', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'url', u'description': u'url'}, {u'type': u'string', u'name': u'id', u'description': u'id of rct'}], u'description': u'list baremetal rack configuration'}, u's3s': {u'name': u'listS3s', u'related': [u'addSwift', u'listSecondaryStagingStores', u'addS3', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}], u'description': u'Lists S3s'}, u'hypervisors': {u'name': u'listHypervisors', u'related': [], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the zone id for listing hypervisors.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'Hypervisor name'}], u'description': u'List hypervisors'}, u'accounts': {u'name': u'listAccounts', u'related': [u'listAccounts', u'markDefaultZoneForAccount'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount'], u'length': 255, u'type': u'uuid', u'description': u'list account by account ID'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list account by account name'}, {u'name': u'iscleanuprequired', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list accounts by cleanuprequred attribute (values are true or false)'}, {u'name': u'accounttype', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'list accounts by account type. Valid account types are 1 (admin), 2 (domain-admin), and 0 (user).'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list accounts by state. Valid states are enabled, disabled, and locked.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}], u'name': u'user'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}], u'description': u'Lists accounts and provides detailed account information for listed accounts'}, u'networkdevice': {u'name': u'listNetworkDevice', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'networkdevicetype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Network device type, now supports ExternalDhcp, PxeServer, NetscalerMPXLoadBalancer, NetscalerVPXLoadBalancer, NetscalerSDXLoadBalancer, F5BigIpLoadBalancer, JuniperSRXFirewall, PaloAltoFirewall'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'networkdeviceparameterlist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'parameters for network device'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the network device'}], u'description': u'List network devices'}, u'vlanipranges': {u'name': u'listVlanIpRanges', u'related': [], u'isasync': False, u'params': [{u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'physical network id of the VLAN IP range'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the VLAN IP range'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'project who will own the VLAN'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ID or VID of the VLAN. Default is an "untagged" VLAN.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account with which the VLAN IP range is associated. Must be used with the domainId parameter.'}, {u'name': u'forvirtualnetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if VLAN is of Virtual type, false if Direct'}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'network id of the VLAN IP range'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the domain ID with which the VLAN IP range is associated.  If used with the account parameter, returns all VLAN IP ranges for that account in the specified domain.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID of the VLAN IP range'}, {u'name': u'id', u'required': False, u'related': [u'listVlanIpRanges'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the VLAN IP range'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'startipv6', u'description': u'the start ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'endipv6', u'description': u'the end ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the VLAN IP range'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the VLAN IP range'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the VLAN IP range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the VLAN IP range'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the VLAN IP range'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the VLAN IP range'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name for the VLAN IP range'}, {u'type': u'string', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vlan range'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the VLAN IP range'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vlan range'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the VLAN IP range'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the VLAN IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the VLAN IP range'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of vlan range'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the VLAN IP range'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the VLAN IP range'}], u'description': u'Lists all VLAN IP ranges.'}, u'traffictypeimplementors': {u'name': u'listTrafficTypeImplementors', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Optional. The network traffic type, if specified, return its implementor. Otherwise, return all traffic types with their implementor'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'traffictypeimplementor', u'description': u'implementor of network traffic type'}, {u'type': u'string', u'name': u'traffictype', u'description': u'network traffic type'}], u'description': u'Lists implementors of implementor of a network traffic type or implementors of all network traffic types'}, u'storagenetworkiprange': {u'name': u'listStorageNetworkIpRange', u'related': [], u'isasync': False, u'params': [{u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'optional parameter. Pod uuid, if specicied and range uuid is absent, using it to search the range.'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'optional parameter. Zone uuid, if specicied and both pod uuid and range uuid are absent, using it to search the range.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [u'listStorageNetworkIpRange'], u'length': 255, u'type': u'uuid', u'description': u'optional parameter. Storaget network IP range uuid, if specicied, using it to search the range.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the Zone uuid of the storage network IP range'}, {u'type': u'integer', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the storage network IP range'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the storage network IP range'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod uuid for the storage network IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of storage network IP range.'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the storage network IP range'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network uuid of storage network IP range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the storage network IP range'}], u'description': u'List a storage network IP range.'}, u'isopermissions': {u'name': u'listIsoPermissions', u'related': [u'listIsoPermissions', u'listTemplatePermissions'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIsoPermissions', u'listIsoPermissions', u'listTemplatePermissions'], u'length': 255, u'type': u'uuid', u'description': u'the template ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'list', u'name': u'projectids', u'description': u'the list of projects the template is available for'}, {u'type': u'list', u'name': u'account', u'description': u'the list of accounts the template is available for'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}], u'description': u'List iso visibility and all accounts that have permissions to view this iso.'}, u'snapshotpolicies': {u'name': u'listSnapshotPolicies', u'related': [u'createSnapshotPolicy'], u'isasync': False, u'params': [{u'name': u'volumeid', u'required': False, u'related': [u'listVolumes', u'detachVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listSnapshotPolicies', u'createSnapshotPolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the snapshot policy'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'timezone', u'description': u'the time zone of the snapshot policy'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is this policy for display to the regular user'}, {u'type': u'short', u'name': u'intervaltype', u'description': u'the interval type of the snapshot policy'}, {u'type': u'string', u'name': u'volumeid', u'description': u'the ID of the disk volume'}, {u'type': u'int', u'name': u'maxsnaps', u'description': u'maximum number of snapshots retained'}, {u'type': u'string', u'name': u'schedule', u'description': u'time the snapshot is scheduled to be taken.'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the snapshot policy'}], u'description': u'Lists snapshot policies.'}, u'nuagevspdevices': {u'name': u'listNuageVspDevices', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'vspdeviceid', u'required': False, u'related': [u'listNuageVspDevices'], u'length': 255, u'type': u'uuid', u'description': u'the Nuage VSP device ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}], u'requiredparams': [], u'response': [{u'type': u'int', u'name': u'retrycount', u'description': u'the number of retries on failure to communicate to Nuage VSD'}, {u'type': u'string', u'name': u'apiversion', u'description': u'the version of the API to use to communicate to Nuage VSD'}, {u'type': u'long', u'name': u'retryinterval', u'description': u'the time to wait after failure before retrying to communicate to Nuage VSD'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname of the Nuage VSD'}, {u'type': u'int', u'name': u'port', u'description': u'the port to communicate to Nuage VSD'}, {u'type': u'string', u'name': u'provider', u'description': u'the service provider name corresponding to this Nuage VSP device'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the ID of the physical network to which this Nuage VSP belongs to'}, {u'type': u'string', u'name': u'nuagedevicename', u'description': u'the name of the Nuage VSP device'}, {u'type': u'string', u'name': u'vspdeviceid', u'description': u'the device id of the Nuage VSD'}], u'description': u'Lists Nuage VSP devices'}, u'loadbalancers': {u'name': u'listLoadBalancers', u'related': [u'updateLoadBalancer', u'createLoadBalancer'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'sourceipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the source ip address of the Load Balancer'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'id', u'required': False, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Load Balancer'}, {u'name': u'sourceipaddressnetworkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the network id of the source ip address'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'networkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the network id of the Load Balancer'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'scheme', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the scheme of the Load Balancer. Supported value is Internal in the current release'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Load Balancer'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the Load Balancer'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the Load Balancer'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Load Balancer'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the Load Balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Load Balancer'}, {u'type': u'string', u'name': u'id', u'description': u'the Load Balancer ID'}, {u'type': u'string', u'name': u'sourceipaddress', u'description': u'Load Balancer source ip'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the Load Balancer'}, {u'type': u'string', u'name': u'networkid', u'description': u'Load Balancer network id'}, {u'description': u'the list of resource tags associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'description': u'the list of instances associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the instance ID'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the instance'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the instance'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the instance'}], u'name': u'loadbalancerinstance'}, {u'type': u'string', u'name': u'sourceipaddressnetworkid', u'description': u'Load Balancer source ip network id'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Load Balancer'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'description': u'the list of rules associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'integer', u'name': u'instanceport', u'description': u'instance port of the load balancer rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the load balancer rule'}, {u'type': u'integer', u'name': u'sourceport', u'description': u'source port of the load balancer rule'}], u'name': u'loadbalancerrule'}], u'description': u'Lists Load Balancers'}, u'guestosmapping': {u'name': u'listGuestOsMapping', u'related': [u'updateGuestOsMapping', u'addGuestOsMapping'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'hypervisorversion', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list Guest OS mapping by hypervisor version. Must be used with hypervisor parameter'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list Guest OS mapping by hypervisor'}, {u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs', u'updateGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'list mapping by Guest OS Type UUID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'updateGuestOsMapping', u'listGuestOsMapping', u'addGuestOsMapping'], u'length': 255, u'type': u'uuid', u'description': u'list mapping by its UUID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'osdisplayname', u'description': u'standard display name for the Guest OS'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'version of the hypervisor for mapping'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the Guest OS mapping'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor'}, {u'type': u'string', u'name': u'osnameforhypervisor', u'description': u'hypervisor specific name for the Guest OS'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the Guest OS type'}, {u'type': u'string', u'name': u'isuserdefined', u'description': u'is the mapping user defined'}], u'description': u'Lists all available OS mappings for given hypervisor'}, u'paloaltofirewallnetworks': {u'name': u'listPaloAltoFirewallNetworks', u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'lbdeviceid', u'required': True, u'related': [u'configurePaloAltoFirewall'], u'length': 255, u'type': u'uuid', u'description': u'palo alto balancer device ID'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}], u'description': u'lists network that are using Palo Alto firewall device'}, u'imagestores': {u'name': u'listImageStores', u'related': [u'addSwift', u'listSecondaryStagingStores', u'addS3', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore', u'listS3s'], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'addSwift', u'listSecondaryStagingStores', u'addS3', u'listImageStores', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore', u'listS3s'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the storage pool'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the image store'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the image store'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the image store protocol'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'provider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the image store provider'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}], u'description': u'Lists image stores.'}, u'autoscalevmgroups': {u'name': u'listAutoScaleVmGroups', u'related': [u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup', u'createAutoScaleVmGroup'], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'listAutoScaleVmGroups', u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup', u'createAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale vm group'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the availability zone ID'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'vmprofileid', u'required': False, u'related': [u'createAutoScaleVmProfile', u'updateAutoScaleVmProfile', u'listAutoScaleVmProfiles'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the profile'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'lbruleid', u'required': False, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the loadbalancer'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'policyid', u'required': False, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy', u'listAutoScalePolicies'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the policy'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'int', u'name': u'minmembers', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'int', u'name': u'maxmembers', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is group for display to the regular user'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the load balancer rule ID'}, {u'type': u'int', u'name': u'interval', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm group ID'}, {u'type': u'list', u'name': u'scaleuppolicies', u'description': u'list of scaleup autoscale policies'}, {u'type': u'string', u'name': u'vmprofileid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'type': u'string', u'name': u'state', u'description': u'the current state of the AutoScale Vm Group'}, {u'type': u'list', u'name': u'scaledownpolicies', u'description': u'list of scaledown autoscale policies'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}], u'description': u'Lists autoscale vm groups.'}, u'internalloadbalancerelements': {u'name': u'listInternalLoadBalancerElements', u'related': [u'configureInternalLoadBalancerElement', u'createInternalLoadBalancerElement'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'enabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list internal load balancer elements by enabled state'}, {u'name': u'id', u'required': False, u'related': [u'listInternalLoadBalancerElements', u'configureInternalLoadBalancerElement', u'createInternalLoadBalancerElement'], u'length': 255, u'type': u'uuid', u'description': u'list internal load balancer elements by id'}, {u'name': u'nspid', u'required': False, u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'list internal load balancer elements by network service provider id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the internal load balancer element'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the element'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the element'}], u'description': u'Lists all available Internal Load Balancer elements.'}, u'projectaccounts': {u'name': u'listProjectAccounts', u'related': [u'createProject', u'updateProject'], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list accounts of the project by account name'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'role', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list accounts of the project by role'}, {u'name': u'projectid', u'required': True, u'related': [u'createProject', u'updateProject', u'listProjectAccounts'], u'length': 255, u'type': u'uuid', u'description': u'id of the project'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [u'projectid'], u'response': [{u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}], u'description': u"Lists project's accounts"}, u'autoscalevmprofiles': {u'name': u'listAutoScaleVmProfiles', u'related': [], u'isasync': False, u'params': [{u'name': u'templateid', u'required': False, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the templateid of the autoscale vm profile'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'availability zone for the auto deployed virtual machine'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'id', u'required': False, u'related': [u'listAutoScaleVmProfiles'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale vm profile'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'otherdeployparams', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the otherdeployparameters of the autoscale vm profile'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'serviceofferingid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list profiles by service offering id'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'destroyvmgraceperiod', u'description': u'the time allowed for existing connections to get closed before a vm is destroyed'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is profile for display to the regular user'}, {u'type': u'string', u'name': u'otherdeployparams', u'description': u'parameters other than zoneId/serviceOfferringId/templateId to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'autoscaleuserid', u'description': u'the ID of the user used to launch and destroy the VMs'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the service offering to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the availability zone to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm profile ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {}, {}], u'description': u'Lists autoscale vm profiles.'}, u'vpcs': {u'name': u'listVPCs', u'related': [u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listVPCs', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'list VPC by id'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list VPCs by state'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'list by zone'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by name of the VPC'}, {u'name': u'restartrequired', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list VPCs by restartRequired option'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'vpcofferingid', u'required': False, u'related': [u'listVPCOfferings'], u'length': 255, u'type': u'uuid', u'description': u'list by ID of the VPC offering'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'cidr', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"list by cidr of the VPC. All VPC guest networks' cidrs should be within this CIDR"}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'supportedservices', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list VPC supporting certain services'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by display text of the VPC'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'restartrequired', u'description': u'true VPC requires restart'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the VPC.'}, {u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u"is VPC uses distributed router for one hop forwarding and host based network ACL's"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the VPC owner'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}], u'name': u'service'}, {u'description': u'the list of networks belongign to the VPC', u'type': u'list', u'response': [{u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}], u'name': u'network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the VPC'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain of the VPC'}, {u'type': u'string', u'name': u'state', u'description': u'state of the VPC. Can be Inactive/Enabled'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the VPC'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the VPC'}, {u'type': u'string', u'name': u'cidr', u'description': u'the cidr the VPC'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the VPC'}, {u'type': u'boolean', u'name': u'regionlevelvpc', u'description': u'true if VPC is region level'}, {u'description': u'the list of resource tags associated with the project', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the vpc'}, {u'type': u'date', u'name': u'created', u'description': u'the date this VPC was created'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the VPC'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the VPC belongs to'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpc for display to the regular user'}, {u'type': u'string', u'name': u'vpcofferingid', u'description': u'vpc offering id the VPC is created from'}], u'description': u'Lists VPCs'}, u'resourcedetails': {u'name': u'listResourceDetails', u'related': [], u'isasync': False, u'params': [{u'name': u'key', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by key'}, {u'name': u'resourceid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by resource id'}, {u'name': u'value', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by key, value. Needs to be passed only along with key'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if set to true, only details marked with display=true, are returned. False by default'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by resource type'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}], u'requiredparams': [u'resourcetype'], u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'description': u'List resource detail(s)'}, u'f5loadbalancers': {u'name': u'listF5LoadBalancers', u'related': [u'configureF5LoadBalancer', u'addF5LoadBalancer'], u'isasync': False, u'params': [{u'name': u'lbdeviceid', u'required': False, u'related': [u'configureF5LoadBalancer', u'listF5LoadBalancers', u'addF5LoadBalancer'], u'length': 255, u'type': u'uuid', u'description': u'f5 load balancer device ID'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the F5 load balancer'}, {u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this F5 device belongs to'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}], u'description': u'lists F5 load balancer devices'}, u'cisconexusvsms': {u'name': u'listCiscoNexusVSMs', u'related': [u'enableCiscoNexusVSM', u'disableCiscoNexusVSM'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'Id of the CloudStack cluster in which the Cisco Nexus 1000v VSM appliance.'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'Id of the CloudStack cluster in which the Cisco Nexus 1000v VSM appliance.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'vsmdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'vsmdeviceid', u'description': u'device id of the Cisco N1KV VSM device'}, {u'type': u'string', u'name': u'vsmdevicestate', u'description': u'The Device State (Enabled/Disabled) of the VSM'}, {u'type': u'int', u'name': u'vsmpktvlanid', u'description': u'packet vlan id of the VSM'}, {u'type': u'int', u'name': u'vsmstoragevlanid', u'description': u'storage vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmmgmtvlanid', u'description': u'management vlan id of the VSM'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external Cisco Nexus 1000v Virtual Supervisor Module'}, {u'type': u'string', u'name': u'vsmdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'vsmdomainid', u'description': u"The VSM is a switch supervisor. This is the VSM's switch domain id"}, {u'type': u'int', u'name': u'vsmctrlvlanid', u'description': u'control vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmconfigstate', u'description': u'The Config State (Primary/Standby) of the VSM'}, {u'type': u'string', u'name': u'vsmconfigmode', u'description': u'The mode of the VSM (standalone/HA)'}], u'description': u'Retrieves a Cisco Nexus 1000v Virtual Switch Manager device associated with a Cluster'}, u'vpncustomergateways': {u'name': u'listVpnCustomerGateways', u'related': [u'updateVpnCustomerGateway'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'id', u'required': False, u'related': [u'listVpnCustomerGateways', u'updateVpnCustomerGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of the customer gateway'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'name of the customer gateway'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'guest ip of the customer gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec preshared-key of customer gateway'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'IPsec policy of customer gateway'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}], u'description': u'Lists site to site vpn customer gateways'}, u'dedicatedhosts': {u'name': u'listDedicatedHosts', u'related': [u'dedicateHost'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the host'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account associated with the host. Must be used with domainId.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'affinitygroupid', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'uuid', u'description': u'list dedicated hosts by affinity group'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the host'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'hostname', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account ID of the host'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the host'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}], u'description': u'Lists dedicated hosts.'}, u'networkofferings': {u'name': u'listNetworkOfferings', u'related': [u'createNetworkOffering', u'updateNetworkOffering'], u'isasync': False, u'params': [{u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network offerings by state'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network offerings by display text'}, {u'name': u'forvpc', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'the network offering can be used only for network creation inside the VPC'}, {u'name': u'specifyvlan', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'the tags for the network offering.'}, {u'name': u'networkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network. Pass this in if you want to see the available network offering that a network can be changed to.'}, {u'name': u'istagged', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if offering has tags specified'}, {u'name': u'supportedservices', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list network offerings supporting certain services'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'list netowrk offerings available for network creation in specific zone'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'list network offerings by tags'}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by traffic type'}, {u'name': u'sourcenatsupported', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if need to list only netwok offerings where source nat is supported, false otherwise'}, {u'name': u'guestiptype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network offerings by guest type: Shared or Isolated'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isdefault', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if need to list only default network offerings. Default value is false'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network offerings by name'}, {u'name': u'specifyipranges', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if need to list only network offerings which support specifying ip ranges'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'availability', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the availability of network offering. Default value is Required'}, {u'name': u'id', u'required': False, u'related': [u'createNetworkOffering', u'updateNetworkOffering', u'listNetworkOfferings'], u'length': 255, u'type': u'uuid', u'description': u'list network offerings by id'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'supportsstrechedl2subnet', u'description': u'true if network offering supports network that span multiple zones'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the network offering'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network offering is default, false otherwise'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'boolean', u'name': u'forvpc', u'description': u'true if network offering can be used by VPC networks only'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with network offering'}, {u'type': u'boolean', u'name': u'conservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'date', u'name': u'created', u'description': u'the date this network offering was created'}, {u'type': u'string', u'name': u'guestiptype', u'description': u'guest type of the network offering, can be Shared or Isolated'}, {u'type': u'integer', u'name': u'maxconnections', u'description': u'maximum number of concurrents connections to be handled by lb'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering used by virtual router provider'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network offering'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network offering supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network offering. Can be Disabled/Enabled/Inactive'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the network offering.'}, {u'type': u'boolean', u'name': u'egressdefaultpolicy', u'description': u'true if guest network default egress policy is allow; false if default egress policy is deny'}, {u'type': u'boolean', u'name': u'specifyvlan', u'description': u'true if network offering supports vlans, false otherwise'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'true if network offering supports persistent networks, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network offering'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the network offering, supported types are Public, Management, Control, Guest, Vlan or Storage.'}, {u'type': u'string', u'name': u'availability', u'description': u'availability of the network offering'}], u'description': u'Lists all available network offerings.'}, u'zones': {u'name': u'listZones', u'related': [u'listZones'], u'isasync': False, u'params': [{u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List zones by resource tags (key/value pairs)'}, {u'name': u'showcapacities', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'flag to display the capacity of the zones'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain associated with the zone'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the zone'}, {u'name': u'id', u'required': False, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone'}, {u'name': u'networktype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the network type of the zone that the virtual machine belongs to'}, {u'name': u'available', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if you want to retrieve all available Zones. False if you only want to return the Zones from which you have at least one VM. Default is false.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'internaldns1', u'description': u'the first internal DNS for the Zone'}, {u'type': u'map', u'name': u'resourcedetails', u'description': u'Meta data associated with the zone (key/value pairs)'}, {u'type': u'string', u'name': u'id', u'description': u'Zone id'}, {u'type': u'string', u'name': u'networktype', u'description': u'the network type of the zone; can be Basic or Advanced'}, {u'type': u'boolean', u'name': u'securitygroupsenabled', u'description': u'true if security groups support is enabled, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'Network domain name for the networks in the zone'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the Zone'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the Zone'}, {u'description': u'the capacity of the Zone', u'type': u'list', u'response': [{u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}], u'name': u'capacity'}, {u'type': u'boolean', u'name': u'localstorageenabled', u'description': u'true if local storage offering enabled, false otherwise'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the Zone'}, {u'type': u'string', u'name': u'zonetoken', u'description': u'Zone Token'}, {u'type': u'string', u'name': u'domainname', u'description': u'the name of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'guestcidraddress', u'description': u'the guest CIDR address for the Zone'}, {}, {u'type': u'string', u'name': u'description', u'description': u'Zone description'}, {u'type': u'string', u'name': u'domainid', u'description': u'the UUID of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'name', u'description': u'Zone name'}, {u'description': u'the list of resource tags associated with zone.', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'internaldns2', u'description': u'the second internal DNS for the Zone'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the Zone'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the display text of the zone'}, {u'type': u'string', u'name': u'dhcpprovider', u'description': u'the dhcp Provider for the Zone'}], u'description': u'Lists zones'}, u'virtualmachines': {u'name': u'listVirtualMachines', u'related': [u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': False, u'params': [{u'name': u'groupid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the group ID'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the target hypervisor for the template'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the availability zone ID'}, {u'name': u'id', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'displayvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'comma separated list of host details requested, value can be a list of [all, group, nics, stats, secgrp, tmpl, servoff, diskoff, iso, volume, min, affgrp]. If no parameter is passed in, the details will be defaulted to all'}, {u'name': u'templateid', u'required': False, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'list vms by template'}, {u'name': u'isoid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list vms by iso'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'serviceofferingid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list by the service offering'}, {u'name': u'vpcid', u'required': False, u'related': [u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'list vms by vpc'}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list by network id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'state of the virtual machine'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the virtual machine'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the pod ID'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'storageid', u'required': False, u'related': [u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u"the storage ID where vm's volumes belong to"}, {u'name': u'forvirtualnetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list by network type; true if need to list vms using Virtual Network, false otherwise'}, {u'name': u'affinitygroupid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list vms by affinity group'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'ids', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'list', u'description': u'the IDs of the virtual machines, mutually exclusive with id'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}], u'name': u'nic'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'ingressrule'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}], u'description': u'List the virtual machines owned by the account.'}, u'netscalerloadbalancernetworks': {u'name': u'listNetscalerLoadBalancerNetworks', u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'lbdeviceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'netscaler load balancer device ID'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}], u'description': u'lists network that are using a netscaler load balancer device'}, u'oscategories': {u'name': u'listOsCategories', u'related': [], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list os category by name'}, {u'name': u'id', u'required': False, u'related': [u'listOsCategories'], u'length': 255, u'type': u'uuid', u'description': u'list Os category by id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the OS category'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the OS category'}], u'description': u'Lists all supported OS categories for this cloud.'}, u'ldapusers': {u'name': u'listLdapUsers', u'related': [u'searchLdap'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Determines whether all ldap users are returned or just non-cloudstack users'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'firstname', u'description': u"The user's firstname"}, {u'type': u'string', u'name': u'email', u'description': u"The user's email"}, {u'type': u'string', u'name': u'username', u'description': u"The user's username"}, {u'type': u'string', u'name': u'principal', u'description': u"The user's principle"}, {u'type': u'string', u'name': u'lastname', u'description': u"The user's lastname"}, {u'type': u'string', u'name': u'domain', u'description': u"The user's domain"}], u'description': u'Lists all LDAP Users'}, u'affinitygroups': {u'name': u'listAffinityGroups', u'related': [], u'isasync': False, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists affinity groups by name'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'lists affinity groups by type'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'id', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'uuid', u'description': u'list the affinity group by the id provided'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'lists affinity groups by virtual machine id'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}], u'description': u'Lists affinity groups'}, u'secondarystagingstores': {u'name': u'listSecondaryStagingStores', u'related': [u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the staging store protocol'}, {u'name': u'id', u'required': False, u'related': [u'listSecondaryStagingStores', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the staging store'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the staging store'}, {u'name': u'provider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the staging store provider'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the staging store'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}], u'description': u'Lists secondary staging stores.'}, u'virtualrouterelements': {u'name': u'listVirtualRouterElements', u'related': [u'configureVirtualRouterElement', u'createVirtualRouterElement'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'nspid', u'required': False, u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'list virtual router elements by network service provider id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listVirtualRouterElements', u'configureVirtualRouterElement', u'createVirtualRouterElement'], u'length': 255, u'type': u'uuid', u'description': u'list virtual router elements by id'}, {u'name': u'enabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list network offerings by enabled state'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the provider'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the provider'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the provider'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the service provider'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the provider'}], u'description': u'Lists all available virtual router elements.'}, u'ciscovnmcresources': {u'name': u'listCiscoVnmcResources', u'related': [u'addCiscoVnmcResource'], u'isasync': False, u'params': [{u'name': u'resourceid', u'required': False, u'related': [u'listCiscoVnmcResources', u'addCiscoVnmcResource'], u'length': 255, u'type': u'uuid', u'description': u'Cisco VNMC resource ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}], u'requiredparams': [], u'response': [{}, {}, {}, {}, {}], u'description': u'Lists Cisco VNMC controllers'}, u'asyncjobs': {u'name': u'listAsyncJobs', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'tzdate', u'description': u'the start date of the async job'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'jobstatus', u'description': u'the current job status-should be 0 for PENDING'}, {u'type': u'integer', u'name': u'jobprocstatus', u'description': u'the progress information of the PENDING job'}, {u'type': u'integer', u'name': u'jobresultcode', u'description': u'the result code for the job'}, {u'type': u'string', u'name': u'cmd', u'description': u'the async command executed'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account that executed the async command'}, {u'type': u'string', u'name': u'userid', u'description': u'the user that executed the async command'}, {u'type': u'responseobject', u'name': u'jobresult', u'description': u'the result reason'}, {u'type': u'string', u'name': u'jobresulttype', u'description': u'the result type'}, {u'type': u'date', u'name': u'created', u'description': u'  the created date of the job'}, {u'type': u'string', u'name': u'jobinstanceid', u'description': u'the unique ID of the instance/entity object related to the job'}, {u'type': u'string', u'name': u'jobinstancetype', u'description': u'the instance/entity object related to the job'}], u'description': u'Lists all pending asynchronous jobs for the account.'}, u'ostypes': {u'name': u'listOsTypes', u'related': [u'addGuestOs'], u'isasync': False, u'params': [{u'name': u'oscategoryid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list by Os Category id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list os by description'}, {u'name': u'id', u'required': False, u'related': [u'addGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'list by Os type Id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'isuserdefined', u'description': u'is the guest OS user defined'}, {u'type': u'string', u'name': u'description', u'description': u'the name/description of the OS type'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the OS type'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the ID of the OS category'}], u'description': u'Lists all supported OS types for this cloud.'}, u'globalloadbalancerrules': {u'name': u'listGlobalLoadBalancerRules', u'related': [], u'isasync': False, u'params': [{u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listGlobalLoadBalancerRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the global load balancer rule'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'regionid', u'required': False, u'related': [u'addRegion'], u'length': 255, u'type': u'integer', u'description': u'region ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which global load balancer is created'}, {u'description': u'List of load balancer rules that are part of GSLB rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}], u'name': u'loadbalancerrule'}, {u'type': u'string', u'name': u'gslbservicetype', u'description': u'GSLB service type'}, {u'type': u'string', u'name': u'gslbstickysessionmethodname', u'description': u'session persistence method used for the global load balancer'}, {u'type': u'string', u'name': u'gslblbmethod', u'description': u'Load balancing method used for the global load balancer'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the global load balancer rule'}, {u'type': u'string', u'name': u'gslbdomainname', u'description': u'DNS domain name given for the global load balancer'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'name', u'description': u'name of the global load balancer rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'id', u'description': u'global load balancer rule ID'}], u'description': u'Lists load balancer rules.'}, u'networkacls': {u'name': u'listNetworkACLs', u'related': [u'updateNetworkACLItem', u'createNetworkACL'], u'isasync': False, u'params': [{u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'networkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'listNiciraNvpDeviceNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list network ACL Items by network Id'}, {u'name': u'id', u'required': False, u'related': [u'listNetworkACLs', u'updateNetworkACLItem', u'createNetworkACL'], u'length': 255, u'type': u'uuid', u'description': u'Lists network ACL Item with the specified ID'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'aclid', u'required': False, u'related': [u'listNetworkACLLists', u'createNetworkACLList'], u'length': 255, u'type': u'uuid', u'description': u'list network ACL Items by ACL Id'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network ACL Items by Protocol'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network ACL Items by traffic type - Ingress or Egress'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'action', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list network ACL Items by Action'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'suspendProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'endport', u'description': u"the ending port of ACL's port range"}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the ACL'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'action', u'description': u'Action of ACL Item. Allow/Deny'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the ACL'}, {u'type': u'integer', u'name': u'number', u'description': u'Number of the ACL Item'}, {u'description': u'the list of resource tags associated with the network ACLs', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'aclid', u'description': u'the ID of the ACL this item belongs to'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of ACL's port range"}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ACL Item'}], u'description': u'Lists all network ACL items'}, u'eventtypes': {u'name': u'listEventTypes', u'related': [], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'name', u'description': u'Event Type'}], u'description': u'List Event Types'}, u'remoteaccessvpns': {u'name': u'listRemoteAccessVpns', u'related': [u'createRemoteAccessVpn'], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'id', u'required': False, u'related': [u'listRemoteAccessVpns', u'createRemoteAccessVpn'], u'length': 255, u'type': u'uuid', u'description': u'Lists remote access vpn rule with the specified ID'}, {u'name': u'publicipid', u'required': False, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'public ip address id of the vpn server'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list remote access VPNs for ceratin network'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the account of the remote access vpn'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn for display to the regular user'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the remote access vpn'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the account of the remote access vpn'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the remote access vpn'}, {u'type': u'string', u'name': u'presharedkey', u'description': u'the ipsec preshared key'}, {u'type': u'string', u'name': u'iprange', u'description': u'the range of ips to allocate to the clients'}], u'description': u'Lists remote access vpns'}, u'ucsprofiles': {u'name': u'listUcsProfiles', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'ucsmanagerid', u'required': True, u'related': [u'addUcsManager'], u'length': 255, u'type': u'uuid', u'description': u'the id for the ucs manager'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [u'ucsmanagerid'], u'response': [{u'type': u'string', u'name': u'ucsdn', u'description': u'ucs profile dn'}], u'description': u'List profile in ucs manager'}, u'nics': {u'name': u'listNics', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the vm'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u"list nic of the specific vm's network"}, {u'name': u'nicid', u'required': False, u'related': [u'listNics'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the nic to to list IPs'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}], u'description': u'list the vm nics  IP to NIC'}, u'alerts': {u'name': u'listAlerts', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listAlerts'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the alert'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by alert name'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list by alert type'}], u'requiredparams': [], u'response': [{u'type': u'date', u'name': u'sent', u'description': u'the date and time the alert was sent'}, {u'type': u'string', u'name': u'description', u'description': u'description of the alert'}, {u'type': u'short', u'name': u'type', u'description': u'One of the following alert types: MEMORY = 0, CPU = 1, STORAGE = 2, STORAGE_ALLOCATED = 3, PUBLIC_IP = 4, PRIVATE_IP = 5, HOST = 6, USERVM = 7, DOMAIN_ROUTER = 8, CONSOLE_PROXY = 9, ROUTING = 10: lost connection to default route (to the gateway), STORAGE_MISC = 11: lost connection to default route (to the gateway), USAGE_SERVER = 12: lost connection to default route (to the gateway), MANAGMENT_NODE = 13: lost connection to default route (to the gateway), DOMAIN_ROUTER_MIGRATE = 14, CONSOLE_PROXY_MIGRATE = 15, USERVM_MIGRATE = 16, VLAN = 17, SSVM = 18, USAGE_SERVER_RESULT = 19'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the alert'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the alert'}], u'description': u'Lists all alerts.'}, u'regions': {u'name': u'listRegions', u'related': [u'addRegion'], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'List Region by region ID.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List Region by region name.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'portableipserviceenabled', u'description': u'true if security groups support is enabled, false otherwise'}, {u'type': u'integer', u'name': u'id', u'description': u'the ID of the region'}, {u'type': u'boolean', u'name': u'gslbserviceenabled', u'description': u'true if GSLB service is enabled in the region, false otherwise'}, {u'type': u'string', u'name': u'endpoint', u'description': u'the end point of the region'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the region'}], u'description': u'Lists Regions'}, u'vpcofferings': {u'name': u'listVPCOfferings', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'listVPCOfferings'], u'length': 255, u'type': u'uuid', u'description': u'list VPC offerings by id'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list VPC offerings by state'}, {u'name': u'isdefault', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if need to list only default VPC offerings. Default value is false'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list VPC offerings by name'}, {u'name': u'supportedservices', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list VPC offerings supporting certain services'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list VPC offerings by display text'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the vpc offering'}, {u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u' indicates if the vpc offering supports distributed router for one-hop forwarding'}, {u'type': u'string', u'name': u'state', u'description': u'state of the vpc offering. Can be Disabled/Enabled'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if vpc offering is default, false otherwise'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the vpc offering.'}, {u'type': u'date', u'name': u'created', u'description': u'the date this vpc offering was created'}, {u'type': u'boolean', u'name': u'supportsregionLevelvpc', u'description': u' indicated if the offering can support region level vpc'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the vpc offering'}], u'description': u'Lists VPC offerings'}, u'sslcerts': {u'name': u'listSslCerts', u'related': [], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'project who owns the ssl cert'}, {u'name': u'certid', u'required': False, u'related': [u'listSslCerts'], u'length': 255, u'type': u'uuid', u'description': u'Id of SSL certificate'}, {u'name': u'lbruleid', u'required': False, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'Loadbalancer Rule Id'}, {u'name': u'accountid', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'Account Id'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'id', u'description': u'SSL certificate ID'}, {u'type': u'string', u'name': u'certificate', u'description': u'certificate'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the certificate'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the certificate'}, {u'type': u'string', u'name': u'certchain', u'description': u'certificate chain'}, {u'type': u'string', u'name': u'privatekey', u'description': u'private key'}, {u'type': u'list', u'name': u'loadbalancerrulelist', u'description': u'List of loabalancers this certificate is bound to'}, {u'type': u'string', u'name': u'fingerprint', u'description': u'certificate fingerprint'}, {u'type': u'string', u'name': u'account', u'description': u'account for the certificate'}], u'description': u'Lists SSL certificates'}, u'niciranvpdevicenetworks': {u'name': u'listNiciraNvpDeviceNetworks', u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'nvpdeviceid', u'required': True, u'related': [u'listNiciraNvpDevices', u'addNiciraNvpDevice'], u'length': 255, u'type': u'uuid', u'description': u'nicira nvp device ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'nvpdeviceid'], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}], u'description': u'lists network that are using a nicira nvp device'}, u'baremetalpxeservers': {u'name': u'listBaremetalPxeServers', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Pxe server device ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'url', u'description': u'url'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'id', u'description': u'device id of '}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this external dhcp device belongs to'}], u'description': u'list baremetal pxe server'}, u'templates': {u'name': u'listTemplates', u'related': [u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the hypervisor for which to restrict the search'}, {u'name': u'templatefilter', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'possible values are "featured", "self", "selfexecutable","sharedexecutable","executable", and "community". * featured : templates that have been marked as featured and public. * self : templates that have been registered or created by the calling user. * selfexecutable : same as self, but only returns templates that can be used to deploy a new VM. * sharedexecutable : templates ready to be deployed that have been granted to the calling user by another user. * executable : templates that are owned by the calling user, or public templates, that can be used to deploy a VM. * community : templates that have been marked as public but not featured. * all : all templates (only usable by admins).'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'id', u'required': False, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the template ID'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the template name'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'list templates by zoneId'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'showremoved', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'show removed templates as well'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}], u'requiredparams': [u'templatefilter'], u'response': [{u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}], u'description': u'List all public, private, and privileged templates.'}, u'externalfirewalls': {u'name': u'listExternalFirewalls', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'zone Id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [u'zoneid'], u'response': [{u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}], u'description': u'List external firewall appliances.'}, u'ipforwardingrules': {u'name': u'listIpForwardingRules', u'related': [], u'isasync': False, u'params': [{u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Lists all rules applied to the specified Vm.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'ipaddressid', u'required': False, u'related': [u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'list the rule belonging to this public ip address'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'Lists rule with the specified ID.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'virtualmachineid', u'description': u'the VM ID for the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'the VM name for the port forwarding rule'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'the VM display name for the port forwarding rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the port forwarding rule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the port forwarding rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the port forwarding rule belongs to'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the port forwarding rule'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is firewall for display to the regular user'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'publicport', u'description': u"the starting port of port forwarding rule's public port range"}, {u'type': u'string', u'name': u'privateendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'vmguestip', u'description': u'the vm ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'publicendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'privateport', u'description': u"the starting port of port forwarding rule's private port range"}], u'description': u'List the ip forwarding rules'}, u'srxfirewalls': {u'name': u'listSrxFirewalls', u'related': [], u'isasync': False, u'params': [{u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'fwdeviceid', u'required': False, u'related': [u'listSrxFirewalls'], u'length': 255, u'type': u'uuid', u'description': u'SRX firewall device ID'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this SRX firewall belongs to'}, {u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the SRX firewall'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}], u'description': u'lists SRX firewall devices in a physical network'}, u'vpnconnections': {u'name': u'listVpnConnections', u'related': [], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'id', u'required': False, u'related': [u'listVpnConnections'], u'length': 255, u'type': u'uuid', u'description': u'id of the vpn connection'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'vpcid', u'required': False, u'related': [u'createVPC', u'listVPCs', u'updateVPC'], u'length': 255, u'type': u'uuid', u'description': u'id of vpc'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u's2scustomergatewayid', u'description': u'the customer gateway ID'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'state', u'description': u'State of vpn connection'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u's2svpngatewayid', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'ESP policy of the customer gateway'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is connection for display to the regular user'}, {u'type': u'boolean', u'name': u'passive', u'description': u'State of vpn connection'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of the customer gateway'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'id', u'description': u'the connection ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}], u'description': u'Lists site to site vpn connection gateways'}, u'trafficmonitors': {u'name': u'listTrafficMonitors', u'related': [], u'isasync': False, u'params': [{u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'zone Id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'zoneid'], u'response': [{u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}], u'description': u'List traffic monitor Hosts.'}, u'vpnusers': {u'name': u'listVpnUsers', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': False, u'related': [u'listVpnUsers'], u'length': 255, u'type': u'uuid', u'description': u'The uuid of the Vpn user'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username of the vpn user.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the account of the remote access vpn'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the Vpn User'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn userID'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'username', u'description': u'the username of the vpn user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the account of the remote access vpn'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the remote access vpn'}], u'description': u'Lists vpn users'}, u'egressfirewallrules': {u'name': u'listEgressFirewallRules', u'related': [], u'isasync': False, u'params': [{u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Lists rule with the specified ID.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Lists rule with the specified ID.'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'ipaddressid', u'required': False, u'related': [u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the id of IP address of the firwall services'}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'list firewall rules for ceratin network'}, {u'name': u'networkid', u'required': False, u'related': [u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the id network network for the egress firwall services'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}], u'description': u'Lists all egress firewall rules for network id.'}, u'opendaylightcontrollers': {u'name': u'listOpenDaylightControllers', u'related': [u'deleteOpenDaylightController'], u'isasync': False, u'params': [{u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'id', u'required': False, u'related': [u'listOpenDaylightControllers', u'deleteOpenDaylightController'], u'length': 255, u'type': u'uuid', u'description': u'the ID of a OpenDaylight Controller'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'device id of the controller'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this controller belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the name assigned to the controller'}, {u'type': u'string', u'name': u'username', u'description': u'the username to authenticate to the controller'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the controller api'}], u'description': u'Lists OpenDyalight controllers'}, u'externalloadbalancers': {u'name': u'listExternalLoadBalancers', u'related': [u'listHosts'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'zone Id'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}], u'name': u'vgpu'}, {u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}], u'name': u'gpugroup'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}], u'description': u'Lists F5 external load balancer appliances added in a zone.'}, u'staticroutes': {u'name': u'listStaticRoutes', u'related': [], u'isasync': False, u'params': [{u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'list static routes by vpc id'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'gatewayid', u'required': False, u'related': [u'createPrivateGateway'], u'length': 255, u'type': u'uuid', u'description': u'list static routes by gateway id'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'id', u'required': False, u'related': [u'listStaticRoutes'], u'length': 255, u'type': u'uuid', u'description': u'list static route by id'}], u'requiredparams': [], u'response': [{u'description': u'the list of resource tags associated with static route', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the static route'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of static route'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the static route'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the static route belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the static route'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the static route'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the static route'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the static route'}, {u'type': u'string', u'name': u'cidr', u'description': u'static route CIDR'}, {u'type': u'string', u'name': u'gatewayid', u'description': u'VPC gateway the route is created for'}], u'description': u'Lists all static routes'}, u'portableipranges': {u'name': u'listPortableIpRanges', u'related': [], u'isasync': False, u'params': [{u'name': u'regionid', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Id of a Region'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'id', u'required': False, u'related': [u'listPortableIpRanges'], u'length': 255, u'type': u'uuid', u'description': u'Id of the portable ip range'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the VLAN IP range'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which portable ip range is provisioned'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the VLAN IP range'}, {u'description': u'List of portable IP and association with zone/network/vpc details that are part of GSLB rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the portal IP address was acquired'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the portable IP address is associated with'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID the portable IP address is associated with'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which global load balancer is created'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}], u'name': u'portableipaddress'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the portable IP range'}, {u'type': u'string', u'name': u'id', u'description': u'portable IP range ID'}, {u'type': u'string', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the portable IP range'}], u'description': u'list portable IP ranges'}, u'volumes': {u'name': u'listVolumes', u'related': [u'migrateVolume', u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': False, u'params': [{u'name': u'hostid', u'required': False, u'related': [u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'list volumes on specified host'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'List resources by tags (key/value pairs)'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the type of disk volume'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list resources by account. Must be used with the domainId parameter.'}, {u'name': u'isrecursive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'defaults to false, but if true, lists all resources from the parent specified by the domainId till leaves.'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'listall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, list only resources belonging to the command's caller; if set to true - list resources that the caller is authorized to see. Default value is false"}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'storageid', u'required': False, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'enableStorageMaintenance', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the storage pool, available to ROOT admin only'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'suspendProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'list objects by project'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the availability zone'}, {u'name': u'storageid', u'required': False, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'enableStorageMaintenance', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the storage pool, available to ROOT admin only'}, {u'name': u'diskofferingid', u'required': False, u'related': [u'updateDiskOffering', u'listDiskOfferings', u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'list volumes by disk offering'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}, {u'name': u'displayvolume', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'list resources by display flag; only ROOT admin is eligible to pass this parameter'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the disk volume'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the pod id the disk volume belongs to'}, {u'name': u'id', u'required': False, u'related': [u'listVolumes', u'migrateVolume', u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'list only resources belonging to the domain specified'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the pod id the disk volume belongs to'}], u'requiredparams': [], u'response': [{u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}], u'description': u'Lists all volumes.'}, u'pods': {u'name': u'listPods', u'related': [u'createPod', u'updatePod'], u'isasync': False, u'params': [{u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'id', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'list Pods by ID'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list pods by allocation state'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'list Pods by Zone ID'}, {u'name': u'showcapacities', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'flag to display the capacity of the pods'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list Pods by name'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [], u'response': [{u'description': u'the capacity of the Pod', u'type': u'list', u'response': [{u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the Pod'}, {u'type': u'string', u'name': u'startip', u'description': u'the starting IP for the Pod'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the Pod'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the Pod'}, {u'type': u'string', u'name': u'endip', u'description': u'the ending IP for the Pod'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the Pod'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the Pod'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the Pod'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Pod'}], u'description': u'Lists all Pods.'}}, u'activate': {u'project': {u'name': u'activateProject', u'related': [u'createProject', u'updateProject', u'listProjectAccounts'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to be modified'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}], u'description': u'Activates a project'}}, u'reconnect': {u'host': {u'name': u'reconnectHost', u'related': [u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'reconnectHost', u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}, {u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}], u'name': u'vgpu'}], u'name': u'gpugroup'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}], u'description': u'Reconnects a host.'}}, u'cancel': {u'hostmaintenance': {u'name': u'cancelHostMaintenance', u'related': [u'listHosts', u'updateHost', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}, {u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}], u'name': u'vgpu'}], u'name': u'gpugroup'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}], u'description': u'Cancels host maintenance.'}, u'storagemaintenance': {u'name': u'cancelStorageMaintenance', u'related': [u'createStoragePool', u'listStoragePools', u'findStoragePoolsForMigration'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the primary storage ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}, {u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}], u'description': u'Cancels maintenance for primary storage'}}, u'query': {u'asyncjobresult': {u'name': u'queryAsyncJobResult', u'related': [u'listAsyncJobs'], u'isasync': False, u'params': [{u'name': u'jobid', u'required': True, u'related': [u'listAsyncJobs', u'queryAsyncJobResult'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the asychronous job'}], u'requiredparams': [u'jobid'], u'response': [{u'type': u'string', u'name': u'accountid', u'description': u'the account that executed the async command'}, {u'type': u'string', u'name': u'jobinstancetype', u'description': u'the instance/entity object related to the job'}, {u'type': u'integer', u'name': u'jobprocstatus', u'description': u'the progress information of the PENDING job'}, {u'type': u'date', u'name': u'created', u'description': u'  the created date of the job'}, {u'type': u'integer', u'name': u'jobresultcode', u'description': u'the result code for the job'}, {u'type': u'responseobject', u'name': u'jobresult', u'description': u'the result reason'}, {u'type': u'string', u'name': u'cmd', u'description': u'the async command executed'}, {u'type': u'string', u'name': u'jobinstanceid', u'description': u'the unique ID of the instance/entity object related to the job'}, {u'type': u'string', u'name': u'jobresulttype', u'description': u'the result type'}, {u'type': u'string', u'name': u'userid', u'description': u'the user that executed the async command'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the current job status-should be 0 for PENDING'}], u'description': u'Retrieves the current status of asynchronous job.'}}, u'recover': {u'virtualmachine': {u'name': u'recoverVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'ingressrule'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}], u'description': u'Recovers a virtual machine.'}}, u'extract': {u'volume': {u'name': u'extractVolume', u'related': [u'extractTemplate', u'extractIso'], u'isasync': True, u'params': [{u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the url to which the volume would be extracted'}, {u'name': u'mode', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the mode of extraction - HTTP_DOWNLOAD or FTP_UPLOAD'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone where the volume is located'}, {u'name': u'id', u'required': True, u'related': [u'listVolumes', u'migrateVolume', u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the volume'}], u'requiredparams': [u'mode', u'zoneid', u'id'], u'response': [{u'type': u'string', u'name': u'extractId', u'description': u'the upload id of extracted object'}, {u'type': u'string', u'name': u'resultstring', u'description': u''}, {u'type': u'string', u'name': u'status', u'description': u'the status of the extraction'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the extracted object'}, {u'type': u'integer', u'name': u'uploadpercentage', u'description': u'the percentage of the entity uploaded to the specified location'}, {u'type': u'string', u'name': u'url', u'description': u'if mode = upload then url of the uploaded entity. if mode = download the url from which the entity can be downloaded'}, {u'type': u'string', u'name': u'zonename', u'description': u'zone name the object was extracted from'}, {u'type': u'string', u'name': u'extractMode', u'description': u'the mode of extraction - upload or download'}, {u'type': u'string', u'name': u'id', u'description': u'the id of extracted object'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the extracted object'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the extracted object belongs'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone ID the object was extracted from'}, {u'type': u'date', u'name': u'created', u'description': u'the time and date the object was created'}, {}, {u'type': u'string', u'name': u'storagetype', u'description': u'type of the storage'}], u'description': u'Extracts volume'}, u'iso': {u'name': u'extractIso', u'related': [u'extractTemplate'], u'isasync': True, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone where the ISO is originally located'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the url to which the ISO would be extracted'}, {u'name': u'id', u'required': True, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the ISO file'}, {u'name': u'mode', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the mode of extraction - HTTP_DOWNLOAD or FTP_UPLOAD'}], u'requiredparams': [u'id', u'mode'], u'response': [{u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the extracted object belongs'}, {}, {u'type': u'string', u'name': u'zonename', u'description': u'zone name the object was extracted from'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone ID the object was extracted from'}, {u'type': u'string', u'name': u'storagetype', u'description': u'type of the storage'}, {u'type': u'date', u'name': u'created', u'description': u'the time and date the object was created'}, {u'type': u'string', u'name': u'url', u'description': u'if mode = upload then url of the uploaded entity. if mode = download the url from which the entity can be downloaded'}, {u'type': u'string', u'name': u'extractMode', u'description': u'the mode of extraction - upload or download'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the extracted object'}, {u'type': u'string', u'name': u'extractId', u'description': u'the upload id of extracted object'}, {u'type': u'integer', u'name': u'uploadpercentage', u'description': u'the percentage of the entity uploaded to the specified location'}, {u'type': u'string', u'name': u'id', u'description': u'the id of extracted object'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the extraction'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the extracted object'}, {u'type': u'string', u'name': u'resultstring', u'description': u''}], u'description': u'Extracts an ISO'}, u'template': {u'name': u'extractTemplate', u'related': [], u'isasync': True, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone where the ISO is originally located'}, {u'name': u'id', u'required': True, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the template'}, {u'name': u'mode', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the mode of extraction - HTTP_DOWNLOAD or FTP_UPLOAD'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the url to which the ISO would be extracted'}], u'requiredparams': [u'id', u'mode'], u'response': [{u'type': u'string', u'name': u'extractId', u'description': u'the upload id of extracted object'}, {u'type': u'date', u'name': u'created', u'description': u'the time and date the object was created'}, {u'type': u'string', u'name': u'resultstring', u'description': u''}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone ID the object was extracted from'}, {}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the extracted object belongs'}, {u'type': u'string', u'name': u'extractMode', u'description': u'the mode of extraction - upload or download'}, {u'type': u'string', u'name': u'zonename', u'description': u'zone name the object was extracted from'}, {u'type': u'string', u'name': u'storagetype', u'description': u'type of the storage'}, {u'type': u'string', u'name': u'url', u'description': u'if mode = upload then url of the uploaded entity. if mode = download the url from which the entity can be downloaded'}, {u'type': u'integer', u'name': u'uploadpercentage', u'description': u'the percentage of the entity uploaded to the specified location'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the extraction'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the extracted object'}, {u'type': u'string', u'name': u'id', u'description': u'the id of extracted object'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the extracted object'}], u'description': u'Extracts a template'}}, u'archive': {u'alerts': {u'name': u'archiveAlerts', u'related': [], u'isasync': False, u'params': [{u'name': u'ids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the IDs of the alerts'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'archive by alert type'}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'start date range to archive alerts (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}, {u'name': u'enddate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'end date range to archive alerts (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Archive one or more alerts.'}, u'events': {u'name': u'archiveEvents', u'related': [], u'isasync': False, u'params': [{u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'archive by event type'}, {u'name': u'ids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the IDs of the events'}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'start date range to archive events (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}, {u'name': u'enddate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'end date range to archive events (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Archive one or more events.'}}, u'scale': {u'systemvm': {u'name': u'scaleSystemVm', u'related': [], u'isasync': True, u'params': [{u'name': u'serviceofferingid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the service offering ID to apply to the system vm'}, {u'name': u'id', u'required': True, u'related': [u'scaleSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system vm'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'name value pairs of custom parameters for cpu, memory and cpunumber. example details[i].name=value'}], u'requiredparams': [u'serviceofferingid', u'id'], u'response': [{u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}], u'description': u'Scale the service offering for a system vm (console proxy or secondary storage). The system vm must be in a "Stopped" state for this command to take effect.'}, u'virtualmachine': {u'name': u'scaleVirtualMachine', u'related': [], u'isasync': True, u'params': [{u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'name value pairs of custom parameters for cpu,memory and cpunumber. example details[i].name=value'}, {u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the service offering for the virtual machine'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'serviceofferingid', u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Scales the virtual machine to a new service offering.'}}, u'prepare': {u'hostformaintenance': {u'name': u'prepareHostForMaintenance', u'related': [u'listHosts', u'listExternalLoadBalancers'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'listExternalLoadBalancers', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}], u'name': u'vgpu'}, {u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}], u'name': u'gpugroup'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}], u'description': u'Prepares a host for maintenance.'}, u'template': {u'name': u'prepareTemplate', u'related': [u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'zone ID of the template to be prepared in primary storage(s).'}, {u'name': u'templateid', u'required': True, u'related': [u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'template ID of the template to be prepared in primary storage(s).'}], u'requiredparams': [u'zoneid', u'templateid'], u'response': [{u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}], u'description': u'load template into primary storage'}}, u'saml': {u'sso': {u'name': u'samlSso', u'related': [], u'isasync': False, u'params': [{u'name': u'idpurl', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Identity Provider SSO HTTP-Redirect binding URL'}], u'requiredparams': [u'idpurl'], u'response': [{u'type': u'string', u'name': u'type', u'description': u'the account type (admin, domain-admin, read-only-admin, user)'}, {u'type': u'string', u'name': u'timezone', u'description': u'user time zone'}, {u'type': u'integer', u'name': u'timeout', u'description': u'the time period before the session has expired'}, {u'type': u'string', u'name': u'userid', u'description': u'User ID'}, {u'type': u'string', u'name': u'registered', u'description': u'Is user registered'}, {u'type': u'string', u'name': u'domainid', u'description': u'Domain ID that the user belongs to'}, {u'type': u'string', u'name': u'username', u'description': u'Username'}, {u'type': u'string', u'name': u'sessionkey', u'description': u'Session key that can be passed in subsequent Query command calls'}, {u'type': u'string', u'name': u'firstname', u'description': u'first name of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'last name of the user'}, {u'type': u'string', u'name': u'account', u'description': u'the account name the user belongs to'}], u'description': u'SP initiated SAML Single Sign On'}, u'slo': {u'name': u'samlSlo', u'related': [u'logout'], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'description', u'description': u'Response description'}], u'description': u'SAML Global Log Out API'}}, u'create': {u'loadbalancerrule': {u'name': u'createLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The protocol for the LB'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'zone where the load balancer is going to be created. This parameter is required when LB service provider is ElasticLoadBalancerVm'}, {u'name': u'openfirewall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, firewall rule for source/end pubic port is automatically created; if false - firewall rule has to be created explicitely. If not specified 1) defaulted to false when LB rule is being created for VPC guest network 2) in all other cases defaulted to true'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the load balancer'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to forward traffic from'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The guest network this rule will be created for. Required when public Ip address is not associated with any Guest network yet (VPC case)'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the load balancer. Must be used with the domainId parameter.'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'algorithm', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'load balancer algorithm (source, roundrobin, leastconn)'}, {u'name': u'publicipid', u'required': False, u'related': [u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'public ip address id from where the network traffic will be load balanced from'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the load balancer rule'}, {u'name': u'description', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the description of the load balancer rule'}, {u'name': u'privateport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the private port of the private ip address/virtual machine where the network traffic will be load balanced to'}, {u'name': u'publicport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the public port from where the network traffic will be load balanced from'}], u'requiredparams': [u'algorithm', u'name', u'privateport', u'publicport'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}], u'description': u'Creates a load balancer rule'}, u'domain': {u'name': u'createDomain', u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Domain UUID, required for adding domain from another Region'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'creates domain with this name'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Network domain for networks in the domain'}, {u'name': u'parentdomainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'assigns new domain a parent domain by domain ID of the parent.  If no parent domain is specied, the ROOT domain is assumed.'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'path', u'description': u'the path of the domain'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'boolean', u'name': u'haschild', u'description': u'whether the domain has one or more sub-domains'}, {u'type': u'integer', u'name': u'level', u'description': u'the level of the domain'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the domain'}, {u'type': u'string', u'name': u'parentdomainname', u'description': u'the domain name of the parent domain'}, {u'type': u'string', u'name': u'parentdomainid', u'description': u'the domain ID of the parent domain'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the domain'}], u'description': u'Creates a domain'}, u'snapshotpolicy': {u'name': u'createSnapshotPolicy', u'related': [], u'isasync': False, u'params': [{u'name': u'schedule', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'time the snapshot is scheduled to be taken. Format is:* if HOURLY, MM* if DAILY, MM:HH* if WEEKLY, MM:HH:DD (1-7)* if MONTHLY, MM:HH:DD (1-28)'}, {u'name': u'intervaltype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'valid values are HOURLY, DAILY, WEEKLY, and MONTHLY'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the policy to the end user or not'}, {u'name': u'maxsnaps', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'maximum number of snapshots to retain'}, {u'name': u'volumeid', u'required': True, u'related': [u'listVolumes', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'timezone', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}], u'requiredparams': [u'schedule', u'intervaltype', u'maxsnaps', u'volumeid', u'timezone'], u'response': [{u'type': u'short', u'name': u'intervaltype', u'description': u'the interval type of the snapshot policy'}, {u'type': u'int', u'name': u'maxsnaps', u'description': u'maximum number of snapshots retained'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the snapshot policy'}, {u'type': u'string', u'name': u'volumeid', u'description': u'the ID of the disk volume'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is this policy for display to the regular user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the time zone of the snapshot policy'}, {u'type': u'string', u'name': u'schedule', u'description': u'time the snapshot is scheduled to be taken.'}], u'description': u'Creates a snapshot policy for the account.'}, u'diskoffering': {u'name': u'createDiskOffering', u'related': [], u'isasync': False, u'params': [{u'name': u'provisioningtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the disk offering'}, {u'name': u'hypervisorsnapshotreserve', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'name': u'displayoffering', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to display the offering to the end user or not.'}, {u'name': u'disksize', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'size of the disk offering in GB'}, {u'name': u'iopswriterate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'io requests write rate of the disk offering'}, {u'name': u'miniops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'min iops of the disk offering'}, {u'name': u'maxiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'max iops of the disk offering'}, {u'name': u'customized', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'whether disk offering size is custom or not'}, {u'name': u'customizediops', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'whether disk offering iops is custom or not'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'tags for the disk offering'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 4096, u'type': u'string', u'description': u'alternate display text of the disk offering'}, {u'name': u'storagetype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the storage type of the disk offering. Values are local and shared.'}, {u'name': u'byteswriterate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes write rate of the disk offering'}, {u'name': u'bytesreadrate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes read rate of the disk offering'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain, null for public offerings'}, {u'name': u'iopsreadrate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'io requests read rate of the disk offering'}], u'requiredparams': [u'name', u'displaytext'], u'response': [{u'type': u'long', u'name': u'disksize', u'description': u'the size of the disk offering in GB'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'true if disk offering uses custom size, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the disk offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the disk offering.'}, {u'type': u'date', u'name': u'created', u'description': u'the date this disk offering was created'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk offering'}, {u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'string', u'name': u'id', u'description': u'unique ID of the disk offering'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the disk offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID this disk offering belongs to. Ignore this information as it is not currently applicable.'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}, {u'type': u'boolean', u'name': u'displayoffering', u'description': u'whether to display the offering to the end user or not.'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'string', u'name': u'cacheMode', u'description': u'the cache mode to use for this disk offering. none, writeback or writethrough'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk offering'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this disk offering'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name this disk offering belongs to. Ignore this information as it is not currently applicable.'}], u'description': u'Creates a disk offering.'}, u'securitygroup': {u'name': u'createSecurityGroup', u'related': [u'listSecurityGroups'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the security group. If the account parameter is used, domainId must also be used.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the security group. Must be used with domainId.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'Create security group for project'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the security group'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the description of the security group'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}], u'description': u'Creates a security group'}, u'portforwardingrule': {u'name': u'createPortForwardingRule', u'related': [u'listIpForwardingRules'], u'isasync': True, u'params': [{u'name': u'networkid', u'required': False, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The network of the vm the Port Forwarding rule will be created for. Required when public Ip address is not associated with any Guest network yet (VPC case)'}, {u'name': u'openfirewall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, firewall rule for source/end pubic port is automatically created; if false - firewall rule has to be created explicitely. If not specified 1) defaulted to false when PF rule is being created for VPC guest network 2) in all other cases defaulted to true'}, {u'name': u'publicendport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u"the ending port of port forwarding rule's private port range"}, {u'name': u'ipaddressid', u'required': True, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the IP address id of the port forwarding rule'}, {u'name': u'protocol', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the port fowarding rule. Valid values are TCP or UDP.'}, {u'name': u'vmguestip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'VM guest nic Secondary ip address for the port forwarding rule'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine for the port forwarding rule'}, {u'name': u'privateport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u"the starting port of port forwarding rule's private port range"}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'privateendport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u"the ending port of port forwarding rule's private port range"}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to forward traffic from'}, {u'name': u'publicport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u"the starting port of port forwarding rule's public port range"}], u'requiredparams': [u'ipaddressid', u'protocol', u'virtualmachineid', u'privateport', u'publicport'], u'response': [{u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the port forwarding rule belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'privateendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'privateport', u'description': u"the starting port of port forwarding rule's private port range"}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is firewall for display to the regular user'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'vmguestip', u'description': u'the vm ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the port forwarding rule'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the port forwarding rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'the VM display name for the port forwarding rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'the VM name for the port forwarding rule'}, {u'type': u'string', u'name': u'publicendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the VM ID for the port forwarding rule'}, {u'type': u'string', u'name': u'publicport', u'description': u"the starting port of port forwarding rule's public port range"}], u'description': u'Creates a port forwarding rule'}, u'pod': {u'name': u'createPod', u'related': [u'updatePod'], u'isasync': False, u'params': [{u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this Pod for allocation of new resources'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Pod'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID in which the Pod will be created'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway for the Pod'}, {u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address for the Pod'}, {u'name': u'startip', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the starting IP address for the Pod'}, {u'name': u'netmask', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask for the Pod'}], u'requiredparams': [u'name', u'zoneid', u'gateway', u'startip', u'netmask'], u'response': [{u'description': u'the capacity of the Pod', u'type': u'list', u'response': [{u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the Pod'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the Pod'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the Pod'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the Pod'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the Pod'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Pod'}, {u'type': u'string', u'name': u'startip', u'description': u'the starting IP for the Pod'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the Pod'}, {u'type': u'string', u'name': u'endip', u'description': u'the ending IP for the Pod'}], u'description': u'Creates a new Pod.'}, u'ipforwardingrule': {u'name': u'createIpForwardingRule', u'related': [u'updatePortForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'isasync': True, u'params': [{u'name': u'ipaddressid', u'required': True, u'related': [u'updateIpAddress', u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the public IP address id of the forwarding rule, already associated via associateIp'}, {u'name': u'protocol', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the rule. Valid values are TCP or UDP.'}, {u'name': u'openfirewall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, firewall rule for source/end pubic port is automatically created; if false - firewall rule has to be created explicitely. Has value true by default'}, {u'name': u'startport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the start port for the rule'}, {u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the end port for the rule'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to forward traffic from'}], u'requiredparams': [u'ipaddressid', u'protocol', u'startport'], u'response': [{u'type': u'string', u'name': u'virtualmachineid', u'description': u'the VM ID for the port forwarding rule'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'publicport', u'description': u"the starting port of port forwarding rule's public port range"}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'the VM display name for the port forwarding rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the port forwarding rule belongs to'}, {u'type': u'string', u'name': u'privateendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vmguestip', u'description': u'the vm ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'the VM name for the port forwarding rule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the port forwarding rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the port forwarding rule'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is firewall for display to the regular user'}, {u'type': u'string', u'name': u'privateport', u'description': u"the starting port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'publicendport', u'description': u"the ending port of port forwarding rule's private port range"}], u'description': u'Creates an ip forwarding rule'}, u'secondarystagingstore': {u'name': u'createSecondaryStagingStore', u'related': [u'listSwifts'], u'isasync': False, u'params': [{u'name': u'provider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the staging store provider name'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the staging store'}, {u'name': u'scope', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the scope of the staging store: zone only for now'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL for the staging store'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'the details for the staging store'}], u'requiredparams': [u'url'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}], u'description': u'create secondary staging store.'}, u'lbstickinesspolicy': {u'name': u'createLBStickinessPolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'param', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'param list. Example: param[0].name=cookiename&param[0].value=LBCookie '}, {u'name': u'methodname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the LB Stickiness policy method, possible values can be obtained from ListNetworks API '}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the LB Stickiness policy'}, {u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the description of the LB Stickiness policy'}], u'requiredparams': [u'methodname', u'name', u'lbruleid'], u'response': [{u'description': u'the list of stickinesspolicies', u'type': u'list', u'response': [{u'type': u'map', u'name': u'params', u'description': u'the params of the policy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB Stickiness policy ID'}, {u'type': u'string', u'name': u'methodname', u'description': u'the method name of the Stickiness policy'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}], u'name': u'stickinesspolicy'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Stickiness policy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Stickiness policy'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the Stickiness policy belongs to'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the Stickiness policy'}], u'description': u'Creates a Load Balancer stickiness policy '}, u'vpcoffering': {u'name': u'createVPCOffering', u'related': [u'listVPCOfferings'], u'isasync': True, u'params': [{u'name': u'servicecapabilitylist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'desired service capabilities as part of vpc offering'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the vpc offering'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the vpc offering'}, {u'name': u'serviceproviderlist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'provider to service mapping. If not specified, the provider for the service will be mapped to the default provider on the physical network'}, {u'name': u'serviceofferingid', u'required': False, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the service offering for the VPC router appliance'}, {u'name': u'supportedservices', u'required': True, u'related': [], u'length': 255, u'type': u'list', u'description': u'services supported by the vpc offering'}], u'requiredparams': [u'name', u'displaytext', u'supportedservices'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the vpc offering.'}, {u'type': u'string', u'name': u'state', u'description': u'state of the vpc offering. Can be Disabled/Enabled'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u' indicates if the vpc offering supports distributed router for one-hop forwarding'}, {u'type': u'date', u'name': u'created', u'description': u'the date this vpc offering was created'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the vpc offering'}, {u'type': u'boolean', u'name': u'supportsregionLevelvpc', u'description': u' indicated if the offering can support region level vpc'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if vpc offering is default, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the vpc offering'}], u'description': u'Creates VPC offering'}, u'network': {u'name': u'createNetwork', u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project for the ssh key'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the network'}, {u'name': u'isolatedpvlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the isolated private vlan for this network'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the VPC network belongs to'}, {u'name': u'startipv6', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IPv6 address in the IPv6 network range'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'network domain'}, {u'name': u'ip6cidr', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the CIDR of IPv6 network, must be at least /64'}, {u'name': u'gateway', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway of the network. Required for Shared networks and Isolated networks when it belongs to VPC'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID the network belongs to'}, {u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address in the network IP range. If not specified, will be defaulted to startIP'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the network'}, {u'name': u'networkofferingid', u'required': True, u'related': [u'createNetworkOffering', u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'the network offering id'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the network'}, {u'name': u'ip6gateway', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway of the IPv6 network. Required for Shared networks'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a network'}, {u'name': u'startip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IP address in the network IP range'}, {u'name': u'subdomainaccess', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Defines whether to allow subdomains to use networks dedicated to their parent domain(s). Should be used with aclType=Domain, defaulted to allow.subdomain.network.access global config if not specified'}, {u'name': u'endipv6', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IPv6 address in the IPv6 network range'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ID or VID of the network'}, {u'name': u'aclid', u'required': False, u'related': [u'listNetworkACLLists', u'createNetworkACLList'], u'length': 255, u'type': u'uuid', u'description': u'Network ACL Id associated for the network'}, {u'name': u'acltype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Access control type; supported values are account and domain. In 3.0 all shared networks should have aclType=Domain, and all Isolated networks - Account. Account means that only the account owner can use the network, domain - all accouns in the domain can use the network'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will own the network'}, {u'name': u'netmask', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask of the network. Required for Shared networks and Isolated networks when it belongs to VPC'}, {u'name': u'displaynetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the network to the end user or not.'}], u'requiredparams': [u'displaytext', u'zoneid', u'networkofferingid', u'name'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}], u'description': u'Creates a network'}, u'zone': {u'name': u'createZone', u'related': [u'listZones', u'listZones'], u'isasync': False, u'params': [{u'name': u'ip6dns1', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first DNS for IPv6 network in the Zone'}, {u'name': u'dns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second DNS for the Zone'}, {u'name': u'securitygroupenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network is security group enabled, false otherwise'}, {u'name': u'dns1', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first DNS for the Zone'}, {u'name': u'domain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Network domain name for the networks in the zone'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain, null for public zones'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Zone'}, {u'name': u'internaldns1', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first internal DNS for the Zone'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this Zone for allocation of new resources'}, {u'name': u'internaldns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second internal DNS for the Zone'}, {u'name': u'ip6dns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second DNS for IPv6 network in the Zone'}, {u'name': u'guestcidraddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the guest CIDR address for the Zone'}, {u'name': u'networktype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'network type of the zone, can be Basic or Advanced'}, {u'name': u'localstorageenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if local storage offering enabled, false otherwise'}], u'requiredparams': [u'dns1', u'name', u'internaldns1', u'networktype'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'the display text of the zone'}, {u'description': u'the capacity of the Zone', u'type': u'list', u'response': [{u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the Zone'}, {u'type': u'boolean', u'name': u'localstorageenabled', u'description': u'true if local storage offering enabled, false otherwise'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the Zone'}, {u'type': u'string', u'name': u'internaldns2', u'description': u'the second internal DNS for the Zone'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the Zone'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'type': u'string', u'name': u'networktype', u'description': u'the network type of the zone; can be Basic or Advanced'}, {u'type': u'string', u'name': u'internaldns1', u'description': u'the first internal DNS for the Zone'}, {u'type': u'string', u'name': u'id', u'description': u'Zone id'}, {u'type': u'string', u'name': u'domainid', u'description': u'the UUID of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'name', u'description': u'Zone name'}, {u'description': u'the list of resource tags associated with zone.', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'guestcidraddress', u'description': u'the guest CIDR address for the Zone'}, {u'type': u'map', u'name': u'resourcedetails', u'description': u'Meta data associated with the zone (key/value pairs)'}, {u'type': u'string', u'name': u'description', u'description': u'Zone description'}, {u'type': u'string', u'name': u'dhcpprovider', u'description': u'the dhcp Provider for the Zone'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the Zone'}, {}, {u'type': u'string', u'name': u'domainname', u'description': u'the name of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'domain', u'description': u'Network domain name for the networks in the zone'}, {u'type': u'string', u'name': u'zonetoken', u'description': u'Zone Token'}, {u'type': u'boolean', u'name': u'securitygroupsenabled', u'description': u'true if security groups support is enabled, false otherwise'}], u'description': u'Creates a Zone.'}, u'remoteaccessvpn': {u'name': u'createRemoteAccessVpn', u'related': [], u'isasync': True, u'params': [{u'name': u'iprange', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the range of ip addresses to allocate to vpn clients. The first ip in the range will be taken by the vpn server'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}, {u'name': u'openfirewall', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, firewall rule for source/end pubic port is automatically created; if false - firewall rule has to be created explicitely. Has value true by default'}, {u'name': u'publicipid', u'required': True, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'public ip address id of the vpn server'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the VPN. Must be used with domainId.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the VPN. If the account parameter is used, domainId must also be used.'}], u'requiredparams': [u'publicipid'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'presharedkey', u'description': u'the ipsec preshared key'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the account of the remote access vpn'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the remote access vpn'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the remote access vpn'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the account of the remote access vpn'}, {u'type': u'string', u'name': u'iprange', u'description': u'the range of ips to allocate to the clients'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn for display to the regular user'}], u'description': u'Creates a l2tp/ipsec remote access vpn'}, u'instancegroup': {u'name': u'createInstanceGroup', u'related': [u'updateInstanceGroup'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID of account owning the instance group'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account of the instance group. The account parameter must be used with the domainId parameter.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'The project of the instance group'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the instance group'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the instance group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'date', u'name': u'created', u'description': u'time and date the instance group was created'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the instance group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the instance group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the instance group'}], u'description': u'Creates a vm group'}, u'autoscalepolicy': {u'name': u'createAutoScalePolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'conditionids', u'required': True, u'related': [], u'length': 255, u'type': u'list', u'description': u'the list of IDs of the conditions that are being evaluated on every interval'}, {u'name': u'quiettime', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the cool down period for which the policy should not be evaluated after the action has been taken'}, {u'name': u'action', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the action to be executed if all the conditions evaluate to true for the specified duration.'}, {u'name': u'duration', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the duration for which the conditions have to be true before action is taken'}], u'requiredparams': [u'conditionids', u'action', u'duration'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the autoscale policy'}, {u'type': u'string', u'name': u'action', u'description': u'the action to be executed if all the conditions evaluate to true for the specified duration.'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale policy ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the autoscale policy'}, {u'type': u'integer', u'name': u'duration', u'description': u'the duration for which the conditions have to be true before action is taken'}, {u'type': u'list', u'name': u'conditions', u'description': u'the list of IDs of the conditions that are being evaluated on every interval'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id autoscale policy'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the autoscale policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the autoscale policy'}, {u'type': u'integer', u'name': u'quiettime', u'description': u'the cool down period for which the policy should not be evaluated after the action has been taken'}], u'description': u'Creates an autoscale policy for a provision or deprovision action, the action is taken when the all the conditions evaluates to true for the specified duration. The policy is in effect once it is attached to a autscale vm group.'}, u'globalloadbalancerrule': {u'name': u'createGlobalLoadBalancerRule', u'related': [u'listGlobalLoadBalancerRules', u'updateGlobalLoadBalancerRule'], u'isasync': True, u'params': [{u'name': u'description', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the description of the load balancer rule'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the load balancer'}, {u'name': u'regionid', u'required': True, u'related': [u'listRegions', u'addRegion'], u'length': 255, u'type': u'integer', u'description': u'region where the global load balancer is going to be created.'}, {u'name': u'gslbservicetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'GSLB service type (tcp, udp, http)'}, {u'name': u'gslbdomainname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'domain name for the GSLB service.'}, {u'name': u'gslblbmethod', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"load balancer algorithm (roundrobin, leastconn, proximity) that method is used to distribute traffic across the zones participating in global server load balancing, if not specified defaults to 'round robin'"}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the load balancer rule'}, {u'name': u'gslbstickysessionmethodname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'session sticky method (sourceip) if not specified defaults to sourceip'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the global load balancer. Must be used with the domainId parameter.'}], u'requiredparams': [u'regionid', u'gslbservicetype', u'gslbdomainname', u'name'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'name of the global load balancer rule'}, {u'type': u'string', u'name': u'id', u'description': u'global load balancer rule ID'}, {u'description': u'List of load balancer rules that are part of GSLB rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}], u'name': u'loadbalancerrule'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which global load balancer is created'}, {u'type': u'string', u'name': u'gslbdomainname', u'description': u'DNS domain name given for the global load balancer'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'gslbservicetype', u'description': u'GSLB service type'}, {u'type': u'string', u'name': u'gslbstickysessionmethodname', u'description': u'session persistence method used for the global load balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'gslblbmethod', u'description': u'Load balancing method used for the global load balancer'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the global load balancer rule'}], u'description': u'Creates a global load balancer rule'}, u'portableiprange': {u'name': u'createPortableIpRange', u'related': [u'listPortableIpRanges'], u'isasync': True, u'params': [{u'name': u'netmask', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask of the portable IP range'}, {u'name': u'startip', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IP address in the portable IP range'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway for the portable IP range'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'VLAN id, if not specified defaulted to untagged'}, {u'name': u'regionid', u'required': True, u'related': [u'listRegions', u'updateRegion', u'addRegion'], u'length': 255, u'type': u'integer', u'description': u'Id of the Region'}, {u'name': u'endip', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address in the portable IP range'}], u'requiredparams': [u'netmask', u'startip', u'gateway', u'regionid', u'endip'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'portable IP range ID'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the portable IP range'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the VLAN IP range'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which portable ip range is provisioned'}, {u'type': u'string', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the VLAN IP range'}, {u'description': u'List of portable IP and association with zone/network/vpc details that are part of GSLB rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which global load balancer is created'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the portable IP address is associated with'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID the portable IP address is associated with'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the portal IP address was acquired'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}], u'name': u'portableipaddress'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the portable IP range'}], u'description': u"adds a range of portable public IP's to a region"}, u'serviceoffering': {u'name': u'createServiceOffering', u'related': [u'listServiceOfferings'], u'isasync': False, u'params': [{u'name': u'hypervisorsnapshotreserve', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'name': u'memory', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the total memory of the service offering in MB'}, {u'name': u'iopswriterate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'io requests write rate of the disk offering'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the service offering'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the service offering'}, {u'name': u'bytesreadrate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes read rate of the disk offering'}, {u'name': u'byteswriterate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes write rate of the disk offering'}, {u'name': u'isvolatile', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the virtual machine needs to be volatile so that on every reboot of VM, original root disk is dettached then destroyed and a fresh root disk is created and attached to VM'}, {u'name': u'cpuspeed', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the CPU speed of the service offering in MHz.'}, {u'name': u'offerha', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'the HA for the service offering'}, {u'name': u'iopsreadrate', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'io requests read rate of the disk offering'}, {u'name': u'miniops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'min iops of the compute offering'}, {u'name': u'cpunumber', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the CPU number of the service offering'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the tags for this service offering.'}, {u'name': u'deploymentplanner', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The deployment planner heuristics used to deploy a VM of this offering. If null, value of global config vm.deployment.planner is used'}, {u'name': u'hosttags', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the host tag for this service offering.'}, {u'name': u'provisioningtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'name': u'customizediops', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'whether compute offering iops is custom or not'}, {u'name': u'networkrate', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'data transfer rate in megabits per second allowed. Supported only for non-System offering and system offerings having "domainrouter" systemvmtype'}, {u'name': u'serviceofferingdetails', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'details for planner, used to store specific parameters'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain, null for public offerings'}, {u'name': u'limitcpuuse', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'restrict the CPU usage to committed service offering'}, {u'name': u'systemvmtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the system VM type. Possible types are "domainrouter", "consoleproxy" and "secondarystoragevm".'}, {u'name': u'issystem', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'is this a system vm offering'}, {u'name': u'maxiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'max iops of the compute offering'}, {u'name': u'storagetype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the storage type of the service offering. Values are local and shared.'}], u'requiredparams': [u'name', u'displaytext'], u'response': [{u'type': u'string', u'name': u'hosttags', u'description': u'the host tag for the service offering'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the service offering'}, {u'type': u'boolean', u'name': u'offerha', u'description': u'the ha support in the service offering'}, {u'type': u'boolean', u'name': u'limitcpuuse', u'description': u'restrict the CPU usage to committed service offering'}, {u'type': u'map', u'name': u'serviceofferingdetails', u'description': u'additional key/value details tied with this service offering'}, {u'type': u'string', u'name': u'deploymentplanner', u'description': u'deployment strategy used to deploy VM.'}, {u'type': u'boolean', u'name': u'isvolatile', u'description': u'true if the vm needs to be volatile, i.e., on every reboot of vm from API root disk is discarded and creates a new root disk'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the clock rate CPU speed in Mhz'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the service offering.'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'is true if the offering is customized'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the service offering'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of CPU'}, {u'type': u'string', u'name': u'domain', u'description': u'Domain name for the offering'}, {u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'date', u'name': u'created', u'description': u'the date this service offering was created'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the service offering'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'is this a system vm offering'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the service offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the service offering'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the service offering'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'is this a the systemvm type for system vm offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the service offering'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory in MB'}, {u'type': u'boolean', u'name': u'defaultuse', u'description': u'is this a  default system vm offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this service offering'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the service offering'}], u'description': u'Creates a service offering.'}, u'template': {u'name': u'createTemplate', u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': True, u'params': [{u'name': u'ostypeid', u'required': True, u'related': [u'addGuestOs', u'updateGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS Type that best represents the OS of this template.'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this template is a public template, false otherwise'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'Template details in key/value pairs.'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the display text of the template. This is usually used for display purposes.'}, {u'name': u'requireshvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template requres HVM, false otherwise'}, {u'name': u'bits', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'32 or 64 bit'}, {u'name': u'passwordenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template supports the password reset feature; default is false'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Optional, VM ID. If this presents, it is going to create a baremetal template for VM this ID refers to. This is only for VM whose hypervisor type is BareMetal'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Optional, only for baremetal hypervisor. The directory name where template stored on CIFS server'}, {u'name': u'snapshotid', u'required': False, u'related': [u'createSnapshot', u'listSnapshots', u'revertSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the snapshot the template is being created from. Either this parameter, or volumeId has to be passed in'}, {u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'name': u'volumeid', u'required': False, u'related': [u'migrateVolume', u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume the template is being created from. Either this parameter, or snapshotId has to be passed in'}, {u'name': u'templatetag', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the tag for this template.'}, {u'name': u'isfeatured', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this template is a featured template, false otherwise'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the template'}], u'requiredparams': [u'ostypeid', u'displaytext', u'name'], u'response': [{u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}], u'description': u'Creates a template of a virtual machine. The virtual machine must be in a STOPPED state. A template created from this command is automatically designated as a private template visible to the account that created it.'}, u'vpngateway': {u'name': u'createVpnGateway', u'related': [u'updateVpnGateway'], u'isasync': True, u'params': [{u'name': u'vpcid', u'required': True, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'public ip address id of the vpn gateway'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}], u'requiredparams': [u'vpcid'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'string', u'name': u'vpcid', u'description': u'the vpc id of this gateway'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn gateway for display to the regular user'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}], u'description': u'Creates site to site vpn local gateway'}, u'networkacllist': {u'name': u'createNetworkACLList', u'related': [], u'isasync': True, u'params': [{u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the network ACL List'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Description of the network ACL List'}, {u'name': u'vpcid', u'required': True, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'Id of the VPC associated with this network ACL List'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the list to the end user or not'}], u'requiredparams': [u'name', u'vpcid'], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is ACL for display to the regular user'}, {u'type': u'string', u'name': u'name', u'description': u'the Name of the ACL'}, {u'type': u'string', u'name': u'description', u'description': u'Description of the ACL'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ACL'}, {u'type': u'string', u'name': u'vpcid', u'description': u'Id of the VPC this ACL is associated with'}], u'description': u'Creates a Network ACL for the given VPC'}, u'autoscalevmgroup': {u'name': u'createAutoScaleVmGroup', u'related': [u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup'], u'isasync': True, u'params': [{u'name': u'vmprofileid', u'required': True, u'related': [u'listAutoScaleVmProfiles'], u'length': 255, u'type': u'uuid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'name': u'interval', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the group to the end user or not'}, {u'name': u'minmembers', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'name': u'scaledownpolicyids', u'required': True, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy'], u'length': 255, u'type': u'list', u'description': u'list of scaledown autoscale policies'}, {u'name': u'maxmembers', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'name': u'scaleuppolicyids', u'required': True, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy'], u'length': 255, u'type': u'list', u'description': u'list of scaleup autoscale policies'}], u'requiredparams': [u'vmprofileid', u'lbruleid', u'minmembers', u'scaledownpolicyids', u'maxmembers', u'scaleuppolicyids'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the autoscale vm group ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is group for display to the regular user'}, {u'type': u'string', u'name': u'vmprofileid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'type': u'int', u'name': u'maxmembers', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'int', u'name': u'interval', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'type': u'list', u'name': u'scaleuppolicies', u'description': u'list of scaleup autoscale policies'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'int', u'name': u'minmembers', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'type': u'string', u'name': u'state', u'description': u'the current state of the AutoScale Vm Group'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the load balancer rule ID'}, {u'type': u'list', u'name': u'scaledownpolicies', u'description': u'list of scaledown autoscale policies'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}], u'description': u'Creates and automatically starts a virtual machine based on a service offering, disk offering, and template.'}, u'vpnconnection': {u'name': u'createVpnConnection', u'related': [u'resetVpnConnection', u'updateVpnConnection', u'listVpnConnections'], u'isasync': True, u'params': [{u'name': u's2svpngatewayid', u'required': True, u'related': [u'createVpnGateway', u'listVpnGateways', u'updateVpnGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of the vpn gateway'}, {u'name': u's2scustomergatewayid', u'required': True, u'related': [u'listVpnCustomerGateways', u'updateVpnCustomerGateway', u'createVpnCustomerGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of the customer gateway'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}, {u'name': u'passive', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'connection is passive or not'}], u'requiredparams': [u's2svpngatewayid', u's2scustomergatewayid'], u'response': [{u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'boolean', u'name': u'passive', u'description': u'State of vpn connection'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'ESP policy of the customer gateway'}, {u'type': u'string', u'name': u'id', u'description': u'the connection ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'string', u'name': u'state', u'description': u'State of vpn connection'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is connection for display to the regular user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u's2scustomergatewayid', u'description': u'the customer gateway ID'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of the customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u's2svpngatewayid', u'description': u'the vpn gateway ID'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}], u'description': u'Create site to site vpn connection'}, u'networkacl': {u'name': u'createNetworkACL', u'related': [], u'isasync': True, u'params': [{u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to allow traffic from/to'}, {u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the starting port of ACL'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The network of the vm the ACL will be created for'}, {u'name': u'aclid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The network of the vm the ACL will be created for'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'action', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'scl entry action, allow or deny'}, {u'name': u'number', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'The network of the vm the ACL will be created for'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the traffic type for the ACL,can be Ingress or Egress, defaulted to Ingress if not specified'}, {u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the ending port of ACL'}, {u'name': u'protocol', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the ACL rule. Valid values are TCP/UDP/ICMP/ALL or valid protocol number'}], u'requiredparams': [u'protocol'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the ACL Item'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of ACL's port range"}, {u'type': u'string', u'name': u'aclid', u'description': u'the ID of the ACL this item belongs to'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the ACL'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of ACL's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'integer', u'name': u'number', u'description': u'Number of the ACL Item'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the ACL'}, {u'type': u'string', u'name': u'action', u'description': u'Action of ACL Item. Allow/Deny'}, {u'description': u'the list of resource tags associated with the network ACLs', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}], u'description': u'Creates a ACL rule in the given network (the network has to belong to VPC)'}, u'storagepool': {u'name': u'createStoragePool', u'related': [u'listStoragePools', u'findStoragePoolsForMigration'], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the storage pool'}, {u'name': u'managed', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'whether the storage should be managed by CloudStack'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'the details for the storage pool'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL of the storage pool'}, {u'name': u'scope', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the scope of the storage: cluster or zone'}, {u'name': u'clusterid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID for the storage pool'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the hosts in zone that will be attached to this storage pool. KVM, VMware supported as of now.'}, {u'name': u'provider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the storage provider name'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the storage pool'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name for the storage pool'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the tags for the storage pool'}, {u'name': u'capacitybytes', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes CloudStack can provision from this storage pool'}, {u'name': u'capacityiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'IOPS CloudStack can provision from this storage pool'}], u'requiredparams': [u'zoneid', u'url', u'name'], u'response': [{u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}], u'description': u'Creates a storage pool.'}, u'vmsnapshot': {u'name': u'createVMSnapshot', u'related': [u'listVMSnapshot'], u'isasync': True, u'params': [{u'name': u'quiescevm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'quiesce vm if true'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The display name of the snapshot'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the vm'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The discription of the snapshot'}, {u'name': u'snapshotmemory', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'snapshot memory if true'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the vm snapshot'}, {u'type': u'string', u'name': u'parent', u'description': u'the parent ID of the vm snapshot'}, {u'type': u'string', u'name': u'displayname', u'description': u'the display name of the vm snapshot'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the vm snapshot'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the vm ID of the vm snapshot'}, {u'type': u'string', u'name': u'parentName', u'description': u'the parent displayName of the vm snapshot'}, {u'type': u'boolean', u'name': u'current', u'description': u'indiates if this is current snapshot'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the vm snapshot'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the vm snapshot'}, {u'type': u'string', u'name': u'type', u'description': u'VM Snapshot type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'date', u'name': u'created', u'description': u'the create date of the vm snapshot'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the vm snapshot'}], u'description': u'Creates snapshot for a vm.'}, u'tags': {u'name': u'createTags', u'related': [], u'isasync': True, u'params': [{u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of the resource'}, {u'name': u'resourceids', u'required': True, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of resources to create the tags for'}, {u'name': u'customer', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"identifies client specific tag. When the value is not null, the tag can't be used by cloudStack code internally"}, {u'name': u'tags', u'required': True, u'related': [], u'length': 255, u'type': u'map', u'description': u'Map of tags (key/value pairs)'}], u'requiredparams': [u'resourcetype', u'resourceids', u'tags'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Creates resource tag(s)'}, u'staticroute': {u'name': u'createStaticRoute', u'related': [u'listStaticRoutes'], u'isasync': True, u'params': [{u'name': u'gatewayid', u'required': True, u'related': [u'createPrivateGateway'], u'length': 255, u'type': u'uuid', u'description': u'the gateway id we are creating static route for'}, {u'name': u'cidr', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'static route cidr'}], u'requiredparams': [u'gatewayid', u'cidr'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the static route'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the static route'}, {u'type': u'string', u'name': u'cidr', u'description': u'static route CIDR'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the static route'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the static route'}, {u'description': u'the list of resource tags associated with static route', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the static route'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the static route'}, {u'type': u'string', u'name': u'gatewayid', u'description': u'VPC gateway the route is created for'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of static route'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the static route belongs to'}], u'description': u'Creates a static route'}, u'volume': {u'name': u'createVolume', u'related': [u'listVolumes', u'migrateVolume', u'uploadVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'snapshotid', u'required': False, u'related': [u'createSnapshot', u'revertSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'the snapshot ID for the disk volume. Either diskOfferingId or snapshotId must be passed in.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the disk volume'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the disk volume. Must be used with the domainId parameter.'}, {u'name': u'size', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Arbitrary volume size'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the availability zone'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'maxiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'max iops'}, {u'name': u'diskofferingid', u'required': False, u'related': [u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk offering. Either diskOfferingId or snapshotId must be passed in.'}, {u'name': u'displayvolume', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to display the volume to the end user or not.'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine; to be used with snapshot Id, VM to which the volume gets attached after creation'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'the project associated with the volume. Mutually exclusive with account parameter'}, {u'name': u'miniops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'min iops'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the disk offering. If used with the account parameter returns the disk volume associated with the account for the specified domain.'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}], u'description': u'Creates a disk volume from a disk offering. This disk volume must still be attached to a virtual machine to make use of it.'}, u'user': {u'name': u'createUser', u'related': [u'lockUser', u'disableUser', u'getUser', u'listUsers', u'updateUser'], u'isasync': False, u'params': [{u'name': u'lastname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'lastname'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Creates the user under the specified domain. Has to be accompanied with the account parameter'}, {u'name': u'firstname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'firstname'}, {u'name': u'email', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'email'}, {u'name': u'timezone', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}, {u'name': u'userid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'User UUID, required for adding account from external provisioning system'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Clear text password (Default hashed to SHA256SALT). If you wish to use any other hashing algorithm, you would need to write a custom authentication adapter See Docs section.'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique username.'}, {u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Creates the user under the specified account. If no account is specified, the username will be used as the account name.'}], u'requiredparams': [u'lastname', u'firstname', u'email', u'password', u'username', u'account'], u'response': [{u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}], u'description': u'Creates a user for an account that already exists'}, u'vpc': {u'name': u'createVPC', u'related': [u'listVPCs', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the VPC. If used with the account parameter returns the VPC associated with the account for the specified domain.'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the VPC'}, {u'name': u'start', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"If set to false, the VPC won't start (VPC VR will not get allocated) until its first network gets implemented. True by default."}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the availability zone'}, {u'name': u'cidr', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u"the cidr of the VPC. All VPC guest networks' cidrs should be within this CIDR"}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'create VPC for the project'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpc to the end user or not'}, {u'name': u'vpcofferingid', u'required': True, u'related': [u'listVPCOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the VPC offering'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the VPC. Must be used with the domainId parameter.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the VPC'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'VPC network domain. All networks inside the VPC will belong to this domain'}], u'requiredparams': [u'displaytext', u'zoneid', u'cidr', u'vpcofferingid', u'name'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the id of the VPC'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the vpc'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the VPC'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the VPC'}, {u'type': u'boolean', u'name': u'regionlevelvpc', u'description': u'true if VPC is region level'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the VPC belongs to'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the VPC.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the VPC'}, {u'description': u'the list of resource tags associated with the project', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'cidr', u'description': u'the cidr the VPC'}, {u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u"is VPC uses distributed router for one hop forwarding and host based network ACL's"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the VPC owner'}, {u'type': u'string', u'name': u'state', u'description': u'state of the VPC. Can be Inactive/Enabled'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpc for display to the regular user'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain of the VPC'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true VPC requires restart'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the VPC'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'description': u'the list of networks belongign to the VPC', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}], u'name': u'network'}, {u'type': u'date', u'name': u'created', u'description': u'the date this VPC was created'}, {u'type': u'string', u'name': u'vpcofferingid', u'description': u'vpc offering id the VPC is created from'}], u'description': u'Creates a VPC'}, u'storagenetworkiprange': {u'name': u'createStorageNetworkIpRange', u'related': [u'listStorageNetworkIpRange', u'updateStorageNetworkIpRange'], u'isasync': True, u'params': [{u'name': u'startip', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IP address'}, {u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'UUID of pod where the ip range belongs to'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Optional. The vlan the ip range sits on, default to Null when it is not specificed which means you network is not on any Vlan. This is mainly for Vmware as other hypervisors can directly reterive bridge from pyhsical network traffic type table'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway for storage network'}, {u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address'}, {u'name': u'netmask', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask for storage network'}], u'requiredparams': [u'startip', u'podid', u'gateway', u'netmask'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the Zone uuid of the storage network IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of storage network IP range.'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod uuid for the storage network IP range'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the storage network IP range'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the storage network IP range'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the storage network IP range'}, {u'type': u'integer', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network uuid of storage network IP range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the storage network IP range'}], u'description': u'Creates a Storage network IP range.'}, u'condition': {u'name': u'createCondition', u'related': [u'listConditions'], u'isasync': True, u'params': [{u'name': u'threshold', u'required': True, u'related': [], u'length': 255, u'type': u'long', u'description': u'Threshold value.'}, {u'name': u'relationaloperator', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Relational Operator to be used with threshold.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID of the account.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account of the condition. Must be used with the domainId parameter.'}, {u'name': u'counterid', u'required': True, u'related': [u'createCounter', u'listCounters'], u'length': 255, u'type': u'uuid', u'description': u'ID of the Counter.'}], u'requiredparams': [u'threshold', u'relationaloperator', u'counterid'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the Condition'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the Condition owner'}, {u'type': u'list', u'name': u'counter', u'description': u'Details of the Counter.'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of counter'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the Condition.'}, {u'type': u'long', u'name': u'threshold', u'description': u'Threshold Value for the counter.'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the Condition'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the Condition.'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner.'}, {u'type': u'string', u'name': u'relationaloperator', u'description': u'Relational Operator to be used with threshold.'}], u'description': u'Creates a condition'}, u'autoscalevmprofile': {u'name': u'createAutoScaleVmProfile', u'related': [u'updateAutoScaleVmProfile', u'listAutoScaleVmProfiles'], u'isasync': True, u'params': [{u'name': u'otherdeployparams', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'parameters other than zoneId/serviceOfferringId/templateId of the auto deployed virtual machine'}, {u'name': u'destroyvmgraceperiod', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the time allowed for existing connections to get closed before a vm is destroyed'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the profile to the end user or not'}, {u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'updateServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the service offering of the auto deployed virtual machine'}, {u'name': u'autoscaleuserid', u'required': False, u'related': [u'lockUser', u'disableUser', u'enableUser', u'getUser', u'listUsers', u'updateUser', u'createUser'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the user used to launch and destroy the VMs'}, {u'name': u'counterparam', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'counterparam list. Example: counterparam[0].name=snmpcommunity&counterparam[0].value=public&counterparam[1].name=snmpport&counterparam[1].value=161'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'availability zone for the auto deployed virtual machine'}, {u'name': u'templateid', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the template of the auto deployed virtual machine'}], u'requiredparams': [u'serviceofferingid', u'zoneid', u'templateid'], u'response': [{u'type': u'integer', u'name': u'destroyvmgraceperiod', u'description': u'the time allowed for existing connections to get closed before a vm is destroyed'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'autoscaleuserid', u'description': u'the ID of the user used to launch and destroy the VMs'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is profile for display to the regular user'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the availability zone to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm profile ID'}, {u'type': u'string', u'name': u'otherdeployparams', u'description': u'parameters other than zoneId/serviceOfferringId/templateId to be used while deploying a virtual machine'}, {}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the service offering to be used while deploying a virtual machine'}], u'description': u'Creates a profile that contains information about the virtual machine which will be provisioned automatically by autoscale feature.'}, u'affinitygroup': {u'name': u'createAffinityGroup', u'related': [u'listAffinityGroups'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'domainId of the account owning the affinity group'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the affinity group'}, {u'name': u'type', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Type of the affinity group from the available affinity/anti-affinity group types'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'optional description of the affinity group'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an account for the affinity group. Must be used with domainId.'}], u'requiredparams': [u'name', u'type'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'description': u'Creates an affinity/anti-affinity group'}, u'account': {u'name': u'createAccount', u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount', u'disableAccount'], u'isasync': False, u'params': [{u'name': u'email', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'email'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Creates the user under the specified account. If no account is specified, the username will be used as the account name.'}, {u'name': u'accountdetails', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'details for account used to store specific parameters'}, {u'name': u'userid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'User UUID, required for adding account from external provisioning system'}, {u'name': u'firstname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'firstname'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique username.'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Clear text password (Default hashed to SHA256SALT). If you wish to use any other hashing algorithm, you would need to write a custom authentication adapter See Docs section.'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"Network domain for the account's networks"}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Creates the user under the specified domain.'}, {u'name': u'lastname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'lastname'}, {u'name': u'accountid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Account UUID, required for adding account from external provisioning system'}, {u'name': u'timezone', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}, {u'name': u'accounttype', u'required': True, u'related': [], u'length': 255, u'type': u'short', u'description': u'Type of the account.  Specify 0 for user, 1 for root admin, and 2 for domain admin'}], u'requiredparams': [u'email', u'firstname', u'username', u'password', u'lastname', u'accounttype'], u'response': [{u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}], u'name': u'user'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}], u'description': u'Creates an account'}, u'firewallrule': {u'name': u'createFirewallRule', u'related': [u'listEgressFirewallRules'], u'isasync': True, u'params': [{u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of firewallrule: system/user'}, {u'name': u'protocol', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the firewall rule. Valid values are TCP/UDP/ICMP.'}, {u'name': u'ipaddressid', u'required': True, u'related': [u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the IP address id of the port forwarding rule'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the starting port of firewall rule'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to forward traffic from'}, {u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the ending port of firewall rule'}], u'requiredparams': [u'protocol', u'ipaddressid'], u'response': [{u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}], u'description': u'Creates a firewall rule for a given ip address'}, u'networkoffering': {u'name': u'createNetworkOffering', u'related': [u'updateNetworkOffering'], u'isasync': False, u'params': [{u'name': u'conservemode', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the network offering is IP conserve mode enabled'}, {u'name': u'traffictype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the traffic type for the network offering. Supported type in current release is GUEST only'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the network offering'}, {u'name': u'guestiptype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'guest type of the network offering: Shared or Isolated'}, {u'name': u'serviceproviderlist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'provider to service mapping. If not specified, the provider for the service will be mapped to the default provider on the physical network'}, {u'name': u'keepaliveenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true keepalive will be turned on in the loadbalancer. At the time of writing this has only an effect on haproxy; the mode http and httpclose options are unset in the haproxy conf file.'}, {u'name': u'specifyvlan', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network offering supports vlans'}, {u'name': u'ispersistent', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network offering supports persistent networks; defaulted to false if not specified'}, {u'name': u'networkrate', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'data transfer rate in megabits per second allowed'}, {u'name': u'availability', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the availability of network offering. Default value is Optional'}, {u'name': u'servicecapabilitylist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'desired service capabilities as part of network offering'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'Network offering details in key/value pairs. Supported keys are internallbprovider/publiclbprovider with service provider as a value'}, {u'name': u'specifyipranges', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network offering supports specifying ip ranges; defaulted to false if not specified'}, {u'name': u'egressdefaultpolicy', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if guest network default egress policy is allow; false if default egress policy is deny'}, {u'name': u'supportedservices', u'required': True, u'related': [], u'length': 255, u'type': u'list', u'description': u'services supported by the network offering'}, {u'name': u'maxconnections', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'maximum number of concurrent connections supported by the network offering'}, {u'name': u'serviceofferingid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the service offering ID used by virtual router provider'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the network offering'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the tags for the network offering.'}], u'requiredparams': [u'traffictype', u'displaytext', u'guestiptype', u'supportedservices', u'name'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the network offering'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the network offering'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'true if network offering supports persistent networks, false otherwise'}, {u'type': u'boolean', u'name': u'specifyvlan', u'description': u'true if network offering supports vlans, false otherwise'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the network offering.'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network offering is default, false otherwise'}, {u'type': u'boolean', u'name': u'egressdefaultpolicy', u'description': u'true if guest network default egress policy is allow; false if default egress policy is deny'}, {u'type': u'integer', u'name': u'maxconnections', u'description': u'maximum number of concurrents connections to be handled by lb'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network offering supports specifying ip ranges, false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with network offering'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'string', u'name': u'availability', u'description': u'availability of the network offering'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network offering. Can be Disabled/Enabled/Inactive'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the network offering, supported types are Public, Management, Control, Guest, Vlan or Storage.'}, {u'type': u'boolean', u'name': u'conservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network offering'}, {u'type': u'boolean', u'name': u'forvpc', u'description': u'true if network offering can be used by VPC networks only'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'guestiptype', u'description': u'guest type of the network offering, can be Shared or Isolated'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering used by virtual router provider'}, {u'type': u'boolean', u'name': u'supportsstrechedl2subnet', u'description': u'true if network offering supports network that span multiple zones'}, {u'type': u'date', u'name': u'created', u'description': u'the date this network offering was created'}], u'description': u'Creates a network offering.'}, u'vlaniprange': {u'name': u'createVlanIpRange', u'related': [u'listVlanIpRanges', u'dedicatePublicIpRange'], u'isasync': False, u'params': [{u'name': u'endipv6', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IPv6 address in the IPv6 network range'}, {u'name': u'startip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IP address in the VLAN IP range'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the physical network id'}, {u'name': u'forvirtualnetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if VLAN is of Virtual type, false if Direct'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID of the VLAN IP range'}, {u'name': u'netmask', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask of the VLAN IP range'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the network id'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will own the VLAN. If VLAN is Zone wide, this parameter should be ommited'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'optional parameter. Have to be specified for Direct Untagged vlan only.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a VLAN'}, {u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address in the VLAN IP range'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ID or VID of the VLAN. If not specified, will be defaulted to the vlan of the network or if vlan of the network is null - to Untagged'}, {u'name': u'ip6gateway', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway of the IPv6 network. Required for Shared networks and Isolated networks when it belongs to VPC'}, {u'name': u'startipv6', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IPv6 address in the IPv6 network range'}, {u'name': u'ip6cidr', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the CIDR of IPv6 network, must be at least /64'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'project who will own the VLAN. If VLAN is Zone wide, this parameter should be ommited'}, {u'name': u'gateway', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway of the VLAN IP range'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the VLAN IP range'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the VLAN IP range'}, {u'type': u'string', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the VLAN IP range'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the VLAN IP range'}, {u'type': u'string', u'name': u'startipv6', u'description': u'the start ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vlan range'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vlan range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the VLAN IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the VLAN IP range'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the VLAN IP range'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the VLAN IP range'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the VLAN IP range'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of vlan range'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the VLAN IP range'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name for the VLAN IP range'}, {u'type': u'string', u'name': u'endipv6', u'description': u'the end ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the VLAN IP range'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the VLAN IP range'}], u'description': u'Creates a VLAN IP range.'}, u'internalloadbalancerelement': {u'name': u'createInternalLoadBalancerElement', u'related': [u'configureInternalLoadBalancerElement'], u'isasync': True, u'params': [{u'name': u'nspid', u'required': True, u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'the network service provider ID of the internal load balancer element'}], u'requiredparams': [u'nspid'], u'response': [{u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the element'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the internal load balancer element'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the element'}], u'description': u'Create an Internal Load Balancer element.'}, u'counter': {u'name': u'createCounter', u'related': [], u'isasync': True, u'params': [{u'name': u'value', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Value of the counter e.g. oid in case of snmp.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the counter.'}, {u'name': u'source', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Source of the counter.'}], u'requiredparams': [u'value', u'name', u'source'], u'response': [{u'type': u'string', u'name': u'source', u'description': u'Source of the counter.'}, {u'type': u'string', u'name': u'name', u'description': u'Name of the counter.'}, {u'type': u'string', u'name': u'value', u'description': u'Value in case of snmp or other specific counters.'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the Counter'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of counter'}], u'description': u'Adds metric counter'}, u'lbhealthcheckpolicy': {u'name': u'createLBHealthCheckPolicy', u'related': [u'updateLBHealthCheckPolicy'], u'isasync': True, u'params': [{u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'pingpath', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'HTTP Ping Path'}, {u'name': u'intervaltime', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Amount of time between health checks (1 sec - 20940 sec)'}, {u'name': u'description', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the description of the load balancer HealthCheck policy'}, {u'name': u'healthythreshold', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Number of consecutive health check success before declaring an instance healthy'}, {u'name': u'responsetimeout', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Time to wait when receiving a response from the health check (2sec - 60 sec)'}, {u'name': u'unhealthythreshold', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Number of consecutive health check failures before declaring an instance unhealthy'}], u'requiredparams': [u'lbruleid'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the HealthCheck policy belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the HealthCheck policy'}, {u'description': u'the list of healthcheckpolicies', u'type': u'list', u'response': [{u'type': u'string', u'name': u'pingpath', u'description': u'the pingpath  of the healthcheck policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB HealthCheck policy ID'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'int', u'name': u'healthcheckinterval', u'description': u'Amount of time between health checks'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the healthcheck policy'}, {u'type': u'int', u'name': u'unhealthcheckthresshold', u'description': u'Number of consecutive health check failures before declaring an instance unhealthy.'}, {u'type': u'int', u'name': u'healthcheckthresshold', u'description': u'Number of consecutive health check success before declaring an instance healthy'}, {u'type': u'int', u'name': u'responsetime', u'description': u'Time to wait when receiving a response from the health check'}], u'name': u'healthcheckpolicy'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the HealthCheck policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the HealthCheck policy'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}], u'description': u'Creates a Load Balancer healthcheck policy '}, u'project': {u'name': u'createProject', u'related': [], u'isasync': True, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will be Admin for the project'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a project'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the project'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'display text of the project'}], u'requiredparams': [u'name', u'displaytext'], u'response': [{u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}], u'description': u'Creates a project'}, u'vpncustomergateway': {u'name': u'createVpnCustomerGateway', u'related': [u'listVpnCustomerGateways', u'updateVpnCustomerGateway'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the gateway. If used with the account parameter returns the gateway associated with the account for the specified domain.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of this customer gateway'}, {u'name': u'esppolicy', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'ESP policy of the customer gateway'}, {u'name': u'ikepolicy', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'IKE policy of the customer gateway'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the gateway. Must be used with the domainId parameter.'}, {u'name': u'esplifetime', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Lifetime of phase 2 VPN connection to the customer gateway, in seconds'}, {u'name': u'ipsecpsk', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'name': u'cidrlist', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'guest cidr list of the customer gateway'}, {u'name': u'dpd', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'If DPD is enabled for VPN connection'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'public ip address id of the customer gateway'}, {u'name': u'ikelifetime', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Lifetime of phase 1 VPN connection to the customer gateway, in seconds'}], u'requiredparams': [u'esppolicy', u'ikepolicy', u'ipsecpsk', u'cidrlist', u'gateway'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'IPsec policy of customer gateway'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec preshared-key of customer gateway'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'guest ip of the customer gateway'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of customer gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u'name', u'description': u'name of the customer gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}], u'description': u'Creates site to site vpn customer gateway'}, u'snapshot': {u'name': u'createSnapshot', u'related': [u'revertSnapshot'], u'isasync': True, u'params': [{u'name': u'policyid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'policy id of the snapshot, if this is null, then use MANUAL_POLICY.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The account of the snapshot. The account parameter must be used with the domainId parameter.'}, {u'name': u'volumeid', u'required': True, u'related': [u'listVolumes', u'migrateVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the disk volume'}, {u'name': u'quiescevm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'quiesce vm if true'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The domain ID of the snapshot. If used with the account parameter, specifies a domain for the account associated with the disk volume.'}], u'requiredparams': [u'volumeid'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the snapshot'}, {u'type': u'string', u'name': u'volumename', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the snapshot'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the snapshot. BackedUp means that snapshot is ready to be used; Creating - the snapshot is being allocated on the primary storage; BackingUp - the snapshot is being backed up on secondary storage'}, {u'type': u'string', u'name': u'volumeid', u'description': u'ID of the disk volume'}, {u'type': u'boolean', u'name': u'revertable', u'description': u'indicates whether the underlying storage supports reverting the volume to this snapshot'}, {u'type': u'string', u'name': u'intervaltype', u'description': u'valid types are hourly, daily, weekly, monthy, template, and none.'}, {u'type': u'string', u'name': u'name', u'description': u'name of the snapshot'}, {u'description': u'the list of resource tags associated with snapshot', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zoneid', u'description': u'id of the availability zone'}, {u'type': u'string', u'name': u'domain', u'description': u"the domain name of the snapshot's account"}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the snapshot'}, {u'type': u'string', u'name': u'snapshottype', u'description': u'the type of the snapshot'}, {u'type': u'date', u'name': u'created', u'description': u'  the date the snapshot was created'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the snapshot'}, {u'type': u'string', u'name': u'domainid', u'description': u"the domain ID of the snapshot's account"}, {u'type': u'string', u'name': u'volumetype', u'description': u'type of the disk volume'}], u'description': u'Creates an instant snapshot of a volume.'}, u'loadbalancer': {u'name': u'createLoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'sourceipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the source ip address the network traffic will be load balanced from'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the Load Balancer'}, {u'name': u'networkid', u'required': True, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The guest network the Load Balancer will be created for'}, {u'name': u'scheme', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the load balancer scheme. Supported value in this release is Internal'}, {u'name': u'description', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the description of the Load Balancer'}, {u'name': u'sourceipaddressnetworkid', u'required': True, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the network id of the source ip address'}, {u'name': u'sourceport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the source port the network traffic will be load balanced from'}, {u'name': u'algorithm', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'load balancer algorithm (source, roundrobin, leastconn)'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'instanceport', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the TCP port of the virtual machine where the network traffic will be load balanced to'}], u'requiredparams': [u'name', u'networkid', u'scheme', u'sourceipaddressnetworkid', u'sourceport', u'algorithm', u'instanceport'], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the Load Balancer ID'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Load Balancer'}, {u'type': u'string', u'name': u'sourceipaddress', u'description': u'Load Balancer source ip'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'description': u'the list of instances associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the instance'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the instance'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the instance'}, {u'type': u'string', u'name': u'id', u'description': u'the instance ID'}], u'name': u'loadbalancerinstance'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Load Balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Load Balancer'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the Load Balancer'}, {u'description': u'the list of resource tags associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the Load Balancer'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Load Balancer'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the Load Balancer'}, {u'type': u'string', u'name': u'networkid', u'description': u'Load Balancer network id'}, {u'description': u'the list of rules associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'integer', u'name': u'sourceport', u'description': u'source port of the load balancer rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the load balancer rule'}, {u'type': u'integer', u'name': u'instanceport', u'description': u'instance port of the load balancer rule'}], u'name': u'loadbalancerrule'}, {u'type': u'string', u'name': u'sourceipaddressnetworkid', u'description': u'Load Balancer source ip network id'}], u'description': u'Creates a Load Balancer'}, u'virtualrouterelement': {u'name': u'createVirtualRouterElement', u'related': [u'configureVirtualRouterElement'], u'isasync': True, u'params': [{u'name': u'providertype', u'required': False, u'related': [u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'The provider type. Supported types are VirtualRouter (default) and VPCVirtualRouter'}, {u'name': u'nspid', u'required': True, u'related': [u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'the network service provider ID of the virtual router element'}], u'requiredparams': [u'nspid'], u'response': [{u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the provider'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the provider'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the provider'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the service provider'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the provider'}], u'description': u'Create a virtual router element.'}, u'egressfirewallrule': {u'name': u'createEgressFirewallRule', u'related': [u'createFirewallRule', u'listFirewallRules', u'listEgressFirewallRules', u'updateEgressFirewallRule', u'updateFirewallRule'], u'isasync': True, u'params': [{u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the ending port of firewall rule'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'networkid', u'required': True, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the network id of the port forwarding rule'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to forward traffic from'}, {u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the starting port of firewall rule'}, {u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of firewallrule: system/user'}, {u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'protocol', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the firewall rule. Valid values are TCP/UDP/ICMP.'}], u'requiredparams': [u'networkid', u'protocol'], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}], u'description': u'Creates a egress firewall rule for a given network '}, u'physicalnetwork': {u'name': u'createPhysicalNetwork', u'related': [u'listPhysicalNetworks'], u'isasync': True, u'params': [{u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the VLAN for the physical network'}, {u'name': u'isolationmethods', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the isolation method for the physical network[VLAN/L3/GRE]'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'Tag the physical network'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the physical network'}, {u'name': u'networkspeed', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the speed for the physical network[1G/10G]'}, {u'name': u'broadcastdomainrange', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the broadcast domain range for the physical network[Pod or Zone]. In Acton release it can be Zone only in Advance zone, and Pod in Basic'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a physical network'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the physical network'}], u'requiredparams': [u'zoneid', u'name'], u'response': [{u'type': u'string', u'name': u'vlan', u'description': u'the vlan of the physical network'}, {u'type': u'string', u'name': u'broadcastdomainrange', u'description': u'Broadcast domain range of the physical network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the physical network owner'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of the physical network'}, {u'type': u'string', u'name': u'isolationmethods', u'description': u'isolation methods'}, {u'type': u'string', u'name': u'tags', u'description': u'comma separated tag'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the physical network'}, {u'type': u'string', u'name': u'networkspeed', u'description': u'the speed of the physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the physical network'}, {u'type': u'string', u'name': u'name', u'description': u'name of the physical network'}], u'description': u'Creates a physical network'}, u'sshkeypair': {u'name': u'createSSHKeyPair', u'related': [], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the ssh key. If the account parameter is used, domainId must also be used.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the keypair'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project for the ssh key'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the ssh key. Must be used with domainId.'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'privatekey', u'description': u'Private key'}], u'description': u'Create a new keypair and returns the private key'}, u'privategateway': {u'name': u'createPrivateGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'networkofferingid', u'required': False, u'related': [u'createNetworkOffering', u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'the uuid of the network offering to use for the private gateways network connection'}, {u'name': u'aclid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL'}, {u'name': u'netmask', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask of the Private gateway'}, {u'name': u'sourcenatsupported', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"source NAT supported value. Default value false. If 'true' source NAT is enabled on the private gateway 'false': sourcenat is not supported"}, {u'name': u'vlan', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the network implementation uri for the private gateway'}, {u'name': u'vpcid', u'required': True, u'related': [u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the VPC network belongs to'}, {u'name': u'ipaddress', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the IP address of the Private gateaway'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway of the Private gateway'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID the network belongs to'}], u'requiredparams': [u'netmask', u'vlan', u'vpcid', u'ipaddress', u'gateway'], u'response': [{u'type': u'boolean', u'name': u'sourcenatsupported', u'description': u'Souce Nat enable status'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the private gateway'}, {u'type': u'string', u'name': u'vlan', u'description': u'the network implementation uri for the private gateway'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the private gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the private gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway'}, {u'type': u'string', u'name': u'state', u'description': u'State of the gateway, can be Creating, Ready, Deleting'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the private gateway'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the private gateway'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the private gateway belongs to'}, {u'type': u'string', u'name': u'ipaddress', u'description': u"the private gateway's ip address"}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the private gateway'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the private gateaway belongs to'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'netmask', u'description': u"the private gateway's netmask"}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id set for private gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the private gateway'}], u'description': u'Creates a private gateway'}, u'serviceinstance': {u'name': u'createServiceInstance', u'related': [], u'isasync': True, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'Project ID for the service instance'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'An optional account for the virtual machine. Must be used with domainId.'}, {u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'The service offering ID that defines the resources consumed by the service appliance'}, {u'name': u'templateid', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'The template ID that specifies the image for the service appliance'}, {u'name': u'rightnetworkid', u'required': True, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The right (outside) network ID for the service instance'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'The name of the service instance'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'An optional domainId for the virtual machine. If the account parameter is used, domainId must also be used.'}, {u'name': u'leftnetworkid', u'required': True, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The left (inside) network for service instance'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'Availability zone for the service instance'}], u'requiredparams': [u'serviceofferingid', u'templateid', u'rightnetworkid', u'name', u'leftnetworkid', u'zoneid'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}], u'description': u'Creates a system virtual-machine that implements network services'}}, u'deploy': {u'virtualmachine': {u'name': u'deployVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'securitygroupids', u'required': False, u'related': [u'listSecurityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of security groups id that going to be applied to the virtual machine. Should be passed only when vm is created from a zone with Basic Network support. Mutually exclusive with securitygroupnames parameter'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the virtual machine. If the account parameter is used, domainId must also be used.'}, {u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the service offering for the virtual machine'}, {u'name': u'group', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional group for the virtual machine'}, {u'name': u'securitygroupnames', u'required': False, u'related': [u'listSecurityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of security groups names that going to be applied to the virtual machine. Should be passed only when vm is created from a zone with Basic Network support. Mutually exclusive with securitygroupids parameter'}, {u'name': u'keyboard', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional keyboard device type for the virtual machine. valid value can be one of de,de-ch,es,fi,fr,fr-be,fr-ch,is,it,jp,nl-be,no,pt,uk,us'}, {u'name': u'userdata', u'required': False, u'related': [], u'length': 32768, u'type': u'string', u'description': u'an optional binary data that can be sent to the virtual machine upon a successful deployment. This binary data must be base64 encoded before adding it to the request. Using HTTP GET (via querystring), you can send up to 2KB of data after base64 encoding. Using HTTP POST(via POST body), you can send up to 32K of data after base64 encoding.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the virtual machine. Must be used with domainId.'}, {u'name': u'affinitygroupnames', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of affinity groups names that are going to be applied to the virtual machine.Mutually exclusive with affinitygroupids parameter'}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"the ip address for default vm's network"}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'availability zone for the virtual machine'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'used to specify the custom parameters.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'host name for the virtual machine'}, {u'name': u'displayvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vm to the end user or not.'}, {u'name': u'templateid', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the template for the virtual machine'}, {u'name': u'keypair', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the ssh key pair used to login to the virtual machine'}, {u'name': u'size', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'the arbitrary size for the DATADISK volume. Mutually exclusive with diskOfferingId'}, {u'name': u'displayname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional user generated name for the virtual machine'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'Deploy vm for the project'}, {u'name': u'deploymentplanner', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Deployment planner to use for vm allocation. Available to ROOT admin only'}, {u'name': u'rootdisksize', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Optional field to resize root disk on deploy. Only applies to template-based deployments. Analogous to details[0].rootdisksize, which takes precedence over this parameter if both are provided'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'destination Host ID to deploy the VM to - parameter available for root admin only'}, {u'name': u'iptonetworklist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u"ip to network mapping. Can't be specified with networkIds parameter. Example: iptonetworklist[0].ip=10.10.10.11&iptonetworklist[0].ipv6=fc00:1234:5678::abcd&iptonetworklist[0].networkid=uuid - requests to use ip 10.10.10.11 in network id=uuid"}, {u'name': u'networkids', u'required': False, u'related': [u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'list', u'description': u"list of network ids used by virtual machine. Can't be specified with ipToNetworkList parameter"}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the hypervisor on which to deploy the virtual machine. The parameter is required and respected only when hypervisor info is not set on the ISO/Template passed to the call'}, {u'name': u'startvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if network offering supports specifying ip ranges; defaulted to true if not specified'}, {u'name': u'ip6address', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"the ipv6 address for default vm's network"}, {u'name': u'affinitygroupids', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of affinity groups id that are going to be applied to the virtual machine. Mutually exclusive with affinitygroupnames parameter'}, {u'name': u'diskofferingid', u'required': False, u'related': [u'listDiskOfferings', u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk offering for the virtual machine. If the template is of ISO format, the diskOfferingId is for the root disk volume. Otherwise this parameter is used to indicate the offering for the data disk volume. If the templateId parameter passed is from a Template object, the diskOfferingId refers to a DATA Disk Volume created. If the templateId parameter passed is from an ISO object, the diskOfferingId refers to a ROOT Disk Volume created.'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}], u'requiredparams': [u'serviceofferingid', u'zoneid', u'templateid'], u'response': [{u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}], u'description': u'Creates and automatically starts a virtual machine based on a service offering, disk offering, and template.'}}, u'reboot': {u'systemvm': {u'name': u'rebootSystemVm', u'related': [u'scaleSystemVm'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'scaleSystemVm', u'rebootSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}], u'description': u'Reboots a system VM.'}, u'router': {u'name': u'rebootRouter', u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the router'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}], u'name': u'nic'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}], u'description': u'Starts a router.'}, u'virtualmachine': {u'name': u'rebootVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}], u'description': u'Reboots a virtual machine.'}}, u'find': {u'hostsformigration': {u'name': u'findHostsForMigration', u'related': [], u'isasync': False, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'find hosts to which this VM can be migrated and flag the hosts with enough CPU/RAM to host the VM'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'boolean', u'name': u'requiresStorageMotion', u'description': u'true if migrating a vm to this host requires storage motion, false otherwise'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}], u'description': u'Find hosts suitable for migrating a virtual machine.'}, u'storagepoolsformigration': {u'name': u'findStoragePoolsForMigration', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVolumes', u'migrateVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the volume'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}, {u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}], u'description': u'Lists storage pools available for migration of a volume.'}}, u'attach': {u'volume': {u'name': u'attachVolume', u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'    the ID of the virtual machine'}, {u'name': u'id', u'required': True, u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'deviceid', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'the ID of the device to map the volume to within the guest OS. If no deviceId is passed in, the next available deviceId will be chosen. Possible values for a Linux OS are:* 0 - /dev/xvda* 1 - /dev/xvdb* 2 - /dev/xvdc* 4 - /dev/xvde* 5 - /dev/xvdf* 6 - /dev/xvdg* 7 - /dev/xvdh* 8 - /dev/xvdi* 9 - /dev/xvdj'}], u'requiredparams': [u'virtualmachineid', u'id'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}], u'description': u'Attaches a disk volume to a virtual machine.'}, u'iso': {u'name': u'attachIso', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the ISO file'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine'}], u'requiredparams': [u'id', u'virtualmachineid'], u'response': [{u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}], u'name': u'ingressrule'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}], u'name': u'nic'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}], u'description': u'Attaches an ISO to a virtual machine.'}}, u'add': {u'ciscoasa1000vresource': {u'name': u'addCiscoAsa1000vResource', u'related': [], u'isasync': False, u'params': [{u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname or ip address of the Cisco ASA 1000v appliance.'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'insideportprofile', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Nexus port profile associated with inside interface of ASA 1000v'}, {u'name': u'clusterid', u'required': True, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the Cluster ID'}], u'requiredparams': [u'hostname', u'physicalnetworkid', u'insideportprofile', u'clusterid'], u'response': [{}, {}, {}, {}, {}], u'description': u'Adds a Cisco Asa 1000v appliance'}, u'nictovirtualmachine': {u'name': u'addNicToVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'IP Address for the new network'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'addNicToVirtualMachine', u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Virtual Machine ID'}, {u'name': u'networkid', u'required': True, u'related': [u'listBrocadeVcsDeviceNetworks', u'listNetworks', u'createNetwork', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'Network ID'}], u'requiredparams': [u'virtualmachineid', u'networkid'], u'response': [{u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}], u'description': u'Adds VM to specified network by creating a NIC'}, u'nuagevspdevice': {u'name': u'addNuageVspDevice', u'related': [u'listNuageVspDevices'], u'isasync': True, u'params': [{u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the physical network in to which Nuage VSP is added'}, {u'name': u'retrycount', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the number of retries on failure to communicate to Nuage VSD'}, {u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the hostname of the Nuage VSD'}, {u'name': u'retryinterval', u'required': True, u'related': [], u'length': 255, u'type': u'long', u'description': u'the time to wait after failure before retrying to communicate to Nuage VSD'}, {u'name': u'apiversion', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the version of the API to use to communicate to Nuage VSD'}, {u'name': u'port', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the port to communicate to Nuage VSD'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password of CMS user in Nuage VSD'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the user name of the CMS user in Nuage VSD'}], u'requiredparams': [u'physicalnetworkid', u'retrycount', u'hostname', u'retryinterval', u'apiversion', u'port', u'password', u'username'], u'response': [{u'type': u'string', u'name': u'hostname', u'description': u'the hostname of the Nuage VSD'}, {u'type': u'int', u'name': u'retrycount', u'description': u'the number of retries on failure to communicate to Nuage VSD'}, {u'type': u'string', u'name': u'provider', u'description': u'the service provider name corresponding to this Nuage VSP device'}, {u'type': u'string', u'name': u'vspdeviceid', u'description': u'the device id of the Nuage VSD'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the ID of the physical network to which this Nuage VSP belongs to'}, {u'type': u'long', u'name': u'retryinterval', u'description': u'the time to wait after failure before retrying to communicate to Nuage VSD'}, {u'type': u'string', u'name': u'nuagedevicename', u'description': u'the name of the Nuage VSP device'}, {u'type': u'string', u'name': u'apiversion', u'description': u'the version of the API to use to communicate to Nuage VSD'}, {u'type': u'int', u'name': u'port', u'description': u'the port to communicate to Nuage VSD'}], u'description': u'Adds a Nuage VSP device'}, u'accounttoproject': {u'name': u'addAccountToProject', u'related': [], u'isasync': True, u'params': [{u'name': u'projectid', u'required': True, u'related': [u'listProjects', u'createProject', u'updateProject', u'suspendProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to add the account to'}, {u'name': u'email', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'email to which invitation to the project is going to be sent'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the account to be added to the project'}], u'requiredparams': [u'projectid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Adds acoount to a project'}, u'externalloadbalancer': {u'name': u'addExternalLoadBalancer', u'related': [], u'isasync': False, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the external load balancer appliance.'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Password of the external load balancer appliance.'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'Zone in which to add the external load balancer appliance.'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username of the external load balancer appliance.'}], u'requiredparams': [u'url', u'password', u'zoneid', u'username'], u'response': [{u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the external load balancer'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external load balancer'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external load balancer"}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external load balancer'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external load balancer'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external load balancer'}], u'description': u'Adds F5 external load balancer appliance.'}, u'globodnshost': {u'name': u'addGloboDnsHost', u'related': [], u'isasync': True, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'GloboDNS url'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Password for GloboDNS'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username for GloboDNS'}], u'requiredparams': [u'url', u'physicalnetworkid', u'password', u'username'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Adds the GloboDNS external host'}, u'cluster': {u'name': u'addCluster', u'related': [u'updateCluster', u'listClusters'], u'isasync': False, u'params': [{u'name': u'vsmusername', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for the VSM associated with this cluster'}, {u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the host'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this cluster for allocation of new resources'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for the cluster'}, {u'name': u'publicvswitchname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of virtual switch used for public traffic in the cluster.  This would override zone wide traffic label setting.'}, {u'name': u'clustertype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of the cluster: CloudManaged, ExternalManaged'}, {u'name': u'clustername', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the cluster name'}, {u'name': u'guestvswitchname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of virtual switch used for guest traffic in the cluster. This would override zone wide traffic label setting.'}, {u'name': u'hypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the cluster: XenServer,KVM,VMware,Hyperv,BareMetal,Simulator'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL'}, {u'name': u'password', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password for the host'}, {u'name': u'publicvswitchtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Type of virtual switch used for public traffic in the cluster. Allowed values are, vmwaresvs (for VMware standard vSwitch) and vmwaredvs (for VMware distributed vSwitch)'}, {u'name': u'vsmipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ipaddress of the VSM associated with this cluster'}, {u'name': u'vsmpassword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password for the VSM associated with this cluster'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the cluster'}, {u'name': u'guestvswitchtype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Type of virtual switch used for guest traffic in the cluster. Allowed values are, vmwaresvs (for VMware standard vSwitch) and vmwaredvs (for VMware distributed vSwitch)'}], u'requiredparams': [u'podid', u'clustertype', u'clustername', u'hypervisor', u'zoneid'], u'response': [{u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'description': u'the capacity of the Cluster', u'type': u'list', u'response': [{u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the cluster'}, {u'type': u'string', u'name': u'memoryovercommitratio', u'description': u'The memory overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'hypervisortype', u'description': u'the hypervisor type of the cluster'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the cluster'}, {u'type': u'string', u'name': u'id', u'description': u'the cluster ID'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the cluster'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the type of the cluster'}, {u'type': u'string', u'name': u'cpuovercommitratio', u'description': u'The cpu overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the cluster'}, {u'type': u'string', u'name': u'managedstate', u'description': u'whether this cluster is managed by cloudstack'}, {u'type': u'string', u'name': u'name', u'description': u'the cluster name'}], u'description': u'Adds a new cluster'}, u'opendaylightcontroller': {u'name': u'addOpenDaylightController', u'related': [u'listOpenDaylightControllers', u'deleteOpenDaylightController'], u'isasync': True, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Api URL of the OpenDaylight Controller.'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credential to access the OpenDaylight API'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username to access the OpenDaylight API'}], u'requiredparams': [u'url', u'physicalnetworkid', u'password', u'username'], u'response': [{u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this controller belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'device id of the controller'}, {u'type': u'string', u'name': u'username', u'description': u'the username to authenticate to the controller'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the controller api'}, {u'type': u'string', u'name': u'name', u'description': u'the name assigned to the controller'}], u'description': u'Adds an OpenDyalight controler'}, u'networkdevice': {u'name': u'addNetworkDevice', u'related': [u'listNetworkDevice'], u'isasync': False, u'params': [{u'name': u'networkdevicetype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Network device type, now supports ExternalDhcp, PxeServer, NetscalerMPXLoadBalancer, NetscalerVPXLoadBalancer, NetscalerSDXLoadBalancer, F5BigIpLoadBalancer, JuniperSRXFirewall, PaloAltoFirewall'}, {u'name': u'networkdeviceparameterlist', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'parameters for network device'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the network device'}], u'description': u'Adds a network device of one of the following types: ExternalDhcp, ExternalFirewall, ExternalLoadBalancer, PxeServer'}, u'guestos': {u'name': u'addGuestOs', u'related': [], u'isasync': True, u'params': [{u'name': u'oscategoryid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'ID of Guest OS category'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Optional name for Guest OS'}, {u'name': u'osdisplayname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique display name for Guest OS'}], u'requiredparams': [u'oscategoryid', u'osdisplayname'], u'response': [{u'type': u'string', u'name': u'description', u'description': u'the name/description of the OS type'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the OS type'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the ID of the OS category'}, {u'type': u'string', u'name': u'isuserdefined', u'description': u'is the guest OS user defined'}], u'description': u'Add a new guest OS type'}, u'brocadevcsdevice': {u'name': u'addBrocadeVcsDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Brocade VCS Switch API'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Brocade VCS Switch API'}, {u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname of ip address of the Brocade VCS Switch.'}], u'requiredparams': [u'password', u'physicalnetworkid', u'username', u'hostname'], u'response': [{u'type': u'string', u'name': u'hostname', u'description': u'the principal switch Ip address'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical Network to which this Brocade VCS belongs to'}, {u'type': u'string', u'name': u'brocadedevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'vcsdeviceid', u'description': u'device id of the Brocade Vcs'}], u'description': u'Adds a Brocade VCS Switch'}, u'niciranvpdevice': {u'name': u'addNiciraNvpDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'transportzoneuuid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'The Transportzone UUID configured on the Nicira Controller'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Nicira Controller API'}, {u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname of ip address of the Nicira NVP Controller.'}, {u'name': u'l3gatewayserviceuuid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The L3 Gateway Service UUID configured on the Nicira Controller'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Nicira Controller API'}], u'requiredparams': [u'physicalnetworkid', u'transportzoneuuid', u'password', u'hostname', u'username'], u'response': [{u'type': u'string', u'name': u'l3gatewayserviceuuid', u'description': u'this L3 gateway service Uuid'}, {u'type': u'string', u'name': u'hostname', u'description': u'the controller Ip address'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this Nirica Nvp belongs to'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'transportzoneuuid', u'description': u'the transport zone Uuid'}, {u'type': u'string', u'name': u'nvpdeviceid', u'description': u'device id of the Nicire Nvp'}, {u'type': u'string', u'name': u'niciradevicename', u'description': u'device name'}], u'description': u'Adds a Nicira NVP device'}, u's3': {u'name': u'addS3', u'related': [u'listSecondaryStagingStores', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'isasync': False, u'params': [{u'name': u'secretkey', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'S3 secret key'}, {u'name': u'sockettimeout', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'socket timeout (milliseconds)'}, {u'name': u'maxerrorretry', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'maximum number of times to retry on error'}, {u'name': u'endpoint', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'S3 host name'}, {u'name': u'connectiontimeout', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'connection timeout (milliseconds)'}, {u'name': u'bucket', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the template storage bucket'}, {u'name': u'usehttps', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'connect to the S3 endpoint via HTTPS?'}, {u'name': u'accesskey', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'S3 access key'}], u'requiredparams': [u'secretkey', u'bucket', u'accesskey'], u'response': [{u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}], u'description': u'Adds S3'}, u'bigswitchvnsdevice': {u'name': u'addBigSwitchVnsDevice', u'related': [u'listBigSwitchVnsDevices'], u'isasync': True, u'params': [{u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname of ip address of the BigSwitch VNS Controller.'}], u'requiredparams': [u'physicalnetworkid', u'hostname'], u'response': [{u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'bigswitchdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this BigSwitch Vns belongs to'}, {u'type': u'string', u'name': u'vnsdeviceid', u'description': u'device id of the BigSwitch Vns'}, {u'type': u'string', u'name': u'hostname', u'description': u'the controller Ip address'}], u'description': u'Adds a BigSwitch VNS device'}, u'guestosmapping': {u'name': u'addGuestOsMapping', u'related': [], u'isasync': True, u'params': [{u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs'], u'length': 255, u'type': u'uuid', u'description': u'UUID of Guest OS type. Either the UUID or Display Name must be passed'}, {u'name': u'osnameforhypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'OS name specific to the hypervisor'}, {u'name': u'hypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hypervisor type. One of : XenServer, KVM, VMWare'}, {u'name': u'osdisplayname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Display Name of Guest OS standard type. Either Display Name or UUID must be passed'}, {u'name': u'hypervisorversion', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u"Hypervisor version to create the mapping for. Use 'default' for default versions"}], u'requiredparams': [u'osnameforhypervisor', u'hypervisor', u'hypervisorversion'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the Guest OS mapping'}, {u'type': u'string', u'name': u'osnameforhypervisor', u'description': u'hypervisor specific name for the Guest OS'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the Guest OS type'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor'}, {u'type': u'string', u'name': u'osdisplayname', u'description': u'standard display name for the Guest OS'}, {u'type': u'string', u'name': u'isuserdefined', u'description': u'is the mapping user defined'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'version of the hypervisor for mapping'}], u'description': u'Adds a guest OS name to hypervisor OS name mapping'}, u'ciscovnmcresource': {u'name': u'addCiscoVnmcResource', u'related': [], u'isasync': False, u'params': [{u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Cisco VNMC Controller API'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to access the Cisco VNMC Controller API'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname or ip address of the Cisco VNMC Controller.'}], u'requiredparams': [u'username', u'password', u'physicalnetworkid', u'hostname'], u'response': [{}, {}, {}, {}, {}], u'description': u'Adds a Cisco Vnmc Controller'}, u'ucsmanager': {u'name': u'addUcsManager', u'related': [], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the Zone id for the ucs manager'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password of UCS'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username of UCS'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of UCS manager'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of UCS url'}], u'requiredparams': [u'zoneid', u'password', u'username', u'url'], u'response': [{u'type': u'string', u'name': u'url', u'description': u'the url of ucs manager'}, {u'type': u'string', u'name': u'name', u'description': u'the name of ucs manager'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of ucs manager'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ucs manager'}], u'description': u'Adds a Ucs manager'}, u'externalfirewall': {u'name': u'addExternalFirewall', u'related': [u'listExternalFirewalls'], u'isasync': False, u'params': [{u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username of the external firewall appliance.'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the external firewall appliance.'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Password of the external firewall appliance.'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'Zone in which to add the external firewall appliance.'}], u'requiredparams': [u'username', u'url', u'password', u'zoneid'], u'response': [{u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the external firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}], u'description': u'Adds an external firewall appliance'}, u'baremetalpxepingserver': {u'name': u'addBaremetalPxePingServer', u'related': [], u'isasync': True, u'params': [{u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external pxe device'}, {u'name': u'pingcifsusername', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username of PING storage server'}, {u'name': u'pingdir', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Root directory on PING storage server'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'pingstorageserverip', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'PING storage server ip'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the external pxe device'}, {u'name': u'pingcifspassword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Password of PING storage server'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external pxe device'}, {u'name': u'podid', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'Pod Id'}, {u'name': u'pxeservertype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of pxe device'}, {u'name': u'tftpdir', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Tftp root directory of PXE server'}], u'requiredparams': [u'username', u'pingdir', u'physicalnetworkid', u'pingstorageserverip', u'url', u'password', u'pxeservertype', u'tftpdir'], u'response': [{u'type': u'string', u'name': u'pingdir', u'description': u'Root directory on PING storage server'}, {u'type': u'string', u'name': u'tftpdir', u'description': u'Tftp root directory of PXE server'}, {u'type': u'string', u'name': u'pingstorageserverip', u'description': u'PING storage server ip'}], u'description': u'add a baremetal ping pxe server'}, u'baremetalhost': {u'name': u'addBaremetalHost', u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'isasync': False, u'params': [{u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the host'}, {u'name': u'hosttags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of tags to be added to the host'}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'ip address intentionally allocated to this host after provisioning'}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID for the host'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this Host for allocation of new resources'}, {u'name': u'hypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the host'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for the host'}, {u'name': u'clustername', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the cluster name for the host'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password for the host'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the host'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the host URL'}], u'requiredparams': [u'podid', u'hypervisor', u'username', u'password', u'zoneid', u'url'], u'response': [{u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}], u'name': u'vgpu'}, {u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}], u'name': u'gpugroup'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}], u'description': u'add a baremetal host'}, u'baremetaldhcp': {u'name': u'addBaremetalDhcp', u'related': [], u'isasync': True, u'params': [{u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external dhcp device'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external dhcp device'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the external dhcp appliance.'}, {u'name': u'dhcpservertype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Type of dhcp device'}], u'requiredparams': [u'username', u'password', u'physicalnetworkid', u'url', u'dhcpservertype'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'device id of '}, {u'type': u'string', u'name': u'url', u'description': u'url'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this external dhcp device belongs to'}, {u'type': u'string', u'name': u'dhcpservertype', u'description': u'name of the provider'}], u'description': u'adds a baremetal dhcp server'}, u'trafficmonitor': {u'name': u'addTrafficMonitor', u'related': [u'listTrafficMonitors'], u'isasync': False, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the traffic monitor Host'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'Zone in which to add the external firewall appliance.'}, {u'name': u'includezones', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Traffic going into the listed zones will be metered'}, {u'name': u'excludezones', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Traffic going into the listed zones will not be metered'}], u'requiredparams': [u'url', u'zoneid'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}], u'description': u'Adds Traffic Monitor Host for Direct Network Usage'}, u'ldapconfiguration': {u'name': u'addLdapConfiguration', u'related': [], u'isasync': False, u'params': [{u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname'}, {u'name': u'port', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Port'}], u'requiredparams': [u'hostname', u'port'], u'response': [{u'type': u'string', u'name': u'hostname', u'description': u'hostname'}, {u'type': u'int', u'name': u'port', u'description': u'port'}], u'description': u'Add a new Ldap Configuration'}, u'iptonic': {u'name': u'addIpToNic', u'related': [], u'isasync': True, u'params': [{u'name': u'nicid', u'required': True, u'related': [u'listNics'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the nic to which you want to assign private IP'}, {u'name': u'ipaddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Secondary IP Address'}], u'requiredparams': [u'nicid'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the secondary private IP addr'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'Secondary IP address'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the ID of the vm'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the network'}, {u'type': u'string', u'name': u'nicid', u'description': u'the ID of the nic'}], u'description': u'Assigns secondary IP to NIC'}, u'vpnuser': {u'name': u'addVpnUser', u'related': [u'listVpnUsers'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the vpn user. If the account parameter is used, domainId must also be used.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the vpn user. Must be used with domainId.'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'username for the vpn user'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'add vpn user to the specific project'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'password for the username'}], u'requiredparams': [u'username', u'password'], u'response': [{u'type': u'string', u'name': u'state', u'description': u'the state of the Vpn User'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the remote access vpn'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn userID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the account of the remote access vpn'}, {u'type': u'string', u'name': u'username', u'description': u'the username of the vpn user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the account of the remote access vpn'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}], u'description': u'Adds vpn users'}, u'traffictype': {u'name': u'addTrafficType', u'related': [], u'isasync': True, u'params': [{u'name': u'traffictype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the trafficType to be added to the physical network'}, {u'name': u'xenservernetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a XenServer host'}, {u'name': u'isolationmethod', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"Used if physical network has multiple isolation types and traffic type is public. Choose which isolation method. Valid options currently 'vlan' or 'vxlan', defaults to 'vlan'."}, {u'name': u'kvmnetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a KVM host'}, {u'name': u'hypervnetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a Hyperv host'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The VLAN id to be used for Management traffic by VMware host'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'vmwarenetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a VMware host'}], u'requiredparams': [u'traffictype', u'physicalnetworkid'], u'response': [{u'type': u'string', u'name': u'vmwarenetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a VMware host'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the trafficType to be added to the physical network'}, {u'type': u'string', u'name': u'kvmnetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a KVM host'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'xenservernetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a XenServer host'}, {u'type': u'string', u'name': u'hypervnetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a HyperV host'}, {u'type': u'string', u'name': u'id', u'description': u'id of the network provider'}], u'description': u'Adds traffic type to a physical network'}, u'host': {u'name': u'addHost', u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'prepareHostForMaintenance'], u'isasync': False, u'params': [{u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the Pod ID for the host'}, {u'name': u'clustername', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the cluster name for the host'}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID for the host'}, {u'name': u'hypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the host'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for the host'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the host URL'}, {u'name': u'hosttags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of tags to be added to the host'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this Host for allocation of new resources'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the password for the host'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the host'}], u'requiredparams': [u'podid', u'hypervisor', u'username', u'url', u'password', u'zoneid'], u'response': [{u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}, {u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}, {u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}], u'name': u'vgpu'}], u'name': u'gpugroup'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}], u'description': u'Adds a new host.'}, u'srxfirewall': {u'name': u'addSrxFirewall', u'related': [u'listSrxFirewalls', u'configureSrxFirewall'], u'isasync': True, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the SRX appliance.'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach SRX firewall device'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach SRX firewall device'}, {u'name': u'networkdevicetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'supports only JuniperSRXFirewall'}], u'requiredparams': [u'url', u'physicalnetworkid', u'password', u'username', u'networkdevicetype'], u'response': [{u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this SRX firewall belongs to'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the SRX firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}], u'description': u'Adds a SRX firewall device'}, u'swift': {u'name': u'addSwift', u'related': [u'listSecondaryStagingStores', u'addS3', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'isasync': False, u'params': [{u'name': u'key', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u' key for the user for swift'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for swift'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account for swift'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL for swift'}], u'requiredparams': [u'url'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}], u'description': u'Adds Swift.'}, u'baremetalpxekickstartserver': {u'name': u'addBaremetalPxeKickStartServer', u'related': [], u'isasync': True, u'params': [{u'name': u'pxeservertype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of pxe device'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'tftpdir', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Tftp root directory of PXE server'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the external pxe device'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external pxe device'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach external pxe device'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'Pod Id'}], u'requiredparams': [u'pxeservertype', u'physicalnetworkid', u'tftpdir', u'url', u'password', u'username'], u'response': [{u'type': u'string', u'name': u'tftpdir', u'description': u'Tftp root directory of PXE server'}], u'description': u'add a baremetal pxe server'}, u'netscalerloadbalancer': {u'name': u'addNetscalerLoadBalancer', u'related': [u'configureNetscalerLoadBalancer', u'listNetscalerLoadBalancers'], u'isasync': True, u'params': [{u'name': u'gslbproviderprivateip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'public IP of the site'}, {u'name': u'isexclusivegslbprovider', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if NetScaler device being added is for providing GSLB service exclusively and can not be used for LB'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach netscaler load balancer device'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach netscaler load balancer device'}, {u'name': u'networkdevicetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Netscaler device type supports NetscalerMPXLoadBalancer, NetscalerVPXLoadBalancer, NetscalerSDXLoadBalancer'}, {u'name': u'gslbprovider', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if NetScaler device being added is for providing GSLB service'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the netscaler load balancer appliance.'}, {u'name': u'gslbproviderpublicip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'public IP of the site'}], u'requiredparams': [u'password', u'username', u'networkdevicetype', u'physicalnetworkid', u'url'], u'response': [{u'type': u'list', u'name': u'podids', u'description': u"Used when NetScaler device is provider of EIP service. This parameter represents the list of pod's, for which there exists a policy based route on datacenter L3 router to route pod's subnet IP to a NetScaler device."}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}, {u'type': u'boolean', u'name': u'isexclusivegslbprovider', u'description': u'true if NetScaler device is provisioned exclusively to be a GSLB service provider'}, {u'type': u'boolean', u'name': u'gslbprovider', u'description': u'true if NetScaler device is provisioned to be a GSLB service provider'}, {u'type': u'string', u'name': u'gslbproviderpublicip', u'description': u'public IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'string', u'name': u'gslbproviderprivateip', u'description': u'private IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the netscaler load balancer'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this netscaler device belongs to'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}], u'description': u'Adds a netscaler load balancer device'}, u'paloaltofirewall': {u'name': u'addPaloAltoFirewall', u'related': [u'listPaloAltoFirewalls', u'configurePaloAltoFirewall'], u'isasync': True, u'params': [{u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach Palo Alto firewall device'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach Palo Alto firewall device'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the Palo Alto appliance.'}, {u'name': u'networkdevicetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'supports only PaloAltoFirewall'}], u'requiredparams': [u'physicalnetworkid', u'username', u'password', u'url', u'networkdevicetype'], u'response': [{u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the Palo Alto firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this Palo Alto firewall belongs to'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}], u'description': u'Adds a Palo Alto firewall device'}, u'region': {u'name': u'addRegion', u'related': [], u'isasync': False, u'params': [{u'name': u'endpoint', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Region service endpoint'}, {u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Id of the Region'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the region'}], u'requiredparams': [u'endpoint', u'id', u'name'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the region'}, {u'type': u'string', u'name': u'endpoint', u'description': u'the end point of the region'}, {u'type': u'boolean', u'name': u'gslbserviceenabled', u'description': u'true if GSLB service is enabled in the region, false otherwise'}, {u'type': u'integer', u'name': u'id', u'description': u'the ID of the region'}, {u'type': u'boolean', u'name': u'portableipserviceenabled', u'description': u'true if security groups support is enabled, false otherwise'}], u'description': u'Adds a Region'}, u'stratospheressp': {u'name': u'addStratosphereSsp', u'related': [], u'isasync': False, u'params': [{u'name': u'tenantuuid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'stratosphere ssp tenant uuid'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'stratosphere ssp api username'}, {u'name': u'password', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'stratosphere ssp api password'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the zone ID'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'stratosphere ssp server url'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'stratosphere ssp api name'}], u'requiredparams': [u'zoneid', u'url', u'name'], u'response': [{u'type': u'string', u'name': u'hostid', u'description': u'server id of the stratosphere ssp server'}, {u'type': u'string', u'name': u'url', u'description': u'url of ssp endpoint'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone which this ssp controls'}, {u'type': u'string', u'name': u'name', u'description': u'name'}], u'description': u'Adds stratosphere ssp server'}, u'vmwaredc': {u'name': u'addVmwareDc', u'related': [u'listVmwareDcs'], u'isasync': False, u'params': [{u'name': u'vcenter', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'The name/ip of vCenter. Make sure it is IP address or full qualified domain name for host running vCenter server.'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The Username required to connect to resource.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of VMware datacenter to be added to specified zone.'}, {u'name': u'password', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The password for specified username.'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'The Zone ID.'}], u'requiredparams': [u'vcenter', u'name', u'zoneid'], u'response': [{u'type': u'long', u'name': u'zoneid', u'description': u'the Zone ID associated with this VMware Datacenter'}, {u'type': u'string', u'name': u'id', u'description': u'The VMware Datacenter ID'}, {u'type': u'string', u'name': u'vcenter', u'description': u'The VMware vCenter name/ip'}, {u'type': u'string', u'name': u'name', u'description': u'The VMware Datacenter name'}], u'description': u'Adds a VMware datacenter to specified zone'}, u'f5loadbalancer': {u'name': u'addF5LoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'URL of the F5 load balancer appliance.'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach F5 BigIP load balancer device'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Credentials to reach F5 BigIP load balancer device'}, {u'name': u'networkdevicetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'supports only F5BigIpLoadBalancer'}], u'requiredparams': [u'url', u'password', u'physicalnetworkid', u'username', u'networkdevicetype'], u'response': [{u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this F5 device belongs to'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the F5 load balancer'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}], u'description': u'Adds a F5 BigIP load balancer device'}, u'resourcedetail': {u'name': u'addResourceDetail', u'related': [], u'isasync': True, u'params': [{u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'pass false if you want this detail to be disabled for the regular user. True by default'}, {u'name': u'resourceid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'resource id to create the details for'}, {u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'type of the resource'}, {u'name': u'details', u'required': True, u'related': [], u'length': 255, u'type': u'map', u'description': u'Map of (key/value pairs)'}], u'requiredparams': [u'resourceid', u'resourcetype', u'details'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Adds detail for the Resource.'}, u'imagestore': {u'name': u'addImageStore', u'related': [u'listSwifts', u'createSecondaryStagingStore'], u'isasync': False, u'params': [{u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL for the image store'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the image store'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name for the image store'}, {u'name': u'provider', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the image store provider name'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'the details for the image store. Example: details[0].key=accesskey&details[0].value=s389ddssaa&details[1].key=secretkey&details[1].value=8dshfsss'}], u'requiredparams': [u'provider'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}], u'description': u'Adds backup image store.'}, u'networkserviceprovider': {u'name': u'addNetworkServiceProvider', u'related': [u'updateNetworkServiceProvider'], u'isasync': True, u'params': [{u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name for the physical network service provider'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the Physical Network ID to add the provider to'}, {u'name': u'servicelist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the list of services to be enabled for this physical network service provider'}, {u'name': u'destinationphysicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the destination Physical Network ID to bridge to'}], u'requiredparams': [u'name', u'physicalnetworkid'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'description': u'Adds a network serviceProvider to a physical network'}, u'secondarystorage': {u'name': u'addSecondaryStorage', u'related': [u'addSwift', u'listSecondaryStagingStores', u'addS3', u'listImageStores', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore', u'listS3s'], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the secondary storage'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL for the secondary storage'}], u'requiredparams': [u'url'], u'response': [{u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}], u'description': u'Adds secondary storage.'}}, u'verbs': [u'authorize', u'restore', u'suspend', u'revoke', u'disassociate', u'migrate', u'lock', u'dedicate', u'activate', u'reconnect', u'cancel', u'query', u'recover', u'extract', u'archive', u'detach', u'prepare', u'saml', u'revert', u'create', u'associate', u'reboot', u'find', u'attach', u'add', u'restart', u'deploy', u'ldap', u'destroy', u'issue', u'start', u'enable', u'configure', u'get', u'stop', u'update', u'change', u'replace', u'disable', u'logout', u'scale', u'import', u'copy', u'generate', u'resize', u'reset', u'expunge', u'upgrade', u'register', u'list', u'upload', u'remove', u'mark', u'clean', u'release', u'login', u'assign', u'delete'], u'change': {u'serviceforvirtualmachine': {u'name': u'changeServiceForVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': False, u'params': [{u'name': u'serviceofferingid', u'required': True, u'related': [u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the service offering ID to apply to the virtual machine'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'name value pairs of custom parameters for cpu, memory and cpunumber. example details[i].name=value'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'serviceofferingid', u'id'], u'response': [{u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}], u'name': u'nic'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}], u'name': u'egressrule'}], u'name': u'securitygroup'}], u'description': u'Changes the service offering for a virtual machine. The virtual machine must be in a "Stopped" state for this command to take effect.'}, u'serviceforsystemvm': {u'name': u'changeServiceForSystemVm', u'related': [u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'rebootSystemVm'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system vm'}, {u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the service offering ID to apply to the system vm'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'name value pairs of custom parameters for cpu, memory and cpunumber. example details[i].name=value'}], u'requiredparams': [u'id', u'serviceofferingid'], u'response': [{u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}], u'description': u'Changes the service offering for a system vm (console proxy or secondary storage). The system vm must be in a "Stopped" state for this command to take effect.'}, u'serviceforrouter': {u'name': u'changeServiceForRouter', u'related': [u'listInternalLoadBalancerVMs', u'startRouter'], u'isasync': False, u'params': [{u'name': u'serviceofferingid', u'required': True, u'related': [u'createServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the service offering ID to apply to the domain router'}, {u'name': u'id', u'required': True, u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the router'}], u'requiredparams': [u'serviceofferingid', u'id'], u'response': [{u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}], u'description': u'Upgrades domain router to a new service offering'}}, u'ldap': {u'createaccount': {u'name': u'ldapCreateAccount', u'related': [u'listAccounts', u'listAccounts', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'isasync': False, u'params': [{u'name': u'accountid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Account UUID, required for adding account from external provisioning system'}, {u'name': u'timezone', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"Network domain for the account's networks"}, {u'name': u'accounttype', u'required': True, u'related': [], u'length': 255, u'type': u'short', u'description': u'Type of the account.  Specify 0 for user, 1 for root admin, and 2 for domain admin'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique username.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Creates the user under the specified account. If no account is specified, the username will be used as the account name.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Creates the user under the specified domain.'}, {u'name': u'accountdetails', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'details for account used to store specific parameters'}, {u'name': u'userid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'User UUID, required for adding account from external provisioning system'}], u'requiredparams': [u'accounttype', u'username'], u'response': [{u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}], u'name': u'user'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}], u'description': u'Creates an account from an LDAP user'}}, u'destroy': {u'systemvm': {u'name': u'destroySystemVm', u'related': [u'startSystemVm', u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm', u'stopSystemVm'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'startSystemVm', u'scaleSystemVm', u'destroySystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm', u'stopSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}], u'description': u'Destroyes a system virtual machine.'}, u'router': {u'name': u'destroyRouter', u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'destroyRouter', u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the router'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}], u'description': u'Destroys a router.'}, u'virtualmachine': {u'name': u'destroyVirtualMachine', u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}, {u'name': u'expunge', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'If true is passed, the vm is expunged immediately. False by default. Parameter can be passed to the call by ROOT/Domain admin only'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}], u'name': u'securitygroup'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}], u'description': u'Destroys a virtual machine. Once destroyed, only the administrator can recover it.'}}, u'get': {u'solidfirevolumeaccessgroupid': {u'name': u'getSolidFireVolumeAccessGroupId', u'related': [], u'isasync': False, u'params': [{u'name': u'storageid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Storage Pool UUID'}, {u'name': u'clusterid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Cluster UUID'}], u'requiredparams': [u'storageid', u'clusterid'], u'response': [{u'type': u'long', u'name': u'solidFireVolumeAccessGroupId', u'description': u'SolidFire Volume Access Group Id'}], u'description': u'Get the SF Volume Access Group ID'}, u'spmetadata': {u'name': u'getSPMetadata', u'related': [], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'metadata', u'description': u'The Metadata XML'}], u'description': u'Returns SAML2 CloudStack Service Provider MetaData'}, u'apilimit': {u'name': u'getApiLimit', u'related': [u'resetApiLimit'], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'int', u'name': u'apiIssued', u'description': u'number of api already issued'}, {u'type': u'long', u'name': u'expireAfter', u'description': u'seconds left to reset counters'}, {u'type': u'int', u'name': u'apiAllowed', u'description': u'currently allowed number of apis'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the api remaining count'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account uuid of the api remaining count'}], u'description': u'Get API limit count for the caller'}, u'vmpassword': {u'name': u'getVMPassword', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'encryptedpassword', u'description': u'The base64 encoded encrypted password of the VM'}], u'description': u'Returns an encrypted password for the VM'}, u'virtualmachineuserdata': {u'name': u'getVirtualMachineUserData', u'related': [], u'isasync': False, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'userdata', u'description': u'Base 64 encoded VM user data'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the ID of the virtual machine'}], u'description': u'Returns user data associated with the VM'}, u'cloudidentifier': {u'name': u'getCloudIdentifier', u'related': [], u'isasync': False, u'params': [{u'name': u'userid', u'required': True, u'related': [u'lockUser', u'listUsers'], u'length': 255, u'type': u'uuid', u'description': u'the user ID for the cloud identifier'}], u'requiredparams': [u'userid'], u'response': [{u'type': u'string', u'name': u'userid', u'description': u'the user ID for the cloud identifier'}, {u'type': u'string', u'name': u'cloudidentifier', u'description': u'the cloud identifier'}, {u'type': u'string', u'name': u'signature', u'description': u'the signed response for the cloud identifier'}], u'description': u'Retrieves a cloud identifier.'}, u'user': {u'name': u'getUser', u'related': [u'lockUser', u'disableUser', u'listUsers', u'updateUser'], u'isasync': False, u'params': [{u'name': u'userapikey', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'API key of the user'}], u'requiredparams': [u'userapikey'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}], u'description': u'Find user account by API key'}, u'solidfireaccountid': {u'name': u'getSolidFireAccountId', u'related': [], u'isasync': False, u'params': [{u'name': u'storageid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Storage Pool UUID'}, {u'name': u'accountid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'CloudStack Account UUID'}], u'requiredparams': [u'storageid', u'accountid'], u'response': [{u'type': u'long', u'name': u'solidFireAccountId', u'description': u'SolidFire Account ID'}], u'description': u'Get SolidFire Account ID'}, u'solidfirevolumeiscsiname': {u'name': u'getSolidFireVolumeIscsiName', u'related': [], u'isasync': False, u'params': [{u'name': u'volumeid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'CloudStack Volume UUID'}], u'requiredparams': [u'volumeid'], u'response': [{u'type': u'string', u'name': u'solidFireVolumeIscsiName', u'description': u'SolidFire Volume Iscsi Name'}], u'description': u"Get SolidFire Volume's Iscsi Name"}, u'solidfirevolumesize': {u'name': u'getSolidFireVolumeSize', u'related': [], u'isasync': False, u'params': [{u'name': u'volumeid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Volume UUID'}, {u'name': u'storageid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Storage Pool UUID'}], u'requiredparams': [u'volumeid', u'storageid'], u'response': [{u'type': u'long', u'name': u'solidFireVolumeSize', u'description': u'SolidFire Volume Size Including Hypervisor Snapshot Reserve'}], u'description': u'Get the SF volume size including Hypervisor Snapshot Reserve'}}, u'issue': {u'nuagevspresourcerequest': {u'name': u'issueNuageVspResourceRequest', u'related': [], u'isasync': False, u'params': [{u'name': u'resourcefilter', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the resource filter in Nuage VSP'}, {u'name': u'networkofferingid', u'required': True, u'related': [u'createNetworkOffering', u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'the network offering id'}, {u'name': u'childresource', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the child resource in Nuage VSP'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the Zone ID for the network'}, {u'name': u'physicalnetworkid', u'required': False, u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the physical network in to which Nuage VSP Controller is added'}, {u'name': u'resourceid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ID of the resource in Nuage VSP'}, {u'name': u'resource', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the resource in Nuage VSP'}, {u'name': u'method', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the Nuage VSP REST API method type'}], u'requiredparams': [u'networkofferingid', u'zoneid', u'resource', u'method'], u'response': [{u'type': u'string', u'name': u'resourceinfo', u'description': u'the details of the Nuage VSP resource'}], u'description': u'Issues a Nuage VSP REST API resource request'}}, u'start': {u'systemvm': {u'name': u'startSystemVm', u'related': [u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'startSystemVm', u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}], u'description': u'Starts a system virtual machine.'}, u'router': {u'name': u'startRouter', u'related': [u'listInternalLoadBalancerVMs'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listInternalLoadBalancerVMs', u'startRouter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the router'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}], u'description': u'Starts a router.'}, u'internalloadbalancervm': {u'name': u'startInternalLoadBalancerVM', u'related': [u'destroyRouter', u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'destroyRouter', u'changeServiceForRouter', u'startInternalLoadBalancerVM', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the internal lb vm'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}], u'name': u'nic'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}], u'description': u'Starts an existing internal lb vm.'}, u'virtualmachine': {u'name': u'startVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}, {u'name': u'hostid', u'required': False, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'destination Host ID to deploy the VM to - parameter available for root admin only'}, {u'name': u'deploymentplanner', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Deployment planner to use for vm allocation. Available to ROOT admin only'}], u'requiredparams': [u'id'], u'response': [{u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}], u'name': u'egressrule'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}], u'description': u'Starts a virtual machine.'}}, u'count': 508, u'enable': {u'account': {u'name': u'enableAccount', u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'updateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Enables specified account.'}, {u'name': u'id', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'updateAccount', u'enableAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'Account id'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'Enables specified account in this domain.'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}], u'name': u'user'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}], u'description': u'Enables an account'}, u'storagemaintenance': {u'name': u'enableStorageMaintenance', u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'findStoragePoolsForMigration'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'enableStorageMaintenance', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'Primary storage ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}], u'description': u'Puts storage pool into maintenance state'}, u'cisconexusvsm': {u'name': u'enableCiscoNexusVSM', u'related': [u'disableCiscoNexusVSM'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'enableCiscoNexusVSM', u'disableCiscoNexusVSM'], u'length': 255, u'type': u'uuid', u'description': u'Id of the Cisco Nexus 1000v VSM device to be enabled'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'vsmconfigstate', u'description': u'The Config State (Primary/Standby) of the VSM'}, {u'type': u'string', u'name': u'vsmmgmtvlanid', u'description': u'management vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'vsmdevicestate', u'description': u'The Device State (Enabled/Disabled) of the VSM'}, {u'type': u'int', u'name': u'vsmstoragevlanid', u'description': u'storage vlan id of the VSM'}, {u'type': u'int', u'name': u'vsmctrlvlanid', u'description': u'control vlan id of the VSM'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external Cisco Nexus 1000v Virtual Supervisor Module'}, {u'type': u'string', u'name': u'vsmdomainid', u'description': u"The VSM is a switch supervisor. This is the VSM's switch domain id"}, {u'type': u'string', u'name': u'vsmdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'vsmdeviceid', u'description': u'device id of the Cisco N1KV VSM device'}, {u'type': u'int', u'name': u'vsmpktvlanid', u'description': u'packet vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmconfigmode', u'description': u'The mode of the VSM (standalone/HA)'}], u'description': u'Enable a Cisco Nexus VSM device'}, u'staticnat': {u'name': u'enableStaticNat', u'related': [], u'isasync': False, u'params': [{u'name': u'vmguestip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'VM guest nic Secondary ip address for the port forwarding rule'}, {u'name': u'ipaddressid', u'required': True, u'related': [u'updateIpAddress', u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the public IP address id for which static nat feature is being enabled'}, {u'name': u'networkid', u'required': False, u'related': [u'listBrocadeVcsDeviceNetworks', u'listF5LoadBalancerNetworks', u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listPaloAltoFirewallNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The network of the vm the static nat will be enabled for. Required when public Ip address is not associated with any Guest network yet (VPC case)'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine for enabling static nat feature'}], u'requiredparams': [u'ipaddressid', u'virtualmachineid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Enables static nat for given ip address'}, u'user': {u'name': u'enableUser', u'related': [u'lockUser', u'disableUser', u'getUser', u'listUsers', u'updateUser', u'createUser'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'lockUser', u'disableUser', u'enableUser', u'getUser', u'listUsers', u'updateUser', u'createUser'], u'length': 255, u'type': u'uuid', u'description': u'Enables user by user ID.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}], u'description': u'Enables a user account'}, u'autoscalevmgroup': {u'name': u'enableAutoScaleVmGroup', u'related': [u'updateAutoScaleVmGroup'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale group'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'state', u'description': u'the current state of the AutoScale Vm Group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'int', u'name': u'minmembers', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'type': u'int', u'name': u'interval', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'type': u'int', u'name': u'maxmembers', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'type': u'string', u'name': u'vmprofileid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'list', u'name': u'scaledownpolicies', u'description': u'list of scaledown autoscale policies'}, {u'type': u'list', u'name': u'scaleuppolicies', u'description': u'list of scaleup autoscale policies'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is group for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm group ID'}], u'description': u'Enables an AutoScale Vm Group'}}, u'configure': {u'netscalerloadbalancer': {u'name': u'configureNetscalerLoadBalancer', u'related': [u'listNetscalerLoadBalancers'], u'isasync': True, u'params': [{u'name': u'lbdeviceid', u'required': True, u'related': [u'configureNetscalerLoadBalancer', u'listNetscalerLoadBalancers'], u'length': 255, u'type': u'uuid', u'description': u'Netscaler load balancer device ID'}, {u'name': u'podids', u'required': False, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'list', u'description': u"Used when NetScaler device is provider of EIP service. This parameter represents the list of pod's, for which there exists a policy based route on datacenter L3 router to route pod's subnet IP to a NetScaler device."}, {u'name': u'lbdevicecapacity', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'capacity of the device, Capacity will be interpreted as number of networks device can handle'}, {u'name': u'inline', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if netscaler load balancer is intended to be used in in-line with firewall, false if netscaler load balancer will side-by-side with firewall'}, {u'name': u'lbdevicededicated', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this netscaler device to dedicated for a account, false if the netscaler device will be shared by multiple accounts'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'gslbproviderprivateip', u'description': u'private IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this netscaler device belongs to'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}, {u'type': u'boolean', u'name': u'isexclusivegslbprovider', u'description': u'true if NetScaler device is provisioned exclusively to be a GSLB service provider'}, {u'type': u'boolean', u'name': u'gslbprovider', u'description': u'true if NetScaler device is provisioned to be a GSLB service provider'}, {u'type': u'list', u'name': u'podids', u'description': u"Used when NetScaler device is provider of EIP service. This parameter represents the list of pod's, for which there exists a policy based route on datacenter L3 router to route pod's subnet IP to a NetScaler device."}, {u'type': u'string', u'name': u'gslbproviderpublicip', u'description': u'public IP of the NetScaler representing GSLB site'}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the netscaler load balancer'}], u'description': u'configures a netscaler load balancer device'}, u'paloaltofirewall': {u'name': u'configurePaloAltoFirewall', u'related': [], u'isasync': True, u'params': [{u'name': u'fwdevicecapacity', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'capacity of the firewall device, Capacity will be interpreted as number of networks device can handle'}, {u'name': u'fwdeviceid', u'required': True, u'related': [u'configurePaloAltoFirewall'], u'length': 255, u'type': u'uuid', u'description': u'Palo Alto firewall device ID'}], u'requiredparams': [u'fwdeviceid'], u'response': [{u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the Palo Alto firewall'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this Palo Alto firewall belongs to'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}], u'description': u'Configures a Palo Alto firewall device'}, u'ovselement': {u'name': u'configureOvsElement', u'related': [], u'isasync': True, u'params': [{u'name': u'enabled', u'required': True, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Enabled/Disabled the service provider'}, {u'name': u'id', u'required': True, u'related': [u'configureOvsElement'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the ovs provider'}], u'requiredparams': [u'enabled', u'id'], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the provider'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the provider'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the provider'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the ovs'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the service provider'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the provider'}], u'description': u'Configures an ovs element.'}, u'f5loadbalancer': {u'name': u'configureF5LoadBalancer', u'related': [u'addF5LoadBalancer'], u'isasync': True, u'params': [{u'name': u'lbdeviceid', u'required': True, u'related': [u'configureF5LoadBalancer', u'addF5LoadBalancer'], u'length': 255, u'type': u'uuid', u'description': u'F5 load balancer device ID'}, {u'name': u'lbdevicecapacity', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'capacity of the device, Capacity will be interpreted as number of networks device can handle'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the load balancer'}, {u'type': u'string', u'name': u'lbdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'lbdeviceid', u'description': u'device id of the F5 load balancer'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this F5 device belongs to'}, {u'type': u'long', u'name': u'lbdevicecapacity', u'description': u'device capacity'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external load balancer'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the load balancer'}, {u'type': u'string', u'name': u'lbdevicestate', u'description': u'device state'}, {u'type': u'boolean', u'name': u'lbdevicededicated', u'description': u'true if device is dedicated for an account'}], u'description': u'configures a F5 load balancer device'}, u'virtualrouterelement': {u'name': u'configureVirtualRouterElement', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'configureVirtualRouterElement'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual router provider'}, {u'name': u'enabled', u'required': True, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Enabled/Disabled the service provider'}], u'requiredparams': [u'id', u'enabled'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the provider'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the provider'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the service provider'}, {u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the provider'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the provider'}], u'description': u'Configures a virtual router element.'}, u'srxfirewall': {u'name': u'configureSrxFirewall', u'related': [u'listSrxFirewalls'], u'isasync': True, u'params': [{u'name': u'fwdevicecapacity', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'capacity of the firewall device, Capacity will be interpreted as number of networks device can handle'}, {u'name': u'fwdeviceid', u'required': True, u'related': [u'listSrxFirewalls', u'configureSrxFirewall'], u'length': 255, u'type': u'uuid', u'description': u'SRX firewall device ID'}], u'requiredparams': [u'fwdeviceid'], u'response': [{u'type': u'string', u'name': u'username', u'description': u"the username that's used to log in to the external firewall"}, {u'type': u'string', u'name': u'zoneid', u'description': u'the zone ID of the external firewall'}, {u'type': u'string', u'name': u'privateinterface', u'description': u'the private interface of the external firewall'}, {u'type': u'string', u'name': u'provider', u'description': u'name of the provider'}, {u'type': u'string', u'name': u'privatezone', u'description': u'the private security zone of the external firewall'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external firewall'}, {u'type': u'string', u'name': u'fwdeviceid', u'description': u'device id of the SRX firewall'}, {u'type': u'string', u'name': u'publicinterface', u'description': u'the public interface of the external firewall'}, {u'type': u'string', u'name': u'fwdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'publiczone', u'description': u'the public security zone of the external firewall'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this SRX firewall belongs to'}, {u'type': u'string', u'name': u'numretries', u'description': u'the number of times to retry requests to the external firewall'}, {u'type': u'string', u'name': u'usageinterface', u'description': u'the usage interface of the external firewall'}, {u'type': u'string', u'name': u'fwdevicename', u'description': u'device name'}, {u'type': u'string', u'name': u'timeout', u'description': u'the timeout (in seconds) for requests to the external firewall'}, {u'type': u'long', u'name': u'fwdevicecapacity', u'description': u'device capacity'}], u'description': u'Configures a SRX firewall device'}, u'internalloadbalancerelement': {u'name': u'configureInternalLoadBalancerElement', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'configureInternalLoadBalancerElement'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the internal lb provider'}, {u'name': u'enabled', u'required': True, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Enables/Disables the Internal Load Balancer element'}], u'requiredparams': [u'id', u'enabled'], u'response': [{u'type': u'string', u'name': u'nspid', u'description': u'the physical network service provider id of the element'}, {u'type': u'boolean', u'name': u'enabled', u'description': u'Enabled/Disabled the element'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the internal load balancer element'}], u'description': u'Configures an Internal Load Balancer element.'}}, u'associate': {u'ucsprofiletoblade': {u'name': u'associateUcsProfileToBlade', u'related': [u'listUcsBlades'], u'isasync': True, u'params': [{u'name': u'ucsmanagerid', u'required': True, u'related': [u'addUcsManager'], u'length': 255, u'type': u'uuid', u'description': u'ucs manager id'}, {u'name': u'profiledn', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'profile dn'}, {u'name': u'bladeid', u'required': True, u'related': [u'associateUcsProfileToBlade', u'listUcsBlades'], u'length': 255, u'type': u'uuid', u'description': u'blade id'}], u'requiredparams': [u'ucsmanagerid', u'profiledn', u'bladeid'], u'response': [{u'type': u'string', u'name': u'ucsmanagerid', u'description': u'ucs manager id'}, {u'type': u'string', u'name': u'profiledn', u'description': u'associated ucs profile dn'}, {u'type': u'string', u'name': u'bladedn', u'description': u'ucs blade dn'}, {u'type': u'string', u'name': u'hostid', u'description': u'cloudstack host id this blade associates to'}, {u'type': u'string', u'name': u'id', u'description': u'ucs blade id'}], u'description': u'associate a profile to a blade'}, u'ipaddress': {u'name': u'associateIpAddress', u'related': [u'listPublicIpAddresses', u'associateIpAddress'], u'isasync': True, u'params': [{u'name': u'regionid', u'required': False, u'related': [u'addRegion'], u'length': 255, u'type': u'integer', u'description': u'region ID from where portable ip is to be associated.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain to associate with this IP address'}, {u'name': u'vpcid', u'required': False, u'related': [u'listVPCs', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the VPC you want the ip address to be associated with'}, {u'name': u'isportable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'should be set to true if public IP is required to be transferable across zones, if not specified defaults to false'}, {u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the availability zone you want to acquire an public IP address from'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the ip to the end user or not'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account to associate with this IP address'}, {u'name': u'networkid', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The network this ip address should be associated to.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'Deploy vm for the project'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'vlanid', u'description': u'the ID of the VLAN associated with the IP address. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'purpose', u'description': u'purpose of the IP address. In Acton this value is not null for Ips with isSystem=true, and can have either StaticNat or LB value'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is public ip for display to the regular user'}, {u'type': u'boolean', u'name': u'isstaticnat', u'description': u'true if this ip is for static nat, false otherwise'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the IP address'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'public IP address id'}, {u'type': u'boolean', u'name': u'isportable', u'description': u'is public IP portable across the zones'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'associatednetworkname', u'description': u'the name of the Network associated with the IP address'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'description': u'the list of resource tags associated with ip address', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vlanname', u'description': u'the VLAN associated with the IP address'}, {u'type': u'string', u'name': u'vmipaddress', u'description': u'virutal machine (dnat) ip address (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'virutal machine id the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'virutal machine name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the public IP address is associated with'}, {u'type': u'string', u'name': u'account', u'description': u'the account the public IP address is associated with'}, {u'type': u'boolean', u'name': u'issourcenat', u'description': u'true if the IP address is a source nat address, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain the public IP address is associated with'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'virutal machine display name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if this ip is system ip (was allocated as a part of deployVm or createLbRule)'}, {u'type': u'string', u'name': u'associatednetworkid', u'description': u'the ID of the Network associated with the IP address'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the public IP address was acquired'}], u'description': u'Acquires and associates a public IP to an account.'}}, u'stop': {u'systemvm': {u'name': u'stopSystemVm', u'related': [u'startSystemVm', u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm'], u'isasync': True, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force stop the VM.  The caller knows the VM is stopped.'}, {u'name': u'id', u'required': True, u'related': [u'startSystemVm', u'scaleSystemVm', u'migrateSystemVm', u'listSystemVms', u'changeServiceForSystemVm', u'rebootSystemVm', u'stopSystemVm'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the system virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the system VM'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the system VM'}, {u'type': u'string', u'name': u'privatemacaddress', u'description': u'the private MAC address for the system VM'}, {u'type': u'integer', u'name': u'activeviewersessions', u'description': u'the number of active console sessions for the console proxy system vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the system VM'}, {u'type': u'string', u'name': u'privateip', u'description': u'the private IP address for the system VM'}, {u'type': u'string', u'name': u'privatenetmask', u'description': u'the private netmask for the system VM'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the system VM'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the system VM'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the system VM'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the system VM'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the system VM'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the system VM'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the system vm'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the system VM'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the system VM'}, {u'type': u'string', u'name': u'jobid', u'description': u'the job ID associated with the system VM. This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the system VM'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the system VM'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the system VM'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the system VM'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'the system VM type'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the system vm'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the system VM'}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the job status associated with the system VM.  This is only displayed if the router listed is part of a currently running asynchronous job.'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the system vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the system VM was created'}], u'description': u'Stops a system VM.'}, u'router': {u'name': u'stopRouter', u'related': [u'destroyRouter', u'changeServiceForRouter', u'startInternalLoadBalancerVM', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'destroyRouter', u'changeServiceForRouter', u'startInternalLoadBalancerVM', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM', u'rebootRouter', u'stopRouter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the router'}, {u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force stop the VM. The caller knows the VM is stopped.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}], u'description': u'Stops a router.'}, u'internalloadbalancervm': {u'name': u'stopInternalLoadBalancerVM', u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter'], u'isasync': True, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force stop the VM. The caller knows the VM is stopped.'}, {u'name': u'id', u'required': True, u'related': [u'changeServiceForRouter', u'listInternalLoadBalancerVMs', u'startRouter', u'stopInternalLoadBalancerVM'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the internal lb vm'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'templateid', u'description': u'the template ID for the router'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the router'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the router'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'linklocalnetworkid', u'description': u'the ID of the corresponding link local network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the router'}, {u'type': u'string', u'name': u'hostname', u'description': u'the hostname for the router'}, {u'type': u'string', u'name': u'linklocalmacaddress', u'description': u'the link local MAC address for the router'}, {u'type': u'string', u'name': u'role', u'description': u'role of the domain router'}, {u'type': u'string', u'name': u'version', u'description': u'the version of template'}, {u'type': u'string', u'name': u'guestnetworkid', u'description': u'the ID of the corresponding guest network'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the router'}, {u'type': u'boolean', u'name': u'requiresupgrade', u'description': u'true if the router template requires upgrader'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID for the router'}, {u'description': u'the list of nics associated with the router', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}], u'name': u'nic'}, {u'type': u'string', u'name': u'hostid', u'description': u'the host ID for the router'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the router was created'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the router'}, {u'type': u'string', u'name': u'publicnetworkid', u'description': u'the ID of the corresponding public network'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the router'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name for the router'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address for the router'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the router belongs to'}, {u'type': u'boolean', u'name': u'isredundantrouter', u'description': u'if this router is an redundant virtual router'}, {u'type': u'string', u'name': u'guestipaddress', u'description': u'the guest IP address for the router'}, {u'type': u'string', u'name': u'linklocalip', u'description': u'the link local IP address for the router'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the router'}, {u'type': u'string', u'name': u'guestnetmask', u'description': u'the guest netmask for the router'}, {u'type': u'string', u'name': u'linklocalnetmask', u'description': u'the link local netmask for the router'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain for the router'}, {u'type': u'string', u'name': u'redundantstate', u'description': u'the state of redundant virtual router'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID associated with the router'}, {u'type': u'string', u'name': u'publicmacaddress', u'description': u'the public MAC address for the router'}, {u'type': u'string', u'name': u'publicnetmask', u'description': u'the public netmask for the router'}, {u'type': u'string', u'name': u'guestmacaddress', u'description': u'the guest MAC address for the router'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the router'}, {u'type': u'string', u'name': u'scriptsversion', u'description': u'the version of scripts'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the router'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the router'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway for the router'}], u'description': u'Stops an Internal LB vm.'}, u'virtualmachine': {u'name': u'stopVirtualMachine', u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force stop the VM (vm is marked as Stopped even when command fails to be send to the backend).  The caller knows the VM is stopped.'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}], u'name': u'securitygroup'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}], u'description': u'Stops a virtual machine.'}}, u'update': {u'loadbalancerrule': {u'name': u'updateLoadBalancerRule', u'related': [u'createLoadBalancerRule', u'listLoadBalancerRules'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the load balancer rule'}, {u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the id of the load balancer rule to update'}, {u'name': u'description', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the description of the load balancer rule'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'algorithm', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'load balancer algorithm (source, roundrobin, leastconn)'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}], u'description': u'Updates load balancer'}, u'domain': {u'name': u'updateDomain', u'related': [u'listDomainChildren'], u'isasync': False, u'params': [{u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"Network domain for the domain's networks; empty string will update domainName with NULL value"}, {u'name': u'id', u'required': True, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'ID of domain to update'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'updates domain with this name'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the domain'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the domain'}, {u'type': u'string', u'name': u'parentdomainname', u'description': u'the domain name of the parent domain'}, {u'type': u'string', u'name': u'parentdomainid', u'description': u'the domain ID of the parent domain'}, {u'type': u'integer', u'name': u'level', u'description': u'the level of the domain'}, {u'type': u'boolean', u'name': u'haschild', u'description': u'whether the domain has one or more sub-domains'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the domain'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}], u'description': u'Updates a domain with a new name'}, u'projectinvitation': {u'name': u'updateProjectInvitation', u'related': [], u'isasync': True, u'params': [{u'name': u'projectid', u'required': True, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to join'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'account that is joining the project'}, {u'name': u'accept', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true, accept the invitation, decline if false. True by default'}, {u'name': u'token', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'list invitations for specified account; this parameter has to be specified with domainId'}], u'requiredparams': [u'projectid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Accepts or declines project invitation'}, u'snapshotpolicy': {u'name': u'updateSnapshotPolicy', u'related': [u'listSnapshotPolicies', u'createSnapshotPolicy'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'id', u'required': False, u'related': [u'listSnapshotPolicies', u'updateSnapshotPolicy', u'createSnapshotPolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the snapshot policy'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the snapshot policy to the end user or not.'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is this policy for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the snapshot policy'}, {u'type': u'string', u'name': u'timezone', u'description': u'the time zone of the snapshot policy'}, {u'type': u'short', u'name': u'intervaltype', u'description': u'the interval type of the snapshot policy'}, {u'type': u'string', u'name': u'schedule', u'description': u'time the snapshot is scheduled to be taken.'}, {u'type': u'string', u'name': u'volumeid', u'description': u'the ID of the disk volume'}, {u'type': u'int', u'name': u'maxsnaps', u'description': u'maximum number of snapshots retained'}], u'description': u'Updates the snapshot policy.'}, u'diskoffering': {u'name': u'updateDiskOffering', u'related': [u'listDiskOfferings', u'createDiskOffering'], u'isasync': False, u'params': [{u'name': u'displayoffering', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to display the offering to the end user or not.'}, {u'name': u'sortkey', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'sort key of the disk offering, integer'}, {u'name': u'id', u'required': True, u'related': [u'updateDiskOffering', u'listDiskOfferings', u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'ID of the disk offering'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'updates alternate display text of the disk offering with this value'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'updates name of the disk offering with this value'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'tags', u'description': u'the tags for the disk offering'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name this disk offering belongs to. Ignore this information as it is not currently applicable.'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk offering'}, {u'type': u'boolean', u'name': u'displayoffering', u'description': u'whether to display the offering to the end user or not.'}, {u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'string', u'name': u'cacheMode', u'description': u'the cache mode to use for this disk offering. none, writeback or writethrough'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk offering'}, {u'type': u'date', u'name': u'created', u'description': u'the date this disk offering was created'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this disk offering'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the disk offering'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'true if disk offering uses custom size, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'unique ID of the disk offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID this disk offering belongs to. Ignore this information as it is not currently applicable.'}, {u'type': u'long', u'name': u'disksize', u'description': u'the size of the disk offering in GB'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the disk offering.'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}], u'description': u'Updates a disk offering.'}, u'virtualmachine': {u'name': u'updateVirtualMachine', u'related': [u'listVirtualMachines', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': False, u'params': [{u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS type that best represents this VM.'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'displayvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vm to the end user or not.'}, {u'name': u'group', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'group of the virtual machine'}, {u'name': u'haenable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if high-availability is enabled for the virtual machine, false otherwise'}, {u'name': u'userdata', u'required': False, u'related': [], u'length': 32768, u'type': u'string', u'description': u'an optional binary data that can be sent to the virtual machine upon a successful deployment. This binary data must be base64 encoded before adding it to the request. Using HTTP GET (via querystring), you can send up to 2KB of data after base64 encoding. Using HTTP POST(via POST body), you can send up to 32K of data after base64 encoding.'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'new host name of the vm. The VM has to be stopped/started for this update to take affect'}, {u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if VM contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}, {u'name': u'instancename', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'instance name of the user vm'}, {u'name': u'displayname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'user generated name'}], u'requiredparams': [u'id'], u'response': [{u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}], u'name': u'nic'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}], u'name': u'securitygroup'}], u'description': u'Updates properties of a virtual machine. The VM has to be stopped and restarted for the new properties to take effect. UpdateVirtualMachine does not first check whether the VM is stopped. Therefore, stop the VM manually before issuing this call.'}, u'portforwardingrule': {u'name': u'updatePortForwardingRule', u'related': [u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the port forwarding rule'}, {u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine for the port forwarding rule'}, {u'name': u'publicport', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the public port of the port forwarding rule'}, {u'name': u'privateport', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the private port of the port forwarding rule'}, {u'name': u'privateip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the private IP address of the port forwarding rule'}, {u'name': u'ipaddressid', u'required': False, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the IP address id of the port forwarding rule'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the port fowarding rule. Valid values are TCP or UDP.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'privateport', u'description': u"the starting port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the port forwarding rule'}, {u'type': u'string', u'name': u'privateendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'the VM name for the port forwarding rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'vmguestip', u'description': u'the vm ip address for the port forwarding rule'}, {u'type': u'string', u'name': u'publicendport', u'description': u"the ending port of port forwarding rule's private port range"}, {u'type': u'string', u'name': u'publicport', u'description': u"the starting port of port forwarding rule's public port range"}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is firewall for display to the regular user'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'the VM ID for the port forwarding rule'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the port forwarding rule belongs to'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the port forwarding rule'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'the VM display name for the port forwarding rule'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the port forwarding rule'}], u'description': u'Updates a port forwarding rule.  Only the private port and the virtual machine can be updated.'}, u'cluster': {u'name': u'updateCluster', u'related': [], u'isasync': False, u'params': [{u'name': u'managedstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'whether this cluster is managed by cloudstack'}, {u'name': u'clustername', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the cluster name'}, {u'name': u'id', u'required': True, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Cluster'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this cluster for allocation of new resources'}, {u'name': u'hypervisor', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the cluster'}, {u'name': u'clustertype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'hypervisor type of the cluster'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the cluster'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'type': u'string', u'name': u'memoryovercommitratio', u'description': u'The memory overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the type of the cluster'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the cluster'}, {u'type': u'string', u'name': u'managedstate', u'description': u'whether this cluster is managed by cloudstack'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the cluster'}, {u'description': u'the capacity of the Cluster', u'type': u'list', u'response': [{u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'cpuovercommitratio', u'description': u'The cpu overcommit ratio of the cluster'}, {u'type': u'string', u'name': u'name', u'description': u'the cluster name'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the cluster'}, {u'type': u'string', u'name': u'id', u'description': u'the cluster ID'}, {u'type': u'string', u'name': u'hypervisortype', u'description': u'the hypervisor type of the cluster'}], u'description': u'Updates an existing cluster'}, u'guestos': {u'name': u'updateGuestOs', u'related': [u'addGuestOs', u'listOsTypes'], u'isasync': True, u'params': [{u'name': u'osdisplayname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique display name for Guest OS'}, {u'name': u'id', u'required': True, u'related': [u'addGuestOs', u'updateGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'UUID of the Guest OS'}], u'requiredparams': [u'osdisplayname', u'id'], u'response': [{u'type': u'string', u'name': u'description', u'description': u'the name/description of the OS type'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the ID of the OS category'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the OS type'}, {u'type': u'string', u'name': u'isuserdefined', u'description': u'is the guest OS user defined'}], u'description': u'Updates the information about Guest OS'}, u'hostpassword': {u'name': u'updateHostPassword', u'related': [], u'isasync': False, u'params': [{u'name': u'hostid', u'required': False, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}, {u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the new password for the host/cluster'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the username for the host/cluster'}, {u'name': u'clusterid', u'required': False, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID'}], u'requiredparams': [u'password', u'username'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Update password of a host/pool on management server.'}, u'pod': {u'name': u'updatePod', u'related': [], u'isasync': False, u'params': [{u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address for the Pod'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this cluster for allocation of new resources'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Pod'}, {u'name': u'gateway', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the gateway for the Pod'}, {u'name': u'id', u'required': True, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Pod'}, {u'name': u'netmask', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask of the Pod'}, {u'name': u'startip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the starting IP address for the Pod'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the Pod'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the Pod'}, {u'description': u'the capacity of the Pod', u'type': u'list', u'response': [{u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the Pod'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the Pod'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the Pod'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Pod'}, {u'type': u'string', u'name': u'endip', u'description': u'the ending IP for the Pod'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the Pod'}, {u'type': u'string', u'name': u'startip', u'description': u'the starting IP for the Pod'}], u'description': u'Updates a Pod.'}, u'vpnconnection': {u'name': u'updateVpnConnection', u'related': [u'resetVpnConnection', u'listVpnConnections'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'resetVpnConnection', u'updateVpnConnection', u'listVpnConnections'], u'length': 255, u'type': u'uuid', u'description': u'id of vpn connection'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}], u'requiredparams': [u'id'], u'response': [{u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'string', u'name': u's2svpngatewayid', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'ESP policy of the customer gateway'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is connection for display to the regular user'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of the customer gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'id', u'description': u'the connection ID'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'string', u'name': u'state', u'description': u'State of vpn connection'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'boolean', u'name': u'passive', u'description': u'State of vpn connection'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u's2scustomergatewayid', u'description': u'the customer gateway ID'}], u'description': u'Updates site to site vpn connection'}, u'isopermissions': {u'name': u'updateIsoPermissions', u'related': [], u'isasync': False, u'params': [{u'name': u'isfeatured', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true for featured template/iso, false otherwise'}, {u'name': u'isextractable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template/iso is extractable, false other wise. Can be set only by root admin'}, {u'name': u'id', u'required': True, u'related': [u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the template ID'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true for public template/iso, false for private templates/isos'}, {u'name': u'projectids', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'list', u'description': u'a comma delimited list of projects. If specified, "op" parameter has to be passed in.'}, {u'name': u'op', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'permission operator (add, remove, reset)'}, {u'name': u'accounts', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'a comma delimited list of accounts. If specified, "op" parameter has to be passed in.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Updates iso permissions'}, u'resourcelimit': {u'name': u'updateResourceLimit', u'related': [u'listResourceLimits'], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'Update resource limits for project'}, {u'name': u'max', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'  Maximum resource limit.'}, {u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Type of resource to update. Values are 0, 1, 2, 3, 4, 6, 7, 8, 9, 10 and 11. 0 - Instance. Number of instances a user can create. 1 - IP. Number of public IP addresses a user can own. 2 - Volume. Number of disk volumes a user can create.3 - Snapshot. Number of snapshots a user can create.4 - Template. Number of templates that a user can register/create.6 - Network. Number of guest network a user can create.7 - VPC. Number of VPC a user can create.8 - CPU. Total number of CPU cores a user can use.9 - Memory. Total Memory (in MB) a user can use.10 - PrimaryStorage. Total primary storage space (in GiB) a user can use.11 - SecondaryStorage. Total secondary storage space (in GiB) a user can use.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Update resource for a specified account. Must be used with the domainId parameter.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Update resource limits for all accounts in specified domain. If used with the account parameter, updates resource limits for a specified account in specified domain.'}], u'requiredparams': [u'resourcetype'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the resource limit'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type. Values include 0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11. See the resourceType parameter for more information on these values.'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the resource limit'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the resource limit'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the resource limit'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the resource limit'}, {u'type': u'long', u'name': u'max', u'description': u'the maximum number of the resource. A -1 means the resource currently has no limit.'}], u'description': u'Updates resource limits for an account or domain.'}, u'lbstickinesspolicy': {u'name': u'updateLBStickinessPolicy', u'related': [u'createLBStickinessPolicy', u'listLBStickinessPolicies'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the policy to the end user or not'}, {u'name': u'id', u'required': True, u'related': [u'createLBStickinessPolicy', u'updateLBStickinessPolicy', u'listLBStickinessPolicies'], u'length': 255, u'type': u'uuid', u'description': u'id of lb stickiness policy'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Stickiness policy'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the Stickiness policy'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Stickiness policy'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the Stickiness policy belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'description': u'the list of stickinesspolicies', u'type': u'list', u'response': [{u'type': u'string', u'name': u'methodname', u'description': u'the method name of the Stickiness policy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Stickiness policy'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB Stickiness policy ID'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}, {u'type': u'map', u'name': u'params', u'description': u'the params of the policy'}], u'name': u'stickinesspolicy'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Stickiness policy'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}], u'description': u'Updates LB Stickiness policy'}, u'vpcoffering': {u'name': u'updateVPCOffering', u'related': [u'createVPCOffering', u'listVPCOfferings'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updateVPCOffering', u'createVPCOffering', u'listVPCOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the id of the VPC offering'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the VPC offering'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'update state for the VPC offering; supported states - Enabled/Disabled'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the VPC offering'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u' indicates if the vpc offering supports distributed router for one-hop forwarding'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the vpc offering'}, {u'type': u'boolean', u'name': u'supportsregionLevelvpc', u'description': u' indicated if the offering can support region level vpc'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the vpc offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the vpc offering.'}, {u'type': u'date', u'name': u'created', u'description': u'the date this vpc offering was created'}, {u'type': u'string', u'name': u'state', u'description': u'state of the vpc offering. Can be Disabled/Enabled'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if vpc offering is default, false otherwise'}], u'description': u'Updates VPC offering'}, u'network': {u'name': u'updateNetwork', u'related': [u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'isasync': True, u'params': [{u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'network domain'}, {u'name': u'changecidr', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force update even if cidr type is different'}, {u'name': u'id', u'required': True, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network'}, {u'name': u'networkofferingid', u'required': False, u'related': [u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'network offering ID'}, {u'name': u'guestvmcidr', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'CIDR for Guest VMs,Cloudstack allocates IPs to Guest VMs only from this CIDR'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the new display text for the network'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the new name for the network'}, {u'name': u'displaynetwork', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the network to the end user or not.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}], u'name': u'service'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}], u'description': u'Updates a network'}, u'cloudtouseobjectstore': {u'name': u'updateCloudToUseObjectStore', u'related': [u'addSecondaryStorage', u'addSwift', u'listSecondaryStagingStores', u'addS3', u'listImageStores', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore', u'listS3s'], u'isasync': False, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name for the image store'}, {u'name': u'provider', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the image store provider name'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL for the image store'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'the details for the image store. Example: details[0].key=accesskey&details[0].value=s389ddssaa&details[1].key=secretkey&details[1].value=8dshfsss'}], u'requiredparams': [u'provider'], u'response': [{u'type': u'set', u'name': u'details', u'description': u'the details of the image store'}, {u'type': u'string', u'name': u'url', u'description': u'the url of the image store'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the image store'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the image store'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the image store'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the image store'}, {u'type': u'string', u'name': u'providername', u'description': u'the provider name of the image store'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the image store'}, {u'type': u'scopetype', u'name': u'scope', u'description': u'the scope of the image store'}], u'description': u'Migrate current NFS secondary storages to use object store.'}, u'remoteaccessvpn': {u'name': u'updateRemoteAccessVpn', u'related': [u'listRemoteAccessVpns', u'createRemoteAccessVpn'], u'isasync': True, u'params': [{u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}, {u'name': u'id', u'required': True, u'related': [u'listRemoteAccessVpns', u'updateRemoteAccessVpn', u'createRemoteAccessVpn'], u'length': 255, u'type': u'uuid', u'description': u'id of the remote access vpn'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the account of the remote access vpn'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the account of the remote access vpn'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn for display to the regular user'}, {u'type': u'string', u'name': u'iprange', u'description': u'the range of ips to allocate to the clients'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address of the vpn server'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the remote access vpn'}, {u'type': u'string', u'name': u'presharedkey', u'description': u'the ipsec preshared key'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the remote access vpn'}], u'description': u'Updates remote access vpn'}, u'guestosmapping': {u'name': u'updateGuestOsMapping', u'related': [u'addGuestOsMapping'], u'isasync': True, u'params': [{u'name': u'osnameforhypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hypervisor specific name for this Guest OS'}, {u'name': u'id', u'required': True, u'related': [u'updateGuestOsMapping', u'addGuestOsMapping'], u'length': 255, u'type': u'uuid', u'description': u'UUID of the Guest OS to hypervisor name Mapping'}], u'requiredparams': [u'osnameforhypervisor', u'id'], u'response': [{u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the Guest OS type'}, {u'type': u'string', u'name': u'osnameforhypervisor', u'description': u'hypervisor specific name for the Guest OS'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'version of the hypervisor for mapping'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the Guest OS mapping'}, {u'type': u'string', u'name': u'isuserdefined', u'description': u'is the mapping user defined'}, {u'type': u'string', u'name': u'osdisplayname', u'description': u'standard display name for the Guest OS'}], u'description': u'Updates the information about Guest OS to Hypervisor specific name mapping'}, u'instancegroup': {u'name': u'updateInstanceGroup', u'related': [], u'isasync': False, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'new instance group name'}, {u'name': u'id', u'required': True, u'related': [u'updateInstanceGroup'], u'length': 255, u'type': u'uuid', u'description': u'Instance group ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the instance group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the instance group'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the instance group'}, {u'type': u'date', u'name': u'created', u'description': u'time and date the instance group was created'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the instance group'}], u'description': u'Updates a vm group'}, u'autoscalepolicy': {u'name': u'updateAutoScalePolicy', u'related': [u'createAutoScalePolicy'], u'isasync': True, u'params': [{u'name': u'quiettime', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the cool down period for which the policy should not be evaluated after the action has been taken'}, {u'name': u'duration', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the duration for which the conditions have to be true before action is taken'}, {u'name': u'id', u'required': True, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale policy'}, {u'name': u'conditionids', u'required': False, u'related': [u'listConditions'], u'length': 255, u'type': u'list', u'description': u'the list of IDs of the conditions that are being evaluated on every interval'}], u'requiredparams': [u'id'], u'response': [{u'type': u'list', u'name': u'conditions', u'description': u'the list of IDs of the conditions that are being evaluated on every interval'}, {u'type': u'integer', u'name': u'quiettime', u'description': u'the cool down period for which the policy should not be evaluated after the action has been taken'}, {u'type': u'string', u'name': u'action', u'description': u'the action to be executed if all the conditions evaluate to true for the specified duration.'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the autoscale policy'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale policy ID'}, {u'type': u'integer', u'name': u'duration', u'description': u'the duration for which the conditions have to be true before action is taken'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the autoscale policy'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id autoscale policy'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the autoscale policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the autoscale policy'}], u'description': u'Updates an existing autoscale policy.'}, u'globalloadbalancerrule': {u'name': u'updateGlobalLoadBalancerRule', u'related': [u'listGlobalLoadBalancerRules'], u'isasync': True, u'params': [{u'name': u'description', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the description of the load balancer rule'}, {u'name': u'id', u'required': True, u'related': [u'listGlobalLoadBalancerRules', u'updateGlobalLoadBalancerRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the global load balancer rule'}, {u'name': u'gslbstickysessionmethodname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'session sticky method (sourceip) if not specified defaults to sourceip'}, {u'name': u'gslblbmethod', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"load balancer algorithm (roundrobin, leastconn, proximity) that is used to distributed traffic across the zones participating in global server load balancing, if not specified defaults to 'round robin'"}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'gslbdomainname', u'description': u'DNS domain name given for the global load balancer'}, {u'type': u'string', u'name': u'gslbservicetype', u'description': u'GSLB service type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'gslblbmethod', u'description': u'Load balancing method used for the global load balancer'}, {u'type': u'integer', u'name': u'regionid', u'description': u'Region Id in which global load balancer is created'}, {u'type': u'string', u'name': u'name', u'description': u'name of the global load balancer rule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}, {u'description': u'List of load balancer rules that are part of GSLB rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the load balancer rule'}, {u'type': u'string', u'name': u'publicipid', u'description': u'the public ip address id'}, {u'type': u'string', u'name': u'networkid', u'description': u'the id of the guest network the lb rule belongs to'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the rule belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the load balancer'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the load balancer'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the loadbalanacer rule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the load balancer'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'publicport', u'description': u'the public port'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'description': u'the list of resource tags associated with load balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'id', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the load balancer rule'}, {u'type': u'string', u'name': u'privateport', u'description': u'the private port'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public ip address'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the load balancer rule'}], u'name': u'loadbalancerrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the load balancer'}, {u'type': u'string', u'name': u'gslbstickysessionmethodname', u'description': u'session persistence method used for the global load balancer'}, {u'type': u'string', u'name': u'id', u'description': u'global load balancer rule ID'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the global load balancer rule'}], u'description': u'update global load balancer rules.'}, u'serviceoffering': {u'name': u'updateServiceOffering', u'related': [u'createServiceOffering', u'listServiceOfferings'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'createServiceOffering', u'updateServiceOffering', u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the service offering to be updated'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the service offering to be updated'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the service offering to be updated'}, {u'name': u'sortkey', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'sort key of the service offering, integer'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'issystem', u'description': u'is this a system vm offering'}, {u'type': u'integer', u'name': u'hypervisorsnapshotreserve', u'description': u'Hypervisor snapshot reserve space as a percent of a volume (for managed storage using Xen or VMware)'}, {u'type': u'boolean', u'name': u'isvolatile', u'description': u'true if the vm needs to be volatile, i.e., on every reboot of vm from API root disk is discarded and creates a new root disk'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the service offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the service offering.'}, {u'type': u'date', u'name': u'created', u'description': u'the date this service offering was created'}, {u'type': u'string', u'name': u'systemvmtype', u'description': u'is this a the systemvm type for system vm offering'}, {u'type': u'long', u'name': u'maxiops', u'description': u'the max iops of the disk offering'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the service offering'}, {u'type': u'string', u'name': u'domain', u'description': u'Domain name for the offering'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of CPU'}, {u'type': u'string', u'name': u'deploymentplanner', u'description': u'deployment strategy used to deploy VM.'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the service offering'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the service offering'}, {u'type': u'boolean', u'name': u'offerha', u'description': u'the ha support in the service offering'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the service offering'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the clock rate CPU speed in Mhz'}, {u'type': u'long', u'name': u'miniops', u'description': u'the min iops of the disk offering'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the service offering'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the service offering'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes. Valid values are thin, sparse, fat.'}, {u'type': u'string', u'name': u'hosttags', u'description': u'the host tag for the service offering'}, {u'type': u'boolean', u'name': u'iscustomizediops', u'description': u'true if disk offering uses custom iops, false otherwise'}, {u'type': u'map', u'name': u'serviceofferingdetails', u'description': u'additional key/value details tied with this service offering'}, {u'type': u'boolean', u'name': u'limitcpuuse', u'description': u'restrict the CPU usage to committed service offering'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory in MB'}, {u'type': u'boolean', u'name': u'defaultuse', u'description': u'is this a  default system vm offering'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the service offering'}, {u'type': u'boolean', u'name': u'iscustomized', u'description': u'is true if the offering is customized'}, {u'type': u'string', u'name': u'storagetype', u'description': u'the storage type for this service offering'}], u'description': u'Updates a service offering.'}, u'storagepool': {u'name': u'updateStoragePool', u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'findStoragePoolsForMigration'], u'isasync': False, u'params': [{u'name': u'capacitybytes', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'bytes CloudStack can provision from this storage pool'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'comma-separated list of tags for the storage pool'}, {u'name': u'capacityiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'name': u'id', u'required': True, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the Id of the storage pool'}], u'requiredparams': [u'id'], u'response': [{u'type': u'long', u'name': u'capacityiops', u'description': u'IOPS CloudStack can provision from this storage pool'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'string', u'name': u'name', u'description': u'the name of the storage pool'}, {u'type': u'string', u'name': u'overprovisionfactor', u'description': u'the overprovisionfactor for the storage pool'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the storage pool'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor type of the storage pool'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster for the storage pool'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the storage pool'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the storage pool'}, {u'type': u'storagepoolstatus', u'name': u'state', u'description': u'the state of the storage pool'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster for the storage pool'}, {u'type': u'long', u'name': u'disksizeused', u'description': u"the host's currently used disk size"}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the storage pool'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the storage pool'}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this pool is suitable to migrate a volume, false otherwise'}, {u'type': u'string', u'name': u'path', u'description': u'the storage pool path'}, {u'type': u'string', u'name': u'scope', u'description': u'the scope of the storage pool'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the storage pool'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the storage pool'}, {u'type': u'map', u'name': u'storagecapabilities', u'description': u'the storage pool capabilities'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the storage pool'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the storage pool was created'}, {u'type': u'string', u'name': u'type', u'description': u'the storage pool type'}], u'description': u'Updates a storage pool.'}, u'vpngateway': {u'name': u'updateVpnGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'id', u'required': True, u'related': [u'updateVpnGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of customer gateway'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpn to the end user or not'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpn gateway for display to the regular user'}, {u'type': u'string', u'name': u'vpcid', u'description': u'the vpc id of this gateway'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}], u'description': u'Updates site to site vpn local gateway'}, u'networkacllist': {u'name': u'updateNetworkACLList', u'related': [], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the list to the end user or not'}, {u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Updates Network ACL list'}, u'hypervisorcapabilities': {u'name': u'updateHypervisorCapabilities', u'related': [u'listHypervisorCapabilities'], u'isasync': False, u'params': [{u'name': u'securitygroupenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'set true to enable security group for this hypervisor.'}, {u'name': u'id', u'required': False, u'related': [u'updateHypervisorCapabilities', u'listHypervisorCapabilities'], u'length': 255, u'type': u'uuid', u'description': u'ID of the hypervisor capability'}, {u'name': u'maxguestslimit', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'the max number of Guest VMs per host for this hypervisor.'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'maxguestslimit', u'description': u'the maximum number of guest vms recommended for this hypervisor'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the hypervisor type'}, {u'type': u'boolean', u'name': u'securitygroupenabled', u'description': u'true if security group is supported'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'integer', u'name': u'maxdatavolumeslimit', u'description': u'the maximum number of Data Volumes that can be attached for this hypervisor'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the hypervisor capabilities row'}, {u'type': u'boolean', u'name': u'storagemotionenabled', u'description': u'true if storage motion is supported'}, {u'type': u'integer', u'name': u'maxhostspercluster', u'description': u'the maximum number of Hosts per cluster for this hypervisor'}], u'description': u'Updates a hypervisor capabilities.'}, u'template': {u'name': u'updateTemplate', u'related': [u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS type that best represents the OS of this image.'}, {u'name': u'sortkey', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'sort key of the template, integer'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the display text of the image'}, {u'name': u'isrouting', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template type is routing i.e., if template is used to deploy router'}, {u'name': u'id', u'required': True, u'related': [u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the image file'}, {u'name': u'passwordenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the image supports the password reset feature; default is false'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the image file'}, {u'name': u'bootable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if image is bootable, false otherwise'}, {u'name': u'format', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the format for the image'}, {u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if template/ISO contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}], u'description': u'Updates attributes of a template.'}, u'defaultnicforvirtualmachine': {u'name': u'updateDefaultNicForVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'nicid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'NIC ID'}, {u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Virtual Machine ID'}], u'requiredparams': [u'nicid', u'virtualmachineid'], u'response': [{u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}], u'name': u'ingressrule'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}], u'description': u'Changes the default NIC on a VM'}, u'volume': {u'name': u'updateVolume', u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'storageid', u'required': False, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'Destination storage pool UUID for the volume'}, {u'name': u'chaininfo', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The chain info of the volume'}, {u'name': u'id', u'required': False, u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'displayvolume', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the volume to the end user or not.'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The state of the volume'}, {u'name': u'path', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The path of the volume'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}], u'description': u'Updates the volume.'}, u'host': {u'name': u'updateHost', u'related': [u'listHosts', u'listExternalLoadBalancers', u'prepareHostForMaintenance'], u'isasync': False, u'params': [{u'name': u'hosttags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of tags to be added to the host'}, {u'name': u'oscategoryid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the id of Os category to update the host with'}, {u'name': u'id', u'required': True, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the host to update'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Change resource state of host, valid values are [Enable, Disable]. Operation may failed if host in states not allowing Enable/Disable'}, {u'name': u'url', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the new uri for the secondary storage: nfs://host/path'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'podid', u'description': u'the Pod ID of the host'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the memory total of the host'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the cluster ID of the host'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the host'}, {u'type': u'long', u'name': u'averageload', u'description': u'the cpu average load on the host'}, {u'type': u'string', u'name': u'hypervisorversion', u'description': u'the hypervisor version'}, {u'type': u'boolean', u'name': u'hasenoughcapacity', u'description': u'true if this host has enough CPU and RAM capacity to migrate a VM to it, false otherwise'}, {u'type': u'long', u'name': u'memoryused', u'description': u"the amount of the host's memory currently used"}, {u'type': u'string', u'name': u'oscategoryname', u'description': u'the OS category name of the host'}, {u'type': u'long', u'name': u'disksizetotal', u'description': u'the total disk size of the host'}, {u'type': u'type', u'name': u'type', u'description': u'the host type'}, {u'type': u'string', u'name': u'oscategoryid', u'description': u'the OS category ID of the host'}, {u'type': u'string', u'name': u'hosttags', u'description': u'comma-separated list of tags for the host'}, {u'type': u'long', u'name': u'disksizeallocated', u'description': u"the host's currently allocated disk size"}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'long', u'name': u'managementserverid', u'description': u'the management server ID of the host'}, {u'type': u'date', u'name': u'disconnected', u'description': u'true if the host is disconnected. False otherwise.'}, {u'type': u'long', u'name': u'cpuspeed', u'description': u'the CPU speed of the host'}, {u'type': u'string', u'name': u'capabilities', u'description': u'capabilities of the host'}, {u'type': u'string', u'name': u'cpuwithoverprovisioning', u'description': u"the amount of the host's CPU after applying the cpu.overprovisioning.factor "}, {u'type': u'boolean', u'name': u'islocalstorageactive', u'description': u'true if local storage is active, false otherwise'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'hypervisortype', u'name': u'hypervisor', u'description': u'the host hypervisor'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the IP address of the host'}, {u'type': u'date', u'name': u'lastpinged', u'description': u'the date and time the host was last pinged'}, {u'type': u'string', u'name': u'clustertype', u'description': u'the cluster type of the cluster that host belongs to'}, {u'type': u'boolean', u'name': u'hahost', u'description': u'true if the host is Ha host (dedicated to vms started by HA process; false otherwise'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the CPU number of the host'}, {u'type': u'string', u'name': u'clustername', u'description': u'the cluster name of the host'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name of the host'}, {u'type': u'string', u'name': u'events', u'description': u'events available for the host'}, {u'type': u'long', u'name': u'memoryallocated', u'description': u"the amount of the host's memory currently allocated"}, {u'type': u'boolean', u'name': u'suitableformigration', u'description': u'true if this host is suitable(has enough capacity and satisfies all conditions like hosttags, max guests vm limit etc) to migrate a VM to it , false otherwise'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name of the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the host'}, {u'type': u'string', u'name': u'resourcestate', u'description': u'the resource state of the host'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the host's CPU currently used"}, {u'type': u'string', u'name': u'cpuallocated', u'description': u"the amount of the host's CPU currently allocated"}, {u'description': u'GPU cards present in the host', u'type': u'list', u'response': [{u'type': u'string', u'name': u'gpugroupname', u'description': u'GPU cards present in the host'}, {u'description': u'the list of enabled vGPUs', u'type': u'list', u'response': [{u'type': u'long', u'name': u'remainingcapacity', u'description': u'Remaining capacity in terms of no. of more VMs that can be deployped with this vGPU type'}, {u'type': u'long', u'name': u'maxcapacity', u'description': u'Maximum vgpu can be created with this vgpu type on the given gpu group'}, {u'type': u'long', u'name': u'videoram', u'description': u'Video RAM for this vGPU type'}, {u'type': u'long', u'name': u'maxvgpuperpgpu', u'description': u'Maximum no. of vgpu per gpu card (pgpu)'}, {u'type': u'string', u'name': u'vgputype', u'description': u'Model Name of vGPU'}, {u'type': u'long', u'name': u'maxresolutiony', u'description': u'Maximum Y resolution per display'}, {u'type': u'long', u'name': u'maxresolutionx', u'description': u'Maximum X resolution per display'}, {u'type': u'long', u'name': u'maxheads', u'description': u'Maximum displays per user'}], u'name': u'vgpu'}], u'name': u'gpugroup'}, {u'type': u'string', u'name': u'version', u'description': u'the host version'}, {u'type': u'integer', u'name': u'cpusockets', u'description': u'the number of CPU sockets on the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the host'}, {u'type': u'map', u'name': u'details', u'description': u'Host details in key/value pairs.'}, {u'type': u'status', u'name': u'state', u'description': u'the state of the host'}], u'description': u'Updates a host.'}, u'networkaclitem': {u'name': u'updateNetworkACLItem', u'related': [u'createNetworkACL'], u'isasync': True, u'params': [{u'name': u'endport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the ending port of ACL'}, {u'name': u'icmpcode', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'error code for this icmp message'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'number', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'The network of the vm the ACL will be created for'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'startport', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the starting port of ACL'}, {u'name': u'protocol', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the protocol for the ACL rule. Valid values are TCP/UDP/ICMP/ALL or valid protocol number'}, {u'name': u'id', u'required': True, u'related': [u'updateNetworkACLItem', u'createNetworkACL'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL Item'}, {u'name': u'action', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'scl entry action, allow or deny'}, {u'name': u'cidrlist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the cidr list to allow traffic from/to'}, {u'name': u'icmptype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'type of the icmp message being sent'}, {u'name': u'traffictype', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the traffic type for the ACL,can be Ingress or Egress, defaulted to Ingress if not specified'}], u'requiredparams': [u'id'], u'response': [{u'type': u'integer', u'name': u'number', u'description': u'Number of the ACL Item'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the ACL Item'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of ACL's port range"}, {u'type': u'string', u'name': u'action', u'description': u'Action of ACL Item. Allow/Deny'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of ACL's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the ACL'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the ACL'}, {u'description': u'the list of resource tags associated with the network ACLs', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'aclid', u'description': u'the ID of the ACL this item belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}], u'description': u'Updates ACL Item with specified Id'}, u'vpc': {u'name': u'updateVPC', u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'id', u'required': True, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the id of the VPC'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the vpc to the end user or not'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the VPC'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the VPC'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u"is VPC uses distributed router for one hop forwarding and host based network ACL's"}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the VPC belongs to'}, {u'type': u'boolean', u'name': u'regionlevelvpc', u'description': u'true if VPC is region level'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpc for display to the regular user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the VPC'}, {u'description': u'the list of networks belongign to the VPC', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}], u'name': u'network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the VPC owner'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the VPC'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true VPC requires restart'}, {u'type': u'string', u'name': u'state', u'description': u'state of the VPC. Can be Inactive/Enabled'}, {u'type': u'string', u'name': u'cidr', u'description': u'the cidr the VPC'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain of the VPC'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the VPC'}, {u'description': u'the list of resource tags associated with the project', u'type': u'list', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the VPC'}, {u'type': u'date', u'name': u'created', u'description': u'the date this VPC was created'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the vpc'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the VPC.'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the VPC'}, {u'type': u'string', u'name': u'vpcofferingid', u'description': u'vpc offering id the VPC is created from'}], u'description': u'Updates a VPC'}, u'resourcecount': {u'name': u'updateResourceCount', u'related': [], u'isasync': False, u'params': [{u'name': u'domainid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'If account parameter specified then updates resource counts for a specified account in this domain else update resource counts for all accounts & child domains in specified domain.'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Update resource limits for project'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Update resource count for a specified account. Must be used with the domainId parameter.'}, {u'name': u'resourcetype', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Type of resource to update. If specifies valid values are 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 and 11. If not specified will update all resource counts0 - Instance. Number of instances a user can create. 1 - IP. Number of public IP addresses a user can own. 2 - Volume. Number of disk volumes a user can create.3 - Snapshot. Number of snapshots a user can create.4 - Template. Number of templates that a user can register/create.5 - Project. Number of projects that a user can create.6 - Network. Number of guest network a user can create.7 - VPC. Number of VPC a user can create.8 - CPU. Total number of CPU cores a user can use.9 - Memory. Total Memory (in MB) a user can use.10 - PrimaryStorage. Total primary storage space (in GiB) a user can use.11 - SecondaryStorage. Total secondary storage space (in GiB) a user can use.'}], u'requiredparams': [u'domainid'], u'response': [{u'type': u'string', u'name': u'projectid', u'description': u"the project id for which resource count's are updated"}, {u'type': u'string', u'name': u'domainid', u'description': u"the domain ID for which resource count's are updated"}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type. Values include 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11. See the resourceType parameter for more information on these values.'}, {u'type': u'string', u'name': u'domain', u'description': u"the domain name for which resource count's are updated"}, {u'type': u'string', u'name': u'project', u'description': u"the project name for which resource count's are updated"}, {u'type': u'long', u'name': u'resourcecount', u'description': u'resource count'}, {u'type': u'string', u'name': u'account', u'description': u"the account for which resource count's are updated"}], u'description': u'Recalculate and update resource count for an account or domain.'}, u'storagenetworkiprange': {u'name': u'updateStorageNetworkIpRange', u'related': [u'listStorageNetworkIpRange'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listStorageNetworkIpRange', u'updateStorageNetworkIpRange'], u'length': 255, u'type': u'uuid', u'description': u'UUID of storage network ip range'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Optional. the vlan the ip range sits on'}, {u'name': u'netmask', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the netmask for storage network'}, {u'name': u'endip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the ending IP address'}, {u'name': u'startip', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the beginning IP address'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'podid', u'description': u'the Pod uuid for the storage network IP range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the storage network IP range'}, {u'type': u'integer', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the storage network IP range'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the storage network IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of storage network IP range.'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network uuid of storage network IP range'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone uuid of the storage network IP range'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the storage network IP range'}], u'description': u'Update a Storage network IP range, only allowed when no IPs in this range have been allocated.'}, u'configuration': {u'name': u'updateConfiguration', u'related': [u'listConfigurations'], u'isasync': False, u'params': [{u'name': u'clusterid', u'required': False, u'related': [u'updateCluster', u'listClusters'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Cluster to update the parameter value for corresponding cluster'}, {u'name': u'accountid', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'updateAccount', u'enableAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Account to update the parameter value for corresponding account'}, {u'name': u'value', u'required': False, u'related': [], u'length': 4095, u'type': u'string', u'description': u'the value of the configuration'}, {u'name': u'storageid', u'required': False, u'related': [u'createStoragePool', u'cancelStorageMaintenance', u'listStoragePools', u'updateStoragePool', u'enableStorageMaintenance', u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Storage pool to update the parameter value for corresponding storage pool'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the configuration'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone to update the parameter value for corresponding zone'}], u'requiredparams': [u'name'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the configuration'}, {u'type': u'string', u'name': u'category', u'description': u'the category of the configuration'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the configuration'}, {u'type': u'string', u'name': u'scope', u'description': u'scope(zone/cluster/pool/account) of the parameter that needs to be updated'}, {u'type': u'string', u'name': u'value', u'description': u'the value of the configuration'}, {u'type': u'long', u'name': u'id', u'description': u'the value of the configuration'}], u'description': u'Updates a configuration.'}, u'ipaddress': {u'name': u'updateIpAddress', u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'id', u'required': True, u'related': [u'updateIpAddress', u'associateIpAddress', u'listPublicIpAddresses', u'restartNetwork', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the id of the public ip address to update'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the ip to the end user or not'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'purpose', u'description': u'purpose of the IP address. In Acton this value is not null for Ips with isSystem=true, and can have either StaticNat or LB value'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'vlanid', u'description': u'the ID of the VLAN associated with the IP address. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'virutal machine name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'associatednetworkid', u'description': u'the ID of the Network associated with the IP address'}, {u'type': u'string', u'name': u'id', u'description': u'public IP address id'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain the public IP address is associated with'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the public IP address is associated with'}, {u'type': u'string', u'name': u'account', u'description': u'the account the public IP address is associated with'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'virutal machine id the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'boolean', u'name': u'isstaticnat', u'description': u'true if this ip is for static nat, false otherwise'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if this ip is system ip (was allocated as a part of deployVm or createLbRule)'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is public ip for display to the regular user'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the IP address'}, {u'type': u'string', u'name': u'vlanname', u'description': u'the VLAN associated with the IP address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'boolean', u'name': u'isportable', u'description': u'is public IP portable across the zones'}, {u'type': u'boolean', u'name': u'issourcenat', u'description': u'true if the IP address is a source nat address, false otherwise'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the public IP address was acquired'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'description': u'the list of resource tags associated with ip address', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'associatednetworkname', u'description': u'the name of the Network associated with the IP address'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'vmipaddress', u'description': u'virutal machine (dnat) ip address (not null only for static nat Ip)'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'virutal machine display name the ip address is assigned to (not null only for static nat Ip)'}], u'description': u'Updates an ip address'}, u'templatepermissions': {u'name': u'updateTemplatePermissions', u'related': [], u'isasync': False, u'params': [{u'name': u'isfeatured', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true for featured template/iso, false otherwise'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true for public template/iso, false for private templates/isos'}, {u'name': u'isextractable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template/iso is extractable, false other wise. Can be set only by root admin'}, {u'name': u'id', u'required': True, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the template ID'}, {u'name': u'accounts', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'a comma delimited list of accounts. If specified, "op" parameter has to be passed in.'}, {u'name': u'projectids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'a comma delimited list of projects. If specified, "op" parameter has to be passed in.'}, {u'name': u'op', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'permission operator (add, remove, reset)'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Updates a template visibility permissions. A public template is visible to all accounts within the same domain. A private template is visible only to the owner of the template. A priviledged template is a private template with account permissions added. Only accounts specified under the template permissions are visible to them.'}, u'autoscalevmprofile': {u'name': u'updateAutoScaleVmProfile', u'related': [u'listAutoScaleVmProfiles'], u'isasync': True, u'params': [{u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the profile to the end user or not'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'id', u'required': True, u'related': [u'updateAutoScaleVmProfile', u'listAutoScaleVmProfiles'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale vm profile'}, {u'name': u'destroyvmgraceperiod', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the time allowed for existing connections to get closed before a vm is destroyed'}, {u'name': u'templateid', u'required': False, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the template of the auto deployed virtual machine'}, {u'name': u'autoscaleuserid', u'required': False, u'related': [u'lockUser', u'disableUser', u'enableUser', u'getUser', u'listUsers', u'updateUser', u'createUser'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the user used to launch and destroy the VMs'}, {u'name': u'counterparam', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'counterparam list. Example: counterparam[0].name=snmpcommunity&counterparam[0].value=public&counterparam[1].name=snmpport&counterparam[1].value=161'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the availability zone to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the service offering to be used while deploying a virtual machine'}, {}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm profile ID'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is profile for display to the regular user'}, {u'type': u'integer', u'name': u'destroyvmgraceperiod', u'description': u'the time allowed for existing connections to get closed before a vm is destroyed'}, {}, {u'type': u'string', u'name': u'templateid', u'description': u'the template to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'otherdeployparams', u'description': u'parameters other than zoneId/serviceOfferringId/templateId to be used while deploying a virtual machine'}, {u'type': u'string', u'name': u'autoscaleuserid', u'description': u'the ID of the user used to launch and destroy the VMs'}], u'description': u'Updates an existing autoscale vm profile.'}, u'traffictype': {u'name': u'updateTrafficType', u'related': [u'addTrafficType'], u'isasync': True, u'params': [{u'name': u'vmwarenetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a VMware host'}, {u'name': u'kvmnetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a KVM host'}, {u'name': u'hypervnetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a Hyperv host'}, {u'name': u'id', u'required': True, u'related': [u'addTrafficType', u'updateTrafficType'], u'length': 255, u'type': u'uuid', u'description': u'traffic type id'}, {u'name': u'xenservernetworklabel', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The network name label of the physical device dedicated to this traffic on a XenServer host'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'hypervnetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a HyperV host'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the trafficType to be added to the physical network'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'id of the network provider'}, {u'type': u'string', u'name': u'xenservernetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a XenServer host'}, {u'type': u'string', u'name': u'vmwarenetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a VMware host'}, {u'type': u'string', u'name': u'kvmnetworklabel', u'description': u'The network name label of the physical device dedicated to this traffic on a KVM host'}], u'description': u'Updates traffic type of a physical network'}, u'account': {u'name': u'updateAccount', u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the domain where the account exists'}, {u'name': u'accountdetails', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'details for account used to store specific parameters'}, {u'name': u'id', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'lockAccount', u'ldapCreateAccount', u'updateAccount', u'createAccount', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'Account id'}, {u'name': u'newname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'new name for the account'}, {u'name': u'networkdomain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u"Network domain for the account's networks; empty string will update domainName with NULL value"}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the current account name'}], u'requiredparams': [u'newname'], u'response': [{u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}], u'name': u'user'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}], u'description': u'Updates account information for the authenticated user'}, u'zone': {u'name': u'updateZone', u'related': [u'listZones', u'listZones', u'createZone'], u'isasync': False, u'params': [{u'name': u'localstorageenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if local storage offering enabled, false otherwise'}, {u'name': u'dns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second DNS for the Zone'}, {u'name': u'ip6dns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second DNS for IPv6 network in the Zone'}, {u'name': u'guestcidraddress', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the guest CIDR address for the Zone'}, {u'name': u'internaldns1', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first internal DNS for the Zone'}, {u'name': u'dhcpprovider', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the dhcp Provider for the Zone'}, {u'name': u'ip6dns1', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first DNS for IPv6 network in the Zone'}, {u'name': u'allocationstate', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Allocation state of this cluster for allocation of new resources'}, {u'name': u'internaldns2', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the second internal DNS for the Zone'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'updates a private zone to public if set, but not vice-versa'}, {u'name': u'id', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone'}, {u'name': u'dnssearchorder', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the dns search order list'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'the details for the Zone'}, {u'name': u'dns1', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the first DNS for the Zone'}, {u'name': u'domain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Network domain name for the networks in the zone; empty string will update domain with NULL value'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the Zone'}], u'requiredparams': [u'id'], u'response': [{u'description': u'the capacity of the Zone', u'type': u'list', u'response': [{u'type': u'string', u'name': u'percentused', u'description': u'the percentage of capacity currently in use'}, {u'type': u'string', u'name': u'clustername', u'description': u'the Cluster name'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Zone name'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name'}, {u'type': u'short', u'name': u'type', u'description': u'the capacity type'}, {u'type': u'long', u'name': u'capacitytotal', u'description': u'the total capacity available'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID'}, {u'type': u'long', u'name': u'capacityused', u'description': u'the capacity currently in use'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the Cluster ID'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID'}], u'name': u'capacity'}, {u'type': u'string', u'name': u'zonetoken', u'description': u'Zone Token'}, {u'type': u'string', u'name': u'name', u'description': u'Zone name'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the display text of the zone'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the Zone'}, {u'type': u'string', u'name': u'ip6dns1', u'description': u'the first IPv6 DNS for the Zone'}, {u'type': u'string', u'name': u'domainid', u'description': u'the UUID of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'internaldns2', u'description': u'the second internal DNS for the Zone'}, {u'type': u'string', u'name': u'ip6dns2', u'description': u'the second IPv6 DNS for the Zone'}, {u'type': u'boolean', u'name': u'securitygroupsenabled', u'description': u'true if security groups support is enabled, false otherwise'}, {u'type': u'string', u'name': u'networktype', u'description': u'the network type of the zone; can be Basic or Advanced'}, {u'type': u'string', u'name': u'internaldns1', u'description': u'the first internal DNS for the Zone'}, {u'type': u'string', u'name': u'guestcidraddress', u'description': u'the guest CIDR address for the Zone'}, {u'type': u'boolean', u'name': u'localstorageenabled', u'description': u'true if local storage offering enabled, false otherwise'}, {u'type': u'string', u'name': u'domainname', u'description': u'the name of the containing domain, null for public zones'}, {u'type': u'string', u'name': u'domain', u'description': u'Network domain name for the networks in the zone'}, {u'type': u'string', u'name': u'id', u'description': u'Zone id'}, {u'type': u'string', u'name': u'dhcpprovider', u'description': u'the dhcp Provider for the Zone'}, {u'type': u'map', u'name': u'resourcedetails', u'description': u'Meta data associated with the zone (key/value pairs)'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the Zone'}, {u'type': u'string', u'name': u'allocationstate', u'description': u'the allocation state of the cluster'}, {u'description': u'the list of resource tags associated with zone.', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'description', u'description': u'Zone description'}, {}], u'description': u'Updates a Zone.'}, u'firewallrule': {u'name': u'updateFirewallRule', u'related': [u'createFirewallRule', u'listEgressFirewallRules'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the firewall rule'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}], u'description': u'Updates firewall rule '}, u'vmaffinitygroup': {u'name': u'updateVMAffinityGroup', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'affinitygroupnames', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of affinity groups names that are going to be applied to the virtual machine. Should be passed only when vm is created from a zone with Basic Network support. Mutually exclusive with securitygroupids parameter'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}, {u'name': u'affinitygroupids', u'required': False, u'related': [u'listAffinityGroups'], u'length': 255, u'type': u'list', u'description': u'comma separated list of affinity groups id that are going to be applied to the virtual machine. Should be passed only when vm is created from a zone with Basic Network support. Mutually exclusive with securitygroupnames parameter'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}], u'name': u'nic'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}], u'name': u'securitygroup'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}], u'description': u'Updates the affinity/anti-affinity group associations of a virtual machine. The VM has to be stopped and restarted for the new properties to take effect.'}, u'physicalnetwork': {u'name': u'updatePhysicalNetwork', u'related': [u'listPhysicalNetworks', u'createPhysicalNetwork'], u'isasync': True, u'params': [{u'name': u'networkspeed', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the speed for the physical network[1G/10G]'}, {u'name': u'vlan', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the VLAN for the physical network'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'Tag the physical network'}, {u'name': u'id', u'required': True, u'related': [u'updatePhysicalNetwork', u'listPhysicalNetworks', u'createPhysicalNetwork'], u'length': 255, u'type': u'uuid', u'description': u'physical network id'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Enabled/Disabled'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'networkspeed', u'description': u'the speed of the physical network'}, {u'type': u'string', u'name': u'tags', u'description': u'comma separated tag'}, {u'type': u'string', u'name': u'broadcastdomainrange', u'description': u'Broadcast domain range of the physical network'}, {u'type': u'string', u'name': u'isolationmethods', u'description': u'isolation methods'}, {u'type': u'string', u'name': u'name', u'description': u'name of the physical network'}, {u'type': u'string', u'name': u'vlan', u'description': u'the vlan of the physical network'}, {u'type': u'string', u'name': u'id', u'description': u'the uuid of the physical network'}, {u'type': u'string', u'name': u'state', u'description': u'state of the physical network'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the physical network owner'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the physical network'}], u'description': u'Updates a physical network'}, u'region': {u'name': u'updateRegion', u'related': [u'listRegions', u'addRegion'], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'Id of region to update'}, {u'name': u'endpoint', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'updates region with this end point'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'updates region with this name'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'gslbserviceenabled', u'description': u'true if GSLB service is enabled in the region, false otherwise'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the region'}, {u'type': u'integer', u'name': u'id', u'description': u'the ID of the region'}, {u'type': u'string', u'name': u'endpoint', u'description': u'the end point of the region'}, {u'type': u'boolean', u'name': u'portableipserviceenabled', u'description': u'true if security groups support is enabled, false otherwise'}], u'description': u'Updates a region'}, u'networkoffering': {u'name': u'updateNetworkOffering', u'related': [], u'isasync': False, u'params': [{u'name': u'keepaliveenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'if true keepalive will be turned on in the loadbalancer. At the time of writing this has only an effect on haproxy; the mode http and httpclose options are unset in the haproxy conf file.'}, {u'name': u'availability', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the availability of network offering. Default value is Required for Guest Virtual network offering; Optional for Guest Direct network offering'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the display text of the network offering'}, {u'name': u'sortkey', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'sort key of the network offering, integer'}, {u'name': u'id', u'required': False, u'related': [u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'the id of the network offering'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'update state for the network offering'}, {u'name': u'maxconnections', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'maximum number of concurrent connections supported by the network offering'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the network offering'}], u'requiredparams': [], u'response': [{u'type': u'date', u'name': u'created', u'description': u'the date this network offering was created'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network offering'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering used by virtual router provider'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type for the network offering, supported types are Public, Management, Control, Guest, Vlan or Storage.'}, {u'type': u'boolean', u'name': u'supportsstrechedl2subnet', u'description': u'true if network offering supports network that span multiple zones'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network offering'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the network offering.'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with network offering'}, {u'type': u'boolean', u'name': u'forvpc', u'description': u'true if network offering can be used by VPC networks only'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network offering. Can be Disabled/Enabled/Inactive'}, {u'type': u'string', u'name': u'tags', u'description': u'the tags for the network offering'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'true if network offering supports persistent networks, false otherwise'}, {u'type': u'boolean', u'name': u'egressdefaultpolicy', u'description': u'true if guest network default egress policy is allow; false if default egress policy is deny'}, {u'type': u'integer', u'name': u'maxconnections', u'description': u'maximum number of concurrents connections to be handled by lb'}, {u'type': u'integer', u'name': u'networkrate', u'description': u'data transfer rate in megabits per second allowed.'}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network offering supports specifying ip ranges, false otherwise'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network offering is default, false otherwise'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}], u'name': u'provider'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}, {u'type': u'string', u'name': u'name', u'description': u'the capability name'}], u'name': u'capability'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'boolean', u'name': u'specifyvlan', u'description': u'true if network offering supports vlans, false otherwise'}, {u'type': u'boolean', u'name': u'conservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'guestiptype', u'description': u'guest type of the network offering, can be Shared or Isolated'}, {u'type': u'string', u'name': u'availability', u'description': u'availability of the network offering'}], u'description': u'Updates a network offering.'}, u'lbhealthcheckpolicy': {u'name': u'updateLBHealthCheckPolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the policy to the end user or not'}, {u'name': u'id', u'required': True, u'related': [u'updateLBHealthCheckPolicy'], u'length': 255, u'type': u'uuid', u'description': u'id of lb healthcheck policy'}], u'requiredparams': [u'id'], u'response': [{u'description': u'the list of healthcheckpolicies', u'type': u'list', u'response': [{u'type': u'int', u'name': u'healthcheckinterval', u'description': u'Amount of time between health checks'}, {u'type': u'string', u'name': u'pingpath', u'description': u'the pingpath  of the healthcheck policy'}, {u'type': u'int', u'name': u'unhealthcheckthresshold', u'description': u'Number of consecutive health check failures before declaring an instance unhealthy.'}, {u'type': u'int', u'name': u'healthcheckthresshold', u'description': u'Number of consecutive health check success before declaring an instance healthy'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the policy'}, {u'type': u'int', u'name': u'responsetime', u'description': u'Time to wait when receiving a response from the health check'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the healthcheck policy'}, {u'type': u'string', u'name': u'id', u'description': u'the LB HealthCheck policy ID'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is policy for display to the regular user'}], u'name': u'healthcheckpolicy'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the HealthCheck policy'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain of the HealthCheck policy'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the HealthCheck policy'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the id of the zone the HealthCheck policy belongs to'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the LB rule ID'}], u'description': u'Updates LB HealthCheck policy'}, u'project': {u'name': u'updateProject', u'related': [u'createProject'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to be modified'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'new Admin account for the project'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'display text of the project'}], u'requiredparams': [u'id'], u'response': [{u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by project'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this project'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the project'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the project can own'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this project'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the project can own'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this project'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by project'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this project'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this project'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the project can own'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this project'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this project'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the project can own'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by project'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the project can own'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this project'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this project'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this project'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this project to acquire'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this project can acquire'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this project'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the project can own'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this project'}, {u'type': u'string', u'name': u'account', u'description': u"the account name of the project's owner"}, {u'description': u'the list of resource tags associated with vm', u'type': u'list', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id the project belongs to'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this project'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by project'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this project'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the project'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this project'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this project'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the project'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name where the project belongs to'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by project'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the project'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this project'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by project'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this project to acquire'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this project'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this project'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this project'}], u'description': u'Updates a project'}, u'vpncustomergateway': {u'name': u'updateVpnCustomerGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'ikelifetime', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Lifetime of phase 1 VPN connection to the customer gateway, in seconds'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of this customer gateway'}, {u'name': u'id', u'required': True, u'related': [u'updateVpnCustomerGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of customer gateway'}, {u'name': u'gateway', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'public ip address id of the customer gateway'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the gateway. If used with the account parameter returns the gateway associated with the account for the specified domain.'}, {u'name': u'ikepolicy', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'IKE policy of the customer gateway'}, {u'name': u'esplifetime', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'Lifetime of phase 2 VPN connection to the customer gateway, in seconds'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the gateway. Must be used with the domainId parameter.'}, {u'name': u'ipsecpsk', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'name': u'cidrlist', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'guest cidr of the customer gateway'}, {u'name': u'esppolicy', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'ESP policy of the customer gateway'}, {u'name': u'dpd', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'If DPD is enabled for VPN connection'}], u'requiredparams': [u'id', u'gateway', u'ikepolicy', u'ipsecpsk', u'cidrlist', u'esppolicy'], u'response': [{u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'name', u'description': u'name of the customer gateway'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec preshared-key of customer gateway'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'guest ip of the customer gateway'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u'id', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'IPsec policy of customer gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}], u'description': u'Update site to site vpn customer gateway'}, u'iso': {u'name': u'updateIso', u'related': [u'listIsos', u'listTemplates', u'listIsos', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'bootable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if image is bootable, false otherwise'}, {u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS type that best represents the OS of this image.'}, {u'name': u'displaytext', u'required': False, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the display text of the image'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the image file'}, {u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if template/ISO contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'name': u'isrouting', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template type is routing i.e., if template is used to deploy router'}, {u'name': u'passwordenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the image supports the password reset feature; default is false'}, {u'name': u'sortkey', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'sort key of the template, integer'}, {u'name': u'id', u'required': True, u'related': [u'listIsos', u'listTemplates', u'listIsos', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the image file'}, {u'name': u'format', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the format for the image'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}], u'description': u'Updates an ISO file.'}, u'egressfirewallrule': {u'name': u'updateEgressFirewallRule', u'related': [u'createFirewallRule', u'listFirewallRules', u'listEgressFirewallRules', u'updateFirewallRule'], u'isasync': True, u'params': [{u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the egress firewall rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'state', u'description': u'the state of the rule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the firewall rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'error code for this icmp message'}, {u'type': u'string', u'name': u'endport', u'description': u"the ending port of firewall rule's port range"}, {u'type': u'integer', u'name': u'icmptype', u'description': u'type of the icmp message being sent'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of the firewall rule'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'the cidr list to forward traffic from'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the public ip address for the firewall rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'list', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the firewall rule'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'startport', u'description': u"the starting port of firewall rule's port range"}, {u'type': u'string', u'name': u'ipaddressid', u'description': u'the public ip address id for the firewall rule'}], u'description': u'Updates egress firewall rule '}, u'networkserviceprovider': {u'name': u'updateNetworkServiceProvider', u'related': [], u'isasync': True, u'params': [{u'name': u'servicelist', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the list of services to be enabled for this physical network service provider'}, {u'name': u'id', u'required': True, u'related': [u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'network service provider id'}, {u'name': u'state', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Enabled/Disabled/Shutdown the physical network service provider'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}], u'description': u'Updates a network serviceProvider of a physical network'}, u'autoscalevmgroup': {u'name': u'updateAutoScaleVmGroup', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updateAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale group'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}, {u'name': u'minmembers', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the group to the end user or not'}, {u'name': u'maxmembers', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'name': u'interval', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'name': u'scaleuppolicyids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of scaleup autoscale policies'}, {u'name': u'scaledownpolicyids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of scaledown autoscale policies'}], u'requiredparams': [u'id'], u'response': [{u'type': u'int', u'name': u'interval', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is group for display to the regular user'}, {u'type': u'string', u'name': u'state', u'description': u'the current state of the AutoScale Vm Group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the load balancer rule ID'}, {u'type': u'int', u'name': u'maxmembers', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm group ID'}, {u'type': u'string', u'name': u'vmprofileid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'list', u'name': u'scaledownpolicies', u'description': u'list of scaledown autoscale policies'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'list', u'name': u'scaleuppolicies', u'description': u'list of scaleup autoscale policies'}, {u'type': u'int', u'name': u'minmembers', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}], u'description': u'Updates an existing autoscale vm group.'}, u'loadbalancer': {u'name': u'updateLoadBalancer', u'related': [u'createLoadBalancer'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Load Balancer'}, {u'name': u'fordisplay', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'an optional field, whether to the display the rule to the end user or not'}, {u'name': u'customid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional field, in case you want to set a custom id to the resource. Allowed to Root Admins only'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain of the Load Balancer'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the Load Balancer'}, {u'type': u'string', u'name': u'algorithm', u'description': u'the load balancer algorithm (source, roundrobin, leastconn)'}, {u'description': u'the list of instances associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the instance'}, {u'type': u'string', u'name': u'id', u'description': u'the instance ID'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the instance'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the instance'}], u'name': u'loadbalancerinstance'}, {u'type': u'string', u'name': u'id', u'description': u'the Load Balancer ID'}, {u'type': u'string', u'name': u'sourceipaddressnetworkid', u'description': u'Load Balancer source ip network id'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the Load Balancer'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is rule for display to the regular user'}, {u'type': u'string', u'name': u'networkid', u'description': u'Load Balancer network id'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the Load Balancer'}, {u'description': u'the list of rules associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'integer', u'name': u'instanceport', u'description': u'instance port of the load balancer rule'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the load balancer rule'}, {u'type': u'integer', u'name': u'sourceport', u'description': u'source port of the load balancer rule'}], u'name': u'loadbalancerrule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the Load Balancer'}, {u'type': u'string', u'name': u'sourceipaddress', u'description': u'Load Balancer source ip'}, {u'description': u'the list of resource tags associated with the Load Balancer', u'type': u'list', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the Load Balancer'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the Load Balancer'}], u'description': u'Updates a Load Balancer'}, u'user': {u'name': u'updateUser', u'related': [u'lockUser', u'disableUser', u'listUsers'], u'isasync': False, u'params': [{u'name': u'lastname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'last name'}, {u'name': u'usersecretkey', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The secret key for the user. Must be specified with userSecretKey'}, {u'name': u'email', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'email'}, {u'name': u'username', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Unique username'}, {u'name': u'userapikey', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The API key for the user. Must be specified with userSecretKey'}, {u'name': u'firstname', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'first name'}, {u'name': u'timezone', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}, {u'name': u'id', u'required': True, u'related': [u'lockUser', u'disableUser', u'listUsers', u'updateUser'], u'length': 255, u'type': u'uuid', u'description': u'User uuid'}, {u'name': u'password', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Clear text password (default hashed to SHA256SALT). If you wish to use any other hasing algorithm, you would need to write a custom authentication adapter'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}], u'description': u'Updates a user account'}}, u'upload': {u'volume': {u'name': u'uploadVolume', u'related': [u'listVolumes', u'migrateVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'checksum', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the MD5 checksum value of this volume'}, {u'name': u'format', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the format for the volume. Possible values include QCOW2, OVA, and VHD.'}, {u'name': u'diskofferingid', u'required': False, u'related': [u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk offering. This must be a custom sized offering since during uploadVolume volume size is unknown.'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId. If the account parameter is used, domainId must also be used.'}, {u'name': u'imagestoreuuid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Image store uuid'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional accountName. Must be used with domainId.'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the volume'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone the volume is to be hosted on'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL of where the volume is hosted. Possible URL include http:// and https://'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Upload volume for the project'}], u'requiredparams': [u'format', u'name', u'zoneid', u'url'], u'response': [{u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}], u'description': u'Uploads a data disk.'}, u'customcertificate': {u'name': u'uploadCustomCertificate', u'related': [], u'isasync': True, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'A name / alias for the certificate.'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'An integer providing the location in a chain that the certificate will hold. Usually, this can be left empty. When creating a chain, the top level certificate should have an ID of 1, with each step in the chain incrementing by one. Example, CA with id = 1, Intermediate CA with id = 2, Site certificate with ID = 3'}, {u'name': u'certificate', u'required': True, u'related': [], u'length': 65535, u'type': u'string', u'description': u'The certificate to be uploaded.'}, {u'name': u'privatekey', u'required': False, u'related': [], u'length': 65535, u'type': u'string', u'description': u'The private key for the attached certificate.'}, {u'name': u'domainsuffix', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'DNS domain suffix that the certificate is granted for.'}], u'requiredparams': [u'certificate', u'domainsuffix'], u'response': [{u'type': u'string', u'name': u'message', u'description': u'message of the certificate upload operation'}], u'description': u'Uploads a custom certificate for the console proxy VMs to use for SSL. Can be used to upload a single certificate signed by a known CA. Can also be used, through multiple calls, to upload a chain of certificates from CA to the custom certificate itself.'}, u'sslcert': {u'name': u'uploadSslCert', u'related': [u'listSslCerts'], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project for the ssl cert'}, {u'name': u'privatekey', u'required': True, u'related': [], u'length': 16384, u'type': u'string', u'description': u'Private key'}, {u'name': u'certchain', u'required': False, u'related': [], u'length': 2097152, u'type': u'string', u'description': u'Certificate chain of trust'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will own the ssl cert'}, {u'name': u'password', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Password for the private key'}, {u'name': u'certificate', u'required': True, u'related': [], u'length': 16384, u'type': u'string', u'description': u'SSL certificate'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning the ssl cert'}], u'requiredparams': [u'privatekey', u'certificate'], u'response': [{u'type': u'list', u'name': u'loadbalancerrulelist', u'description': u'List of loabalancers this certificate is bound to'}, {u'type': u'string', u'name': u'fingerprint', u'description': u'certificate fingerprint'}, {u'type': u'string', u'name': u'account', u'description': u'account for the certificate'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the certificate'}, {u'type': u'string', u'name': u'id', u'description': u'SSL certificate ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'certificate', u'description': u'certificate'}, {u'type': u'string', u'name': u'privatekey', u'description': u'private key'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the certificate'}, {u'type': u'string', u'name': u'certchain', u'description': u'certificate chain'}], u'description': u'Upload a certificate to cloudstack'}}, u'upgrade': {u'routertemplate': {u'name': u'upgradeRouterTemplate', u'related': [], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'upgrades all routers within the specified zone'}, {u'name': u'domainid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'upgrades all routers owned by the specified domain'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'upgrades router with the specified Id'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'upgrades all routers owned by the specified account'}, {u'name': u'podid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'upgrades all routers within the specified pod'}, {u'name': u'clusterid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'upgrades all routers within the specified cluster'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'jobid', u'description': u'the UUID of the latest async job acting on this object'}, {}, {}, {u'type': u'integer', u'name': u'jobstatus', u'description': u'the current status of the latest async job acting on this object'}], u'description': u'Upgrades router to use newer template'}}, u'disable': {u'account': {u'name': u'disableAccount', u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'Disables specified account in this domain.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Disables specified account.'}, {u'name': u'lock', u'required': True, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'If true, only lock the account; else disable the account'}, {u'name': u'id', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'Account id'}], u'requiredparams': [u'lock'], u'response': [{u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}], u'name': u'user'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}], u'description': u'Disables an account'}, u'autoscalevmgroup': {u'name': u'disableAutoScaleVmGroup', u'related': [u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale group'}], u'requiredparams': [u'id'], u'response': [{u'type': u'list', u'name': u'scaleuppolicies', u'description': u'list of scaleup autoscale policies'}, {u'type': u'string', u'name': u'state', u'description': u'the current state of the AutoScale Vm Group'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is group for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the autoscale vm group ID'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the vm profile'}, {u'type': u'string', u'name': u'vmprofileid', u'description': u'the autoscale profile that contains information about the vms in the vm group.'}, {u'type': u'int', u'name': u'minmembers', u'description': u'the minimum number of members in the vmgroup, the number of instances in the vm group will be equal to or more than this number.'}, {u'type': u'int', u'name': u'maxmembers', u'description': u'the maximum number of members in the vmgroup, The number of instances in the vm group will be equal to or less than this number.'}, {u'type': u'list', u'name': u'scaledownpolicies', u'description': u'list of scaledown autoscale policies'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm profile'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the vm profile'}, {u'type': u'int', u'name': u'interval', u'description': u'the frequency at which the conditions have to be evaluated'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id vm profile'}, {u'type': u'string', u'name': u'lbruleid', u'description': u'the load balancer rule ID'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the instance group'}], u'description': u'Disables an AutoScale Vm Group'}, u'cisconexusvsm': {u'name': u'disableCiscoNexusVSM', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'disableCiscoNexusVSM'], u'length': 255, u'type': u'uuid', u'description': u'Id of the Cisco Nexus 1000v VSM device to be deleted'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'vsmconfigmode', u'description': u'The mode of the VSM (standalone/HA)'}, {u'type': u'string', u'name': u'vsmconfigstate', u'description': u'The Config State (Primary/Standby) of the VSM'}, {u'type': u'int', u'name': u'vsmpktvlanid', u'description': u'packet vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmdomainid', u'description': u"The VSM is a switch supervisor. This is the VSM's switch domain id"}, {u'type': u'string', u'name': u'vsmmgmtvlanid', u'description': u'management vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmdevicestate', u'description': u'The Device State (Enabled/Disabled) of the VSM'}, {u'type': u'string', u'name': u'vsmdeviceid', u'description': u'device id of the Cisco N1KV VSM device'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the management IP address of the external Cisco Nexus 1000v Virtual Supervisor Module'}, {u'type': u'int', u'name': u'vsmctrlvlanid', u'description': u'control vlan id of the VSM'}, {u'type': u'int', u'name': u'vsmstoragevlanid', u'description': u'storage vlan id of the VSM'}, {u'type': u'string', u'name': u'vsmdevicestate', u'description': u'device state'}, {u'type': u'string', u'name': u'vsmdevicename', u'description': u'device name'}], u'description': u'disable a Cisco Nexus VSM device'}, u'staticnat': {u'name': u'disableStaticNat', u'related': [], u'isasync': True, u'params': [{u'name': u'ipaddressid', u'required': True, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'the public IP address id for which static nat feature is being disableed'}], u'requiredparams': [u'ipaddressid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Disables static rule for given ip address'}, u'user': {u'name': u'disableUser', u'related': [u'lockUser', u'listUsers'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'lockUser', u'disableUser', u'listUsers'], u'length': 255, u'type': u'uuid', u'description': u'Disables user by user ID.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}], u'description': u'Disables a user account'}}, u'logout': {u'': {u'name': u'logout', u'related': [], u'isasync': False, u'params': [], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'description', u'description': u'Response description'}], u'description': u'Logs out the user'}}, u'import': {u'ldapusers': {u'name': u'importLdapUsers', u'related': [u'searchLdap', u'listLdapUsers'], u'isasync': False, u'params': [{u'name': u'accounttype', u'required': True, u'related': [], u'length': 255, u'type': u'short', u'description': u'Type of the account.  Specify 0 for user, 1 for root admin, and 2 for domain admin'}, {u'name': u'group', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies the group name from which the ldap users are to be imported. If no group is specified, all the users will be imported.'}, {u'name': u'timezone', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Specifies a timezone for this command. For more information on the timezone parameter, see Time Zone Format.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Creates the user under the specified account. If no account is specified, the username will be used as the account name.'}, {u'name': u'page', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'Specifies the domain to which the ldap users are to be imported. If no domain is specified, a domain will created using group parameter. If the group is also not specified, a domain name based on the OU information will be created. If no OU hierarchy exists, will be defaulted to ROOT domain'}, {u'name': u'accountdetails', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'details for account used to store specific parameters'}, {u'name': u'keyword', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'List by keyword'}, {u'name': u'pagesize', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u''}], u'requiredparams': [u'accounttype'], u'response': [{u'type': u'string', u'name': u'domain', u'description': u"The user's domain"}, {u'type': u'string', u'name': u'username', u'description': u"The user's username"}, {u'type': u'string', u'name': u'email', u'description': u"The user's email"}, {u'type': u'string', u'name': u'lastname', u'description': u"The user's lastname"}, {u'type': u'string', u'name': u'firstname', u'description': u"The user's firstname"}, {u'type': u'string', u'name': u'principal', u'description': u"The user's principle"}], u'description': u'Import LDAP users'}}, u'detach': {u'volume': {u'name': u'detachVolume', u'related': [u'listVolumes', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the virtual machine where the volume is detached from'}, {u'name': u'id', u'required': False, u'related': [u'listVolumes', u'detachVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'deviceid', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'the device ID on the virtual machine where volume is detached from'}], u'requiredparams': [], u'response': [{u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}], u'description': u'Detaches a disk volume from a virtual machine.'}, u'iso': {u'name': u'detachIso', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'virtualmachineid'], u'response': [{u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}], u'name': u'egressrule'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}], u'description': u'Detaches any ISO file (if any) currently attached to a virtual machine.'}}, u'generate': {u'usagerecords': {u'name': u'generateUsageRecords', u'related': [], u'isasync': False, u'params': [{u'name': u'enddate', u'required': True, u'related': [], u'length': 255, u'type': u'date', u'description': u'End date range for usage record query. Use yyyy-MM-dd as the date format, e.g. startDate=2009-06-03.'}, {u'name': u'startdate', u'required': True, u'related': [], u'length': 255, u'type': u'date', u'description': u'Start date range for usage record query. Use yyyy-MM-dd as the date format, e.g. startDate=2009-06-01.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'List events for the specified domain.'}], u'requiredparams': [u'enddate', u'startdate'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Generates usage records. This will generate records only if there any records to be generated, i.e if the scheduled usage job was not run or failed'}, u'alert': {u'name': u'generateAlert', u'related': [], u'isasync': True, u'params': [{u'name': u'zoneid', u'required': False, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'Zone id for which alert is generated'}, {u'name': u'description', u'required': True, u'related': [], u'length': 999, u'type': u'string', u'description': u'Alert description'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the alert'}, {u'name': u'podid', u'required': False, u'related': [u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'Pod id for which alert is generated'}, {u'name': u'type', u'required': True, u'related': [], u'length': 255, u'type': u'short', u'description': u'Type of the alert'}], u'requiredparams': [u'description', u'name', u'type'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Generates an alert'}}, u'restart': {u'network': {u'name': u'restartNetwork', u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'isasync': True, u'params': [{u'name': u'cleanup', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'If cleanup old network elements'}, {u'name': u'id', u'required': True, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'The id of the network to restart.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'ipaddress', u'description': u'public IP address'}, {u'type': u'string', u'name': u'vmipaddress', u'description': u'virutal machine (dnat) ip address (not null only for static nat Ip)'}, {u'type': u'date', u'name': u'allocated', u'description': u'date the public IP address was acquired'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'state', u'description': u'State of the ip address. Can be: Allocatin, Allocated and Releasing'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the Network where ip belongs to'}, {u'type': u'string', u'name': u'vlanname', u'description': u'the VLAN associated with the IP address'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'id', u'description': u'public IP address id'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'virutal machine id the ip address is assigned to (not null only for static nat Ip)'}, {u'description': u'the list of resource tags associated with ip address', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'purpose', u'description': u'purpose of the IP address. In Acton this value is not null for Ips with isSystem=true, and can have either StaticNat or LB value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID the public IP address is associated with'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is public ip for display to the regular user'}, {u'type': u'boolean', u'name': u'issourcenat', u'description': u'true if the IP address is a source nat address, false otherwise'}, {u'type': u'string', u'name': u'vlanid', u'description': u'the ID of the VLAN associated with the IP address. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain the public IP address is associated with'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone the public IP address belongs to'}, {u'type': u'string', u'name': u'virtualmachinedisplayname', u'description': u'virutal machine display name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'boolean', u'name': u'isportable', u'description': u'is public IP portable across the zones'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the ip belongs to'}, {u'type': u'string', u'name': u'virtualmachinename', u'description': u'virutal machine name the ip address is assigned to (not null only for static nat Ip)'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if this ip is system ip (was allocated as a part of deployVm or createLbRule)'}, {u'type': u'string', u'name': u'associatednetworkid', u'description': u'the ID of the Network associated with the IP address'}, {u'type': u'boolean', u'name': u'isstaticnat', u'description': u'true if this ip is for static nat, false otherwise'}, {u'type': u'string', u'name': u'associatednetworkname', u'description': u'the name of the Network associated with the IP address'}, {u'type': u'string', u'name': u'account', u'description': u'the account the public IP address is associated with'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the IP address'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}], u'description': u'Restarts the network; includes 1) restarting network elements - virtual routers, dhcp servers 2) reapplying all public ips 3) reapplying loadBalancing/portForwarding rules'}, u'vpc': {u'name': u'restartVPC', u'related': [u'createVPC', u'listVPCs', u'updateVPC'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the id of the VPC'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'fordisplay', u'description': u'is vpc for display to the regular user'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the VPC'}, {u'description': u'the list of supported services', u'type': u'list', u'response': [{u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}], u'name': u'provider'}, {u'type': u'string', u'name': u'name', u'description': u'the service name'}], u'name': u'service'}, {u'type': u'string', u'name': u'vpcofferingid', u'description': u'vpc offering id the VPC is created from'}, {u'type': u'boolean', u'name': u'regionlevelvpc', u'description': u'true if VPC is region level'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the VPC'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the VPC'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the VPC owner'}, {u'type': u'string', u'name': u'cidr', u'description': u'the cidr the VPC'}, {u'type': u'date', u'name': u'created', u'description': u'the date this VPC was created'}, {u'type': u'string', u'name': u'displaytext', u'description': u'an alternate display text of the VPC.'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain of the VPC'}, {u'description': u'the list of networks belongign to the VPC', u'type': u'list', u'response': [{u'description': u'the list of resource tags associated with network', u'type': u'list', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'gateway', u'description': u"the network's gateway"}, {u'type': u'string', u'name': u'reservediprange', u'description': u"the network's IP range not to be used by CloudStack guest VMs and can be used for non CloudStack purposes"}, {u'type': u'boolean', u'name': u'specifyipranges', u'description': u'true if network supports specifying ip ranges, false otherwise'}, {u'type': u'string', u'name': u'networkofferingname', u'description': u'name of the network offering the network is created from'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'broadcast uri of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network id'}, {u'type': u'string', u'name': u'networkofferingavailability', u'description': u'availability of the network offering the network is created from'}, {u'type': u'string', u'name': u'aclid', u'description': u'ACL Id associated with the VPC network'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the address'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the network'}, {u'type': u'string', u'name': u'acltype', u'description': u'acl type - access type to the network'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the network'}, {u'type': u'string', u'name': u'broadcastdomaintype', u'description': u'Broadcast domain type of the network'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the displaytext of the network'}, {u'type': u'string', u'name': u'related', u'description': u'related to what other network configuration'}, {u'type': u'string', u'name': u'vpcid', u'description': u'VPC the network belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the owner of the network'}, {u'type': u'boolean', u'name': u'networkofferingconservemode', u'description': u'true if network offering is ip conserve mode enabled'}, {u'type': u'string', u'name': u'state', u'description': u'state of the network'}, {u'type': u'boolean', u'name': u'canusefordeploy', u'description': u'list networks available for vm deployment'}, {u'type': u'string', u'name': u'dns1', u'description': u'the first DNS for the network'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'cidr', u'description': u'Cloudstack managed address space, all CloudStack managed VMs get IP address from CIDR'}, {u'type': u'boolean', u'name': u'subdomainaccess', u'description': u'true if users from subdomains can access the domain level network'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if network is default, false otherwise'}, {u'type': u'boolean', u'name': u'displaynetwork', u'description': u'an optional field, whether to the display the network to the end user or not.'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the network'}, {u'type': u'string', u'name': u'vlan', u'description': u'The vlan of the network. This parameter is visible to ROOT admins only'}, {u'type': u'string', u'name': u'networkofferingid', u'description': u'network offering id the network is created from'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the network owner'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the network belongs to'}, {u'type': u'boolean', u'name': u'strechedl2subnet', u'description': u'true if network can span multiple zones'}, {u'type': u'boolean', u'name': u'issystem', u'description': u'true if network is system, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the network owner'}, {u'type': u'string', u'name': u'networkofferingdisplaytext', u'description': u'display text of the network offering the network is created from'}, {u'type': u'set', u'name': u'zonesnetworkspans', u'description': u"If a network is enabled for 'streched l2 subnet' then represents zones on which network currently spans"}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'description': u'the list of services', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the service name'}, {u'description': u'the list of capabilities', u'type': u'list', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the capability name'}, {u'type': u'boolean', u'name': u'canchooseservicecapability', u'description': u'can this service capability value can be choosable while creatine network offerings'}, {u'type': u'string', u'name': u'value', u'description': u'the capability value'}], u'name': u'capability'}, {u'description': u'the service provider name', u'type': u'list', u'response': [{u'type': u'string', u'name': u'state', u'description': u'state of the network provider'}, {u'type': u'string', u'name': u'id', u'description': u'uuid of the network provider'}, {u'type': u'boolean', u'name': u'canenableindividualservice', u'description': u'true if individual services can be enabled/disabled'}, {u'type': u'string', u'name': u'destinationphysicalnetworkid', u'description': u'the destination physical network'}, {u'type': u'string', u'name': u'name', u'description': u'the provider name'}, {u'type': u'list', u'name': u'servicelist', u'description': u'services for this provider'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}], u'name': u'provider'}], u'name': u'service'}, {u'type': u'string', u'name': u'networkcidr', u'description': u'the network CIDR of the guest network configured with IP reservation. It is the summation of CIDR and RESERVED_IP_RANGE'}, {u'type': u'string', u'name': u'dns2', u'description': u'the second DNS for the network'}, {u'type': u'boolean', u'name': u'ispersistent', u'description': u'list networks that are persistent'}, {u'type': u'string', u'name': u'netmask', u'description': u"the network's netmask"}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true network requires restart'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the ipaddress'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the network'}], u'name': u'network'}, {u'type': u'boolean', u'name': u'restartrequired', u'description': u'true VPC requires restart'}, {u'type': u'string', u'name': u'zoneid', u'description': u'zone id of the vpc'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'state', u'description': u'state of the VPC. Can be Inactive/Enabled'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the VPC'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone the VPC belongs to'}, {u'description': u'the list of resource tags associated with the project', u'type': u'list', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the VPC'}, {u'type': u'boolean', u'name': u'distributedvpcrouter', u'description': u"is VPC uses distributed router for one hop forwarding and host based network ACL's"}], u'description': u'Restarts a VPC'}}, u'reset': {u'apilimit': {u'name': u'resetApiLimit', u'related': [], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the acount whose limit to be reset'}], u'requiredparams': [], u'response': [{u'type': u'int', u'name': u'apiIssued', u'description': u'number of api already issued'}, {u'type': u'long', u'name': u'expireAfter', u'description': u'seconds left to reset counters'}, {u'type': u'int', u'name': u'apiAllowed', u'description': u'currently allowed number of apis'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the api remaining count'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account uuid of the api remaining count'}], u'description': u'Reset api count'}, u'sshkeyforvirtualmachine': {u'name': u'resetSSHKeyForVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the ssh key. Must be used with domainId.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the virtual machine. If the account parameter is used, domainId must also be used.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project for the ssh key'}, {u'name': u'keypair', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the ssh key pair used to login to the virtual machine'}, {u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'resetSSHKeyForVirtualMachine', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'deployVirtualMachine', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'recoverVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'keypair', u'id'], u'response': [{u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}], u'name': u'nic'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'ingressrule'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}], u'name': u'tags'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}], u'description': u'Resets the SSH Key for virtual machine. The virtual machine must be in a "Stopped" state. [async]'}, u'passwordforvirtualmachine': {u'name': u'resetPasswordForVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}], u'description': u'Resets the password for virtual machine. The virtual machine must be in a "Stopped" state and the template must already support this feature for this command to take effect. [async]'}, u'vpnconnection': {u'name': u'resetVpnConnection', u'related': [u'listVpnConnections'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for connection. If the account parameter is used, domainId must also be used.'}, {u'name': u'id', u'required': True, u'related': [u'resetVpnConnection', u'listVpnConnections'], u'length': 255, u'type': u'uuid', u'description': u'id of vpn connection'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for connection. Must be used with domainId.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'state', u'description': u'State of vpn connection'}, {u'type': u'string', u'name': u's2svpngatewayid', u'description': u'the vpn gateway ID'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the host was created'}, {u'type': u'string', u'name': u'esppolicy', u'description': u'ESP policy of the customer gateway'}, {u'type': u'long', u'name': u'esplifetime', u'description': u'Lifetime of ESP SA of customer gateway'}, {u'type': u'boolean', u'name': u'fordisplay', u'description': u'is connection for display to the regular user'}, {u'type': u'string', u'name': u'cidrlist', u'description': u'guest cidr list of the customer gateway'}, {u'type': u'string', u'name': u'account', u'description': u'the owner'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the owner'}, {u'type': u'string', u'name': u'project', u'description': u'the project name'}, {u'type': u'string', u'name': u'ikepolicy', u'description': u'IKE policy of the customer gateway'}, {u'type': u'string', u'name': u'gateway', u'description': u'public ip address id of the customer gateway'}, {u'type': u'boolean', u'name': u'passive', u'description': u'State of vpn connection'}, {u'type': u'string', u'name': u'publicip', u'description': u'the public IP address'}, {u'type': u'string', u'name': u'id', u'description': u'the connection ID'}, {u'type': u'boolean', u'name': u'dpd', u'description': u'if DPD is enabled for customer gateway'}, {u'type': u'string', u'name': u'ipsecpsk', u'description': u'IPsec Preshared-Key of the customer gateway'}, {u'type': u'date', u'name': u'removed', u'description': u'the date and time the host was removed'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain id of the owner'}, {u'type': u'string', u'name': u's2scustomergatewayid', u'description': u'the customer gateway ID'}, {u'type': u'long', u'name': u'ikelifetime', u'description': u'Lifetime of IKE SA of customer gateway'}], u'description': u'Reset site to site vpn connection'}}, u'expunge': {u'virtualmachine': {u'name': u'expungeVirtualMachine', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'updateVMAffinityGroup', u'startVirtualMachine', u'rebootVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'attachIso', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the virtual machine'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Expunge a virtual machine. Once expunged, it cannot be recoverd.'}}, u'register': {u'userkeys': {u'name': u'registerUserKeys', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'lockUser', u'listUsers'], u'length': 255, u'type': u'uuid', u'description': u'User id'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the registered user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the registered user'}], u'description': u'This command allows a user to register for the developer API, returning a secret key and an API key. This request is made through the integration API port, so it is a privileged command and must be made on behalf of a user. It is up to the implementer just how the username and password are entered, and then how that translates to an integration API request. Both secret key and API key should be returned to the user'}, u'iso': {u'name': u'registerIso', u'related': [u'listIsos', u'listTemplates', u'listIsos', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if iso contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the ISO'}, {u'name': u'bootable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this ISO is bootable. If not passed explicitly its assumed to be true'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account name. Must be used with domainId.'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the display text of the ISO. This is usually used for display purposes.'}, {u'name': u'imagestoreuuid', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Image store uuid'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject'], u'length': 255, u'type': u'uuid', u'description': u'Register iso for the project'}, {u'name': u'isfeatured', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if you want this ISO to be featured'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL to where the ISO is currently being hosted'}, {u'name': u'isextractable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the iso or its derivatives are extractable; default is false'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if you want to register the ISO to be publicly available to all users, false otherwise.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId. If the account parameter is used, domainId must also be used.'}, {u'name': u'ostypeid', u'required': False, u'related': [u'addGuestOs'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS Type that best represents the OS of this ISO. If the iso is bootable this parameter needs to be passed'}, {u'name': u'checksum', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the MD5 checksum value of this ISO'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones', u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone you wish to register the ISO to.'}], u'requiredparams': [u'name', u'displaytext', u'url', u'zoneid'], u'response': [{u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}], u'description': u'Registers an existing ISO into the CloudStack Cloud.'}, u'sshkeypair': {u'name': u'registerSSHKeyPair', u'related': [u'listSSHKeyPairs'], u'isasync': False, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the ssh key. If the account parameter is used, domainId must also be used.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the ssh key. Must be used with domainId.'}, {u'name': u'projectid', u'required': False, u'related': [u'listProjects', u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'an optional project for the ssh key'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the keypair'}, {u'name': u'publickey', u'required': True, u'related': [], u'length': 5120, u'type': u'string', u'description': u'Public key material of the keypair'}], u'requiredparams': [u'name', u'publickey'], u'response': [{u'type': u'string', u'name': u'fingerprint', u'description': u'Fingerprint of the public key'}, {u'type': u'string', u'name': u'name', u'description': u'Name of the keypair'}], u'description': u'Register a public key in a keypair under a certain name'}, u'template': {u'name': u'registerTemplate', u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'isasync': False, u'params': [{u'name': u'bits', u'required': False, u'related': [], u'length': 255, u'type': u'integer', u'description': u'32 or 64 bits support. 64 by default'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'Register template for the project'}, {u'name': u'templatetag', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the tag for this template.'}, {u'name': u'hypervisor', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the target hypervisor for the template'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone the template is to be hosted on'}, {u'name': u'checksum', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the MD5 checksum value of this template'}, {u'name': u'url', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the URL of where the template is hosted. Possible URL include http:// and https://'}, {u'name': u'sshkeyenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template supports the sshkey upload feature; default is false'}, {u'name': u'isfeatured', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this template is a featured template, false otherwise'}, {u'name': u'details', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'Template details in key/value pairs.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional accountName. Must be used with domainId.'}, {u'name': u'isdynamicallyscalable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'name': u'ostypeid', u'required': True, u'related': [u'addGuestOs', u'updateGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the OS Type that best represents the OS of this template.'}, {u'name': u'requireshvm', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if this template requires HVM'}, {u'name': u'displaytext', u'required': True, u'related': [], u'length': 4096, u'type': u'string', u'description': u'the display text of the template. This is usually used for display purposes.'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId. If the account parameter is used, domainId must also be used.'}, {u'name': u'isextractable', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template or its derivatives are extractable; default is false'}, {u'name': u'format', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the format for the template. Possible values include QCOW2, RAW, and VHD.'}, {u'name': u'isrouting', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template type is routing i.e., if template is used to deploy router'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the template'}, {u'name': u'passwordenabled', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template supports the password reset feature; default is false'}, {u'name': u'ispublic', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if the template is available to all accounts; default is true'}], u'requiredparams': [u'hypervisor', u'zoneid', u'url', u'ostypeid', u'displaytext', u'format', u'name'], u'response': [{u'type': u'boolean', u'name': u'isfeatured', u'description': u'true if this template is a featured template, false otherwise'}, {u'type': u'imageformat', u'name': u'format', u'description': u'the format of the template.'}, {u'type': u'string', u'name': u'account', u'description': u'the account name to which the template belongs'}, {u'type': u'boolean', u'name': u'crossZones', u'description': u'true if the template is managed across all Zones, false otherwise'}, {u'type': u'boolean', u'name': u'isready', u'description': u'true if the template is ready to be deployed from, false otherwise.'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account id to which the template belongs'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the template'}, {u'type': u'boolean', u'name': u'ispublic', u'description': u'true if this template is a public template, false otherwise'}, {u'type': u'string', u'name': u'ostypeid', u'description': u'the ID of the OS type for this template.'}, {u'type': u'boolean', u'name': u'sshkeyenabled', u'description': u'true if template is sshkey enabled, false otherwise'}, {u'description': u'the list of resource tags associated with tempate', u'type': u'set', u'response': [{u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the template'}, {u'type': u'string', u'name': u'checksum', u'description': u'checksum of the template'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain to which the template belongs'}, {u'type': u'long', u'name': u'size', u'description': u'the size of the template'}, {u'type': u'string', u'name': u'name', u'description': u'the template name'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if template contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory'}, {u'type': u'string', u'name': u'templatetag', u'description': u'the tag of this template'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the secondary storage host for the template'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the zone for this template'}, {u'type': u'string', u'name': u'ostypename', u'description': u'the name of the OS type for this template.'}, {u'type': u'string', u'name': u'displaytext', u'description': u'the template display text'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the secondary storage host for the template'}, {u'type': u'date', u'name': u'created', u'description': u'the date this template was created'}, {u'type': u'string', u'name': u'templatetype', u'description': u'the type of the template'}, {u'type': u'string', u'name': u'id', u'description': u'the template ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain to which the template belongs'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the template'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the template is extractable, false otherwise'}, {u'type': u'boolean', u'name': u'bootable', u'description': u'true if the ISO is bootable, false otherwise'}, {u'type': u'map', u'name': u'details', u'description': u'additional key/value details tied with template'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the reset password feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'sourcetemplateid', u'description': u'the template ID of the parent template if present'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the zone for this template'}, {u'type': u'date', u'name': u'removed', u'description': u'the date this template was removed'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}], u'description': u'Registers an existing template into the CloudStack cloud. '}}, u'revert': {u'tovmsnapshot': {u'name': u'revertToVMSnapshot', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'vmsnapshotid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The ID of the vm snapshot'}], u'requiredparams': [u'vmsnapshotid'], u'response': [{u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}], u'name': u'tags'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}], u'name': u'egressrule'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}], u'description': u'Revert VM from a vmsnapshot.'}, u'snapshot': {u'name': u'revertSnapshot', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'revertSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the snapshot'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u"the domain ID of the snapshot's account"}, {u'type': u'date', u'name': u'created', u'description': u'  the date the snapshot was created'}, {u'type': u'string', u'name': u'intervaltype', u'description': u'valid types are hourly, daily, weekly, monthy, template, and none.'}, {u'type': u'string', u'name': u'volumename', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'volumeid', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the snapshot'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the snapshot'}, {u'type': u'boolean', u'name': u'revertable', u'description': u'indicates whether the underlying storage supports reverting the volume to this snapshot'}, {u'type': u'string', u'name': u'volumetype', u'description': u'type of the disk volume'}, {u'type': u'string', u'name': u'domain', u'description': u"the domain name of the snapshot's account"}, {u'type': u'string', u'name': u'snapshottype', u'description': u'the type of the snapshot'}, {u'type': u'state', u'name': u'state', u'description': u'the state of the snapshot. BackedUp means that snapshot is ready to be used; Creating - the snapshot is being allocated on the primary storage; BackingUp - the snapshot is being backed up on secondary storage'}, {u'type': u'string', u'name': u'zoneid', u'description': u'id of the availability zone'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the snapshot'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the snapshot'}, {u'type': u'string', u'name': u'name', u'description': u'name of the snapshot'}, {u'description': u'the list of resource tags associated with snapshot', u'type': u'list', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}], u'description': u'revert a volume snapshot.'}}, u'dedicate': {u'publiciprange': {u'name': u'dedicatePublicIpRange', u'related': [u'listVlanIpRanges'], u'isasync': False, u'params': [{u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will own the VLAN'}, {u'name': u'id', u'required': True, u'related': [u'listVlanIpRanges', u'dedicatePublicIpRange'], u'length': 255, u'type': u'uuid', u'description': u'the id of the VLAN IP range'}, {u'name': u'projectid', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'project who will own the VLAN'}, {u'name': u'domainid', u'required': True, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a VLAN'}], u'requiredparams': [u'account', u'id', u'domainid'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the VLAN IP range'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vlan range'}, {u'type': u'string', u'name': u'vlan', u'description': u'the ID or VID of the VLAN.'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the VLAN IP range'}, {u'type': u'string', u'name': u'networkid', u'description': u'the network id of vlan range'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the VLAN IP range'}, {u'type': u'string', u'name': u'podname', u'description': u'the Pod name for the VLAN IP range'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the VLAN IP range'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the VLAN IP range'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'startipv6', u'description': u'the start ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the VLAN IP range'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vlan range'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network this belongs to'}, {u'type': u'string', u'name': u'podid', u'description': u'the Pod ID for the VLAN IP range'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the VLAN IP range'}, {u'type': u'string', u'name': u'startip', u'description': u'the start ip of the VLAN IP range'}, {u'type': u'string', u'name': u'endipv6', u'description': u'the end ipv6 of the VLAN IP range'}, {u'type': u'string', u'name': u'endip', u'description': u'the end ip of the VLAN IP range'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the Zone ID of the VLAN IP range'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the VLAN IP range'}], u'description': u'Dedicates a Public IP range to an account'}, u'zone': {u'name': u'dedicateZone', u'related': [u'listDedicatedZones'], u'isasync': True, u'params': [{u'name': u'domainid', u'required': True, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain'}, {u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account which needs dedication. Must be used with domainId.'}], u'requiredparams': [u'domainid', u'zoneid'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the zone'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account Id to which the Zone is dedicated'}, {u'type': u'string', u'name': u'zonename', u'description': u'the Name of the Zone'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the Zone'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID to which the Zone is dedicated'}], u'description': u'Dedicates a zones.'}, u'guestvlanrange': {u'name': u'dedicateGuestVlanRange', u'related': [], u'isasync': False, u'params': [{u'name': u'domainid', u'required': True, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'domain ID of the account owning a VLAN'}, {u'name': u'physicalnetworkid', u'required': True, u'related': [u'listPhysicalNetworks'], u'length': 255, u'type': u'uuid', u'description': u'physical network ID of the vlan'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'project who will own the VLAN'}, {u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'account who will own the VLAN'}, {u'name': u'vlanrange', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'guest vlan range to be dedicated'}], u'requiredparams': [u'domainid', u'physicalnetworkid', u'account', u'vlanrange'], u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the guest VLAN range'}, {u'type': u'long', u'name': u'zoneid', u'description': u'the zone of the guest vlan range'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the guest VLAN range'}, {u'type': u'string', u'name': u'account', u'description': u'the account of the guest VLAN range'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the guest VLAN range'}, {u'type': u'string', u'name': u'guestvlanrange', u'description': u'the guest VLAN range'}, {u'type': u'long', u'name': u'physicalnetworkid', u'description': u'the physical network of the guest vlan range'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the guest vlan range'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the guest vlan range'}], u'description': u'Dedicates a guest vlan range to an account'}, u'cluster': {u'name': u'dedicateCluster', u'related': [], u'isasync': True, u'params': [{u'name': u'domainid', u'required': True, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain'}, {u'name': u'clusterid', u'required': True, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Cluster'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account which needs dedication. Must be used with domainId.'}], u'requiredparams': [u'domainid', u'clusterid'], u'response': [{u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the cluster'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the cluster'}, {u'type': u'string', u'name': u'clustername', u'description': u'the name of the cluster'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account ID of the cluster'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'clusterid', u'description': u'the ID of the cluster'}], u'description': u'Dedicate an existing cluster'}, u'host': {u'name': u'dedicateHost', u'related': [], u'isasync': True, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account which needs dedication. Must be used with domainId.'}, {u'name': u'domainid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain'}, {u'name': u'hostid', u'required': True, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the host to update'}], u'requiredparams': [u'domainid', u'hostid'], u'response': [{u'type': u'string', u'name': u'accountid', u'description': u'the Account ID of the host'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the host'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the host'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host'}], u'description': u'Dedicates a host.'}, u'pod': {u'name': u'dedicatePod', u'related': [], u'isasync': True, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the name of the account which needs dedication. Must be used with domainId.'}, {u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Pod'}, {u'name': u'domainid', u'required': True, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the containing domain'}], u'requiredparams': [u'podid', u'domainid'], u'response': [{u'type': u'string', u'name': u'podid', u'description': u'the ID of the Pod'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID to which the Pod is dedicated'}, {u'type': u'string', u'name': u'accountid', u'description': u'the Account Id to which the Pod is dedicated'}, {u'type': u'string', u'name': u'podname', u'description': u'the Name of the Pod'}, {u'type': u'string', u'name': u'affinitygroupid', u'description': u'the Dedication Affinity Group ID of the pod'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the dedicated resource'}], u'description': u'Dedicates a Pod.'}}, u'remove': {u'fromgloballoadbalancerrule': {u'name': u'removeFromGlobalLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createGlobalLoadBalancerRule', u'listGlobalLoadBalancerRules', u'updateGlobalLoadBalancerRule'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the load balancer rule'}, {u'name': u'loadbalancerrulelist', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'list', u'description': u'the list load balancer rules that will be assigned to gloabal load balacner rule'}], u'requiredparams': [u'id', u'loadbalancerrulelist'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes a load balancer rule association with global load balancer rule'}, u'fromloadbalancerrule': {u'name': u'removeFromLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'virtualmachineids', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'list', u'description': u'the list of IDs of the virtual machines that are being removed from the load balancer rule (i.e. virtualMachineIds=1,2,3)'}, {u'name': u'vmidipmap', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'VM ID and IP map, vmidipmap[0].vmid=1 vmidipmap[0].ip=10.1.1.75'}, {u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the load balancer rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes a virtual machine or a list of virtual machines from a load balancer rule.'}, u'resourcedetail': {u'name': u'removeResourceDetail', u'related': [], u'isasync': True, u'params': [{u'name': u'resourceid', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Delete details for resource id'}, {u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Delete detail by resource type'}, {u'name': u'key', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Delete details matching key/value pairs'}], u'requiredparams': [u'resourceid', u'resourcetype'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes detail for the Resource.'}, u'guestosmapping': {u'name': u'removeGuestOsMapping', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updateGuestOsMapping', u'addGuestOsMapping'], u'length': 255, u'type': u'uuid', u'description': u'ID of the guest OS mapping'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Removes a Guest OS Mapping.'}, u'nicfromvirtualmachine': {u'name': u'removeNicFromVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': True, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'removeNicFromVirtualMachine', u'resetPasswordForVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'updateDefaultNicForVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'Virtual Machine ID'}, {u'name': u'nicid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'NIC ID'}], u'requiredparams': [u'virtualmachineid', u'nicid'], u'response': [{u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}], u'name': u'nic'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}, {u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}], u'name': u'tags'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}], u'name': u'tags'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}], u'name': u'securitygroup'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}], u'description': u'Removes VM from specified network by deleting a NIC'}, u'vpnuser': {u'name': u'removeVpnUser', u'related': [], u'isasync': True, u'params': [{u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'an optional domainId for the vpn user. If the account parameter is used, domainId must also be used.'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'an optional account for the vpn user. Must be used with domainId.'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'remove vpn user from the project'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'username for the vpn user'}], u'requiredparams': [u'username'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes vpn user'}, u'vmwaredc': {u'name': u'removeVmwareDc', u'related': [], u'isasync': False, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'The id of Zone from which VMware datacenter has to be removed.'}], u'requiredparams': [u'zoneid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Remove a VMware datacenter from a zone.'}, u'guestos': {u'name': u'removeGuestOs', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'addGuestOs', u'listOsTypes'], u'length': 255, u'type': u'uuid', u'description': u'ID of the guest OS'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes a Guest OS from listing.'}, u'certfromloadbalancer': {u'name': u'removeCertFromLoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}], u'requiredparams': [u'lbruleid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Removes a certificate from a Load Balancer Rule'}, u'region': {u'name': u'removeRegion', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'integer', u'description': u'ID of the region to delete'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Removes specified region'}, u'ipfromnic': {u'name': u'removeIpFromNic', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'addIpToNic'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the secondary ip address to nic'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Removes secondary IP from the NIC.'}}, u'mark': {u'defaultzoneforaccount': {u'name': u'markDefaultZoneForAccount', u'related': [u'listAccounts'], u'isasync': True, u'params': [{u'name': u'account', u'required': True, u'related': [u'listAccounts', u'markDefaultZoneForAccount'], u'length': 255, u'type': u'string', u'description': u'Name of the account that is to be marked.'}, {u'name': u'zoneid', u'required': True, u'related': [u'listZones'], u'length': 255, u'type': u'uuid', u'description': u'The Zone ID with which the account is to be marked.'}, {u'name': u'domainid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Marks the account that belongs to the specified domain.'}], u'requiredparams': [u'account', u'zoneid', u'domainid'], u'response': [{u'type': u'long', u'name': u'receivedbytes', u'description': u'the total number of network traffic bytes received'}, {u'type': u'string', u'name': u'iplimit', u'description': u'the total number of public ip addresses this account can acquire'}, {u'type': u'string', u'name': u'primarystoragelimit', u'description': u'the total primary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'memorylimit', u'description': u'the total memory (in MB) the account can own'}, {u'type': u'string', u'name': u'id', u'description': u'the id of the account'}, {u'type': u'long', u'name': u'sentbytes', u'description': u'the total number of network traffic bytes sent'}, {u'type': u'long', u'name': u'vmtotal', u'description': u'the total number of virtual machines deployed by this account'}, {u'type': u'long', u'name': u'projecttotal', u'description': u'the total number of projects being administrated by this account'}, {u'type': u'list', u'name': u'groups', u'description': u'the list of acl groups that account belongs to'}, {u'type': u'long', u'name': u'volumetotal', u'description': u'the total volume being used by this account'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if account is default, false otherwise'}, {u'type': u'string', u'name': u'domain', u'description': u'name of the Domain the account belongs too'}, {u'type': u'long', u'name': u'memorytotal', u'description': u'the total memory (in MB) owned by account'}, {u'type': u'string', u'name': u'networkdomain', u'description': u'the network domain'}, {u'type': u'string', u'name': u'ipavailable', u'description': u'the total number of public ip addresses available for this account to acquire'}, {u'type': u'string', u'name': u'projectavailable', u'description': u'the total number of projects available for administration by this account'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the account'}, {u'type': u'string', u'name': u'primarystorageavailable', u'description': u'the total primary storage space (in GiB) available to be used for this account'}, {u'type': u'integer', u'name': u'vmstopped', u'description': u'the total number of virtual machines stopped for this account'}, {u'type': u'string', u'name': u'projectlimit', u'description': u'the total number of projects the account can own'}, {u'type': u'long', u'name': u'iptotal', u'description': u'the total number of public ip addresses allocated for this account'}, {u'type': u'long', u'name': u'vpctotal', u'description': u'the total number of vpcs owned by account'}, {u'type': u'long', u'name': u'secondarystoragetotal', u'description': u'the total secondary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'templateavailable', u'description': u'the total number of templates available to be created by this account'}, {u'type': u'short', u'name': u'accounttype', u'description': u'account type (admin, domain-admin, user)'}, {u'type': u'string', u'name': u'defaultzoneid', u'description': u'the default zone of the account'}, {u'type': u'string', u'name': u'secondarystorageavailable', u'description': u'the total secondary storage space (in GiB) available to be used for this account'}, {u'type': u'string', u'name': u'memoryavailable', u'description': u'the total memory (in MB) available to be created for this account'}, {u'type': u'integer', u'name': u'vmrunning', u'description': u'the total number of virtual machines running for this account'}, {u'type': u'string', u'name': u'vpcavailable', u'description': u'the total number of vpcs available to be created for this account'}, {u'type': u'string', u'name': u'domainid', u'description': u'id of the Domain the account belongs too'}, {u'type': u'map', u'name': u'accountdetails', u'description': u'details for the account'}, {u'type': u'long', u'name': u'cputotal', u'description': u'the total number of cpu cores owned by account'}, {u'type': u'boolean', u'name': u'iscleanuprequired', u'description': u'true if the account requires cleanup'}, {u'type': u'string', u'name': u'vmavailable', u'description': u'the total number of virtual machines available for this account to acquire'}, {u'type': u'long', u'name': u'networktotal', u'description': u'the total number of networks owned by account'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the account'}, {u'type': u'string', u'name': u'snapshotlimit', u'description': u'the total number of snapshots which can be stored by this account'}, {u'type': u'string', u'name': u'cpulimit', u'description': u'the total number of cpu cores the account can own'}, {u'type': u'long', u'name': u'primarystoragetotal', u'description': u'the total primary storage space (in GiB) owned by account'}, {u'type': u'string', u'name': u'vpclimit', u'description': u'the total number of vpcs the account can own'}, {u'type': u'string', u'name': u'secondarystoragelimit', u'description': u'the total secondary storage space (in GiB) the account can own'}, {u'type': u'string', u'name': u'vmlimit', u'description': u'the total number of virtual machines that can be deployed by this account'}, {u'description': u'the list of users associated with account', u'type': u'list', u'response': [{u'type': u'string', u'name': u'timezone', u'description': u'the timezone user was created in'}, {u'type': u'string', u'name': u'firstname', u'description': u'the user firstname'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the user'}, {u'type': u'date', u'name': u'created', u'description': u'the date and time the user account was created'}, {u'type': u'boolean', u'name': u'iscallerchilddomain', u'description': u"the boolean value representing if the updating target is in caller's child domain"}, {u'type': u'string', u'name': u'id', u'description': u'the user ID'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the user'}, {u'type': u'string', u'name': u'accountid', u'description': u'the account ID of the user'}, {u'type': u'string', u'name': u'username', u'description': u'the user name'}, {u'type': u'string', u'name': u'state', u'description': u'the user state'}, {u'type': u'string', u'name': u'account', u'description': u'the account name of the user'}, {u'type': u'string', u'name': u'apikey', u'description': u'the api key of the user'}, {u'type': u'short', u'name': u'accounttype', u'description': u'the account type of the user'}, {u'type': u'boolean', u'name': u'isdefault', u'description': u'true if user is default, false otherwise'}, {u'type': u'string', u'name': u'email', u'description': u'the user email address'}, {u'type': u'string', u'name': u'lastname', u'description': u'the user lastname'}, {u'type': u'string', u'name': u'secretkey', u'description': u'the secret key of the user'}], u'name': u'user'}, {u'type': u'string', u'name': u'snapshotavailable', u'description': u'the total number of snapshots available for this account'}, {u'type': u'string', u'name': u'networklimit', u'description': u'the total number of networks the account can own'}, {u'type': u'string', u'name': u'volumeavailable', u'description': u'the total volume available for this account'}, {u'type': u'string', u'name': u'volumelimit', u'description': u'the total volume which can be used by this account'}, {u'type': u'string', u'name': u'cpuavailable', u'description': u'the total number of cpu cores available to be created for this account'}, {u'type': u'string', u'name': u'templatelimit', u'description': u'the total number of templates which can be created by this account'}, {u'type': u'string', u'name': u'networkavailable', u'description': u'the total number of networks available to be created for this account'}, {u'type': u'long', u'name': u'snapshottotal', u'description': u'the total number of snapshots stored by this account'}, {u'type': u'long', u'name': u'templatetotal', u'description': u'the total number of templates which have been created by this account'}], u'description': u'Marks a default zone for this account'}}, u'asyncapis': [u'createCondition', u'reconnectHost', u'copyTemplate', u'addNicToVirtualMachine', u'extractVolume', u'addAccountToProject', u'deleteCiscoNexusVSM', u'deleteEgressFirewallRule', u'createVpnConnection', u'suspendProject', u'deleteLoadBalancer', u'authorizeSecurityGroupIngress', u'addNetscalerLoadBalancer', u'deleteDomain', u'createPortableIpRange', u'configureNetscalerLoadBalancer', u'createTemplate', u'migrateVolume', u'deleteLBHealthCheckPolicy', u'updatePhysicalNetwork', u'deleteStaticRoute', u'deletePaloAltoFirewall', u'destroySystemVm', u'updateRemoteAccessVpn', u'enableStorageMaintenance', u'updateLoadBalancer', u'removeFromGlobalLoadBalancerRule', u'stopRouter', u'attachVolume', u'updateVPCOffering', u'resetSSHKeyForVirtualMachine', u'cleanVMReservations', u'createAffinityGroup', u'deleteTags', u'deleteAccountFromProject', u'addBaremetalPxePingServer', u'deletePortableIpRange', u'updateVolume', u'uploadCustomCertificate', u'createAutoScaleVmProfile', u'releaseDedicatedGuestVlanRange', u'cancelHostMaintenance', u'releaseDedicatedHost', u'addNuageVspDevice', u'deleteStorageNetworkIpRange', u'createInternalLoadBalancerElement', u'deleteFirewallRule', u'deleteNiciraNvpDevice', u'deleteProject', u'removeIpFromNic', u'deleteIpForwardingRule', u'createGlobalLoadBalancerRule', u'resizeVolume', u'deleteBrocadeVcsDevice', u'createStaticRoute', u'deleteGlobalLoadBalancerRule', u'activateProject', u'releaseDedicatedZone', u'createVMSnapshot', u'configureF5LoadBalancer', u'createIpForwardingRule', u'updateIpAddress', u'addPaloAltoFirewall', u'releaseDedicatedCluster', u'updateVPC', u'startInternalLoadBalancerVM', u'associateUcsProfileToBlade', u'updateAutoScaleVmProfile', u'updatePortForwardingRule', u'createStorageNetworkIpRange', u'addGloboDnsHost', u'createLoadBalancer', u'cancelStorageMaintenance', u'deployVirtualMachine', u'revokeSecurityGroupEgress', u'createNetworkACLList', u'deleteCondition', u'createPortForwardingRule', u'createVPCOffering', u'createEgressFirewallRule', u'destroyRouter', u'updateLBStickinessPolicy', u'updateSnapshotPolicy', u'assignToGlobalLoadBalancerRule', u'updateTrafficType', u'addSrxFirewall', u'addNiciraNvpDevice', u'updateNetworkACLItem', u'addIpToNic', u'deleteNetworkACLList', u'configureInternalLoadBalancerElement', u'releaseHostReservation', u'assignCertToLoadBalancer', u'deleteVpnGateway', u'expungeVirtualMachine', u'createAutoScaleVmGroup', u'rebootRouter', u'deleteNetworkServiceProvider', u'createLBHealthCheckPolicy', u'deleteIso', u'removeGuestOsMapping', u'createVpnCustomerGateway', u'deleteAutoScalePolicy', u'deleteSrxFirewall', u'updateNetworkACLList', u'detachVolume', u'deleteNetworkACL', u'deleteVPC', u'updateLoadBalancerRule', u'createPhysicalNetwork', u'deleteTemplate', u'deleteVpnCustomerGateway', u'createVirtualRouterElement', u'updateAutoScalePolicy', u'addBigSwitchVnsDevice', u'releaseDedicatedPod', u'createVpnGateway', u'dedicateZone', u'dedicateCluster', u'deleteCounter', u'updateStorageNetworkIpRange', u'addBrocadeVcsDevice', u'deleteBigSwitchVnsDevice', u'dedicatePod', u'addF5LoadBalancer', u'deleteAutoScaleVmGroup', u'updateGlobalLoadBalancerRule', u'createServiceInstance', u'deleteBaremetalRct', u'authorizeSecurityGroupEgress', u'disableAutoScaleVmGroup', u'prepareHostForMaintenance', u'addOpenDaylightController', u'updateEgressFirewallRule', u'deletePrivateGateway', u'updateGuestOs', u'stopInternalLoadBalancerVM', u'deleteTrafficType', u'deleteLoadBalancerRule', u'attachIso', u'deletePortForwardingRule', u'removeCertFromLoadBalancer', u'configureSrxFirewall', u'updateProjectInvitation', u'createTags', u'enableAutoScaleVmGroup', u'removeVpnUser', u'scaleVirtualMachine', u'updateVpnCustomerGateway', u'stopSystemVm', u'restartNetwork', u'removeGuestOs', u'rebootVirtualMachine', u'enableCiscoNexusVSM', u'configurePaloAltoFirewall', u'updateVMAffinityGroup', u'deleteVpnConnection', u'updateVpnConnection', u'updateVpnGateway', u'startSystemVm', u'deleteF5LoadBalancer', u'updateProject', u'deleteNetwork', u'deleteNetscalerLoadBalancer', u'addTrafficType', u'deleteNuageVspDevice', u'disableUser', u'configureVirtualRouterElement', u'deleteProjectInvitation', u'migrateSystemVm', u'removeNicFromVirtualMachine', u'revokeSecurityGroupIngress', u'updateDefaultNicForVirtualMachine', u'disableStaticNat', u'createNetworkACL', u'createVPC', u'addBaremetalPxeKickStartServer', u'addResourceDetail', u'disassociateIpAddress', u'createVolume', u'resetPasswordForVirtualMachine', u'assignToLoadBalancerRule', u'startRouter', u'updateGuestOsMapping', u'extractIso', u'removeResourceDetail', u'deleteRemoteAccessVpn', u'resetVpnConnection', u'createRemoteAccessVpn', u'startVirtualMachine', u'extractTemplate', u'detachIso', u'deleteAccount', u'associateIpAddress', u'disableAccount', u'migrateVirtualMachine', u'removeFromLoadBalancerRule', u'addVpnUser', u'updateLBHealthCheckPolicy', u'updateFirewallRule', u'deleteLBStickinessPolicy', u'createPrivateGateway', u'disableCiscoNexusVSM', u'deleteVMSnapshot', u'deleteAutoScaleVmProfile', u'deleteSnapshot', u'createProject', u'createLoadBalancerRule', u'createAutoScalePolicy', u'restoreVirtualMachine', u'deleteAffinityGroup', u'copyIso', u'addGuestOsMapping', u'uploadVolume', u'createLBStickinessPolicy', u'migrateVirtualMachineWithVolume', u'stopVirtualMachine', u'createCounter', u'createSnapshot', u'configureOvsElement', u'updateNetwork', u'destroyVirtualMachine', u'dedicateHost', u'createFirewallRule', u'addNetworkServiceProvider', u'rebootSystemVm', u'revertToVMSnapshot', u'markDefaultZoneForAccount', u'restartVPC', u'replaceNetworkACLList', u'generateAlert', u'scaleSystemVm', u'updateAutoScaleVmGroup', u'deletePhysicalNetwork', u'addBaremetalDhcp', u'deleteVPCOffering', u'deleteOpenDaylightController', u'updateNetworkServiceProvider', u'addGuestOs', u'revertSnapshot'], u'resize': {u'volume': {u'name': u'resizeVolume', u'related': [u'listVolumes', u'detachVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'isasync': True, u'params': [{u'name': u'shrinkok', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Verify OK to Shrink'}, {u'name': u'miniops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'New minimum number of IOPS'}, {u'name': u'id', u'required': True, u'related': [u'listVolumes', u'detachVolume', u'resizeVolume', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the disk volume'}, {u'name': u'diskofferingid', u'required': False, u'related': [u'updateDiskOffering', u'listDiskOfferings', u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'new disk offering id'}, {u'name': u'maxiops', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'New maximum number of IOPS'}, {u'name': u'size', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'New volume size in GB'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account associated with the disk volume'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'Hypervisor the volume belongs to'}, {u'type': u'string', u'name': u'serviceofferingdisplaytext', u'description': u'the display text of the service offering for root disk'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the disk volume'}, {u'type': u'boolean', u'name': u'isextractable', u'description': u'true if the volume is extractable, false otherwise'}, {u'type': u'string', u'name': u'storagetype', u'description': u'shared or local storage'}, {u'type': u'boolean', u'name': u'quiescevm', u'description': u'need quiesce vm or not when taking snapshot'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'type', u'description': u'type of the disk volume (ROOT or DATADISK)'}, {u'type': u'string', u'name': u'zonename', u'description': u'name of the availability zone'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'long', u'name': u'maxiops', u'description': u'max iops of the disk volume'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'date', u'name': u'created', u'description': u'the date the disk volume was created'}, {u'type': u'string', u'name': u'status', u'description': u'the status of the volume'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vpn'}, {u'description': u'the list of resource tags associated with volume', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vmname', u'description': u'name of the virtual machine'}, {u'type': u'string', u'name': u'id', u'description': u'ID of the disk volume'}, {u'type': u'string', u'name': u'storage', u'description': u'name of the primary storage hosting the disk volume'}, {u'type': u'string', u'name': u'vmstate', u'description': u'state of the virtual machine'}, {u'type': u'string', u'name': u'vmdisplayname', u'description': u'display name of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the disk volume'}, {u'type': u'date', u'name': u'attached', u'description': u'the date the volume was attached to a VM instance'}, {u'type': u'string', u'name': u'path', u'description': u'the path of the volume'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the disk volume'}, {u'type': u'long', u'name': u'deviceid', u'description': u'the ID of the device on user vm the volume is attahed to. This tag is not returned when the volume is detached.'}, {u'type': u'long', u'name': u'miniops', u'description': u'min iops of the disk volume'}, {u'type': u'string', u'name': u'name', u'description': u'name of the disk volume'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'ID of the disk offering'}, {u'type': u'string', u'name': u'diskofferingdisplaytext', u'description': u'the display text of the disk offering'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'name of the service offering for root disk'}, {u'type': u'long', u'name': u'diskIopsWriteRate', u'description': u'io requests write rate of the disk volume'}, {u'type': u'string', u'name': u'storageid', u'description': u'id of the primary storage hosting the disk volume; returned to admin user only'}, {u'type': u'boolean', u'name': u'displayvolume', u'description': u'an optional field whether to the display the volume to the end user or not.'}, {u'type': u'string', u'name': u'zoneid', u'description': u'ID of the availability zone'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vpn'}, {u'type': u'boolean', u'name': u'destroyed', u'description': u'the boolean state of whether the volume is destroyed or not'}, {u'type': u'long', u'name': u'diskBytesReadRate', u'description': u'bytes read rate of the disk volume'}, {u'type': u'string', u'name': u'snapshotid', u'description': u'ID of the snapshot from which this volume was created'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'chaininfo', u'description': u'the chain info of the volume'}, {u'type': u'long', u'name': u'diskIopsReadRate', u'description': u'io requests read rate of the disk volume'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'ID of the service offering for root disk'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'id of the virtual machine'}, {u'type': u'long', u'name': u'diskBytesWriteRate', u'description': u'bytes write rate of the disk volume'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'name of the disk offering'}, {u'type': u'long', u'name': u'size', u'description': u'size of the disk volume'}, {u'type': u'string', u'name': u'provisioningtype', u'description': u'provisioning type used to create volumes.'}], u'description': u'Resizes a volume'}}, u'clean': {u'vmreservations': {u'name': u'cleanVMReservations', u'related': [], u'isasync': True, u'params': [], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Cleanups VM reservations in the database.'}}, u'login': {u'': {u'name': u'login', u'related': [u'samlSso'], u'isasync': False, u'params': [{u'name': u'password', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hashed password (Default is MD5). If you wish to use any other hashing algorithm, you would need to write a custom authentication adapter See Docs section.'}, {u'name': u'domainId', u'required': False, u'related': [], u'length': 255, u'type': u'long', u'description': u'The id of the domain that the user belongs to. If both domain and domainId are passed in, "domainId" parameter takes precendence'}, {u'name': u'domain', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'Path of the domain that the user belongs to. Example: domain=/com/cloud/internal. If no domain is passed in, the ROOT (/) domain is assumed.'}, {u'name': u'username', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Username'}], u'requiredparams': [u'password', u'username'], u'response': [{u'type': u'string', u'name': u'sessionkey', u'description': u'Session key that can be passed in subsequent Query command calls'}, {u'type': u'string', u'name': u'username', u'description': u'Username'}, {u'type': u'string', u'name': u'registered', u'description': u'Is user registered'}, {u'type': u'string', u'name': u'firstname', u'description': u'first name of the user'}, {u'type': u'string', u'name': u'account', u'description': u'the account name the user belongs to'}, {u'type': u'string', u'name': u'lastname', u'description': u'last name of the user'}, {u'type': u'string', u'name': u'timezone', u'description': u'user time zone'}, {u'type': u'string', u'name': u'type', u'description': u'the account type (admin, domain-admin, read-only-admin, user)'}, {u'type': u'string', u'name': u'userid', u'description': u'User ID'}, {u'type': u'integer', u'name': u'timeout', u'description': u'the time period before the session has expired'}, {u'type': u'string', u'name': u'domainid', u'description': u'Domain ID that the user belongs to'}], u'description': u'Logs a user into the CloudStack. A successful login attempt will generate a JSESSIONID cookie value that can be passed in subsequent Query command calls until the "logout" command has been issued or the session has expired.'}}, u'delete': {u'baremetalrct': {u'name': u'deleteBaremetalRct', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listBaremetalRct', u'addBaremetalRct'], u'length': 255, u'type': u'uuid', u'description': u'RCT id'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'deletes baremetal rack configuration text'}, u'loadbalancerrule': {u'name': u'deleteLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a load balancer rule.'}, u'domain': {u'name': u'deleteDomain', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'ID of domain to delete'}, {u'name': u'cleanup', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'true if all domain resources (child domains, accounts) have to be cleaned up, false otherwise'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a specified domain'}, u'alerts': {u'name': u'deleteAlerts', u'related': [], u'isasync': False, u'params': [{u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'delete by alert type'}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'start date range to delete alerts (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}, {u'name': u'enddate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'end date range to delete alerts (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}, {u'name': u'ids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the IDs of the alerts'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Delete one or more alerts.'}, u'ciscoasa1000vresource': {u'name': u'deleteCiscoAsa1000vResource', u'related': [], u'isasync': False, u'params': [{u'name': u'resourceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Cisco ASA 1000v resource ID'}], u'requiredparams': [u'resourceid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a Cisco ASA 1000v appliance'}, u'diskoffering': {u'name': u'deleteDiskOffering', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'createDiskOffering'], u'length': 255, u'type': u'uuid', u'description': u'ID of the disk offering'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Updates a disk offering.'}, u'nuagevspdevice': {u'name': u'deleteNuageVspDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'vspdeviceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'Nuage device ID'}], u'requiredparams': [u'vspdeviceid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'delete a nuage vsp device'}, u'autoscalepolicy': {u'name': u'deleteAutoScalePolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createAutoScalePolicy', u'updateAutoScalePolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale policy'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a autoscale policy.'}, u'externalloadbalancer': {u'name': u'deleteExternalLoadBalancer', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'updateHost', u'cancelHostMaintenance', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'Id of the external loadbalancer appliance.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a F5 external load balancer appliance added in a zone.'}, u'securitygroup': {u'name': u'deleteSecurityGroup', u'related': [], u'isasync': False, u'params': [{u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account of the security group. Must be specified with domain ID'}, {u'name': u'id', u'required': False, u'related': [u'listSecurityGroups'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the security group. Mutually exclusive with name parameter'}, {u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'the project of the security group'}, {u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The ID of the security group. Mutually exclusive with id parameter'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID of account owning the security group'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes security group'}, u'portforwardingrule': {u'name': u'deletePortForwardingRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the port forwarding rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a port forwarding rule'}, u'cluster': {u'name': u'deleteCluster', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the cluster ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a cluster.'}, u'accountfromproject': {u'name': u'deleteAccountFromProject', u'related': [], u'isasync': True, u'params': [{u'name': u'projectid', u'required': True, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to remove the account from'}, {u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'name of the account to be removed from the project'}], u'requiredparams': [u'projectid', u'account'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes account from the project'}, u'opendaylightcontroller': {u'name': u'deleteOpenDaylightController', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'deleteOpenDaylightController'], u'length': 255, u'type': u'uuid', u'description': u'OpenDaylight Controller ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'url', u'description': u'the url of the controller api'}, {u'type': u'string', u'name': u'name', u'description': u'the name assigned to the controller'}, {u'type': u'string', u'name': u'id', u'description': u'device id of the controller'}, {u'type': u'string', u'name': u'physicalnetworkid', u'description': u'the physical network to which this controller belongs to'}, {u'type': u'string', u'name': u'username', u'description': u'the username to authenticate to the controller'}], u'description': u'Removes an OpenDyalight controler'}, u'networkdevice': {u'name': u'deleteNetworkDevice', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'Id of network device to delete'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes network device.'}, u'pod': {u'name': u'deletePod', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'createPod', u'updatePod', u'listPods'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Pod'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a Pod.'}, u'cisconexusvsm': {u'name': u'deleteCiscoNexusVSM', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'enableCiscoNexusVSM', u'listCiscoNexusVSMs', u'disableCiscoNexusVSM'], u'length': 255, u'type': u'uuid', u'description': u'Id of the Cisco Nexus 1000v VSM device to be deleted'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u' delete a Cisco Nexus VSM device'}, u'brocadevcsdevice': {u'name': u'deleteBrocadeVcsDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'vcsdeviceid', u'required': True, u'related': [u'listBrocadeVcsDevices', u'addBrocadeVcsDevice'], u'length': 255, u'type': u'uuid', u'description': u'Brocade Switch ID'}], u'requiredparams': [u'vcsdeviceid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u' delete a Brocade VCS Switch'}, u'secondarystagingstore': {u'name': u'deleteSecondaryStagingStore', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listSecondaryStagingStores', u'addS3', u'listSwifts', u'addImageStore', u'createSecondaryStagingStore'], u'length': 255, u'type': u'uuid', u'description': u'the staging store ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a secondary staging store .'}, u'project': {u'name': u'deleteProject', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createProject', u'updateProject', u'listProjectAccounts', u'activateProject'], u'length': 255, u'type': u'uuid', u'description': u'id of the project to be deleted'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a project'}, u'snapshotpolicies': {u'name': u'deleteSnapshotPolicies', u'related': [], u'isasync': False, u'params': [{u'name': u'ids', u'required': False, u'related': [u'createSnapshotPolicy'], u'length': 255, u'type': u'list', u'description': u'list of snapshots policy IDs separated by comma'}, {u'name': u'id', u'required': False, u'related': [u'createSnapshotPolicy'], u'length': 255, u'type': u'uuid', u'description': u'the Id of the snapshot policy'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes snapshot policies for the account.'}, u'vpcoffering': {u'name': u'deleteVPCOffering', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the VPC offering'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes VPC offering'}, u'network': {u'name': u'deleteNetwork', u'related': [], u'isasync': True, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u"Force delete a network. Network will be marked as 'Destroy' even when commands to shutdown and cleanup to the backend fails."}, {u'name': u'id', u'required': True, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'listSrxFirewallNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a network'}, u'zone': {u'name': u'deleteZone', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a Zone.'}, u'remoteaccessvpn': {u'name': u'deleteRemoteAccessVpn', u'related': [], u'isasync': True, u'params': [{u'name': u'publicipid', u'required': True, u'related': [u'associateIpAddress', u'listPublicIpAddresses', u'associateIpAddress'], u'length': 255, u'type': u'uuid', u'description': u'public ip address id of the vpn server'}], u'requiredparams': [u'publicipid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Destroys a l2tp/ipsec remote access vpn'}, u'storagenetworkiprange': {u'name': u'deleteStorageNetworkIpRange', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listStorageNetworkIpRange', u'createStorageNetworkIpRange', u'updateStorageNetworkIpRange'], u'length': 255, u'type': u'uuid', u'description': u'the uuid of the storage network ip range'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a storage network IP Range.'}, u'ipforwardingrule': {u'name': u'deleteIpForwardingRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the id of the forwarding rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes an ip forwarding rule'}, u'projectinvitation': {u'name': u'deleteProjectInvitation', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'id of the invitation'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes project invitation'}, u'ciscovnmcresource': {u'name': u'deleteCiscoVnmcResource', u'related': [], u'isasync': False, u'params': [{u'name': u'resourceid', u'required': True, u'related': [u'addCiscoVnmcResource'], u'length': 255, u'type': u'uuid', u'description': u'Cisco Vnmc resource ID'}], u'requiredparams': [u'resourceid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a Cisco Vnmc controller'}, u'globalloadbalancerrule': {u'name': u'deleteGlobalLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listGlobalLoadBalancerRules', u'updateGlobalLoadBalancerRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the global load balancer rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a global load balancer rule.'}, u'portableiprange': {u'name': u'deletePortableIpRange', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listPortableIpRanges'], u'length': 255, u'type': u'uuid', u'description': u'Id of the portable ip range'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u"deletes a range of portable public IP's associated with a region"}, u'niciranvpdevice': {u'name': u'deleteNiciraNvpDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'nvpdeviceid', u'required': True, u'related': [u'listNiciraNvpDevices', u'addNiciraNvpDevice'], u'length': 255, u'type': u'uuid', u'description': u'Nicira device ID'}], u'requiredparams': [u'nvpdeviceid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u' delete a nicira nvp device'}, u'serviceoffering': {u'name': u'deleteServiceOffering', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listServiceOfferings'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the service offering'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a service offering.'}, u'condition': {u'name': u'deleteCondition', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listConditions'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the condition.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Removes a condition'}, u'template': {u'name': u'deleteTemplate', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the template'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of zone of the template'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a template from the system. All virtual machines using the deleted template will not be affected.'}, u'vpngateway': {u'name': u'deleteVpnGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createVpnGateway', u'updateVpnGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of customer gateway'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Delete site to site vpn gateway'}, u'iso': {u'name': u'deleteIso', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listTemplates', u'prepareTemplate', u'registerIso', u'listIsos', u'listTemplates', u'listIsos', u'updateTemplate', u'registerTemplate', u'copyIso', u'updateIso', u'registerIso', u'createTemplate', u'copyIso', u'registerTemplate', u'copyTemplate'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the ISO file'}, {u'name': u'zoneid', u'required': False, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the zone of the ISO file. If not specified, the ISO will be deleted from all the zones'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes an ISO file.'}, u'networkacllist': {u'name': u'deleteNetworkACLList', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a Network ACL'}, u'events': {u'name': u'deleteEvents', u'related': [], u'isasync': False, u'params': [{u'name': u'type', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'delete by event type'}, {u'name': u'enddate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'end date range to delete events (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}, {u'name': u'ids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'the IDs of the events'}, {u'name': u'startdate', u'required': False, u'related': [], u'length': 255, u'type': u'date', u'description': u'start date range to delete events (including) this date (use format "yyyy-MM-dd" or the new format "yyyy-MM-ddThh:mm:ss")'}], u'requiredparams': [], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Delete one or more events.'}, u'autoscalevmgroup': {u'name': u'deleteAutoScaleVmGroup', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'disableAutoScaleVmGroup', u'enableAutoScaleVmGroup', u'updateAutoScaleVmGroup'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale group'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a autoscale vm group.'}, u'vpnconnection': {u'name': u'deleteVpnConnection', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'resetVpnConnection', u'updateVpnConnection', u'listVpnConnections'], u'length': 255, u'type': u'uuid', u'description': u'id of vpn connection'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Delete site to site vpn connection'}, u'trafficmonitor': {u'name': u'deleteTrafficMonitor', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'listExternalLoadBalancers', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'Id of the Traffic Monitor Host.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes an traffic monitor host.'}, u'networkacl': {u'name': u'deleteNetworkACL', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createNetworkACL'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network ACL'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a Network ACL'}, u'storagepool': {u'name': u'deleteStoragePool', u'related': [], u'isasync': False, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force destroy storage pool (force expunge volumes in Destroyed state as a part of pool removal)'}, {u'name': u'id', u'required': True, u'related': [u'findStoragePoolsForMigration'], u'length': 255, u'type': u'uuid', u'description': u'Storage pool id'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a storage pool.'}, u'ldapconfiguration': {u'name': u'deleteLdapConfiguration', u'related': [u'addLdapConfiguration'], u'isasync': False, u'params': [{u'name': u'hostname', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Hostname'}], u'requiredparams': [u'hostname'], u'response': [{u'type': u'int', u'name': u'port', u'description': u'port'}, {u'type': u'string', u'name': u'hostname', u'description': u'hostname'}], u'description': u'Remove an Ldap Configuration'}, u'sslcert': {u'name': u'deleteSslCert', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listSslCerts'], u'length': 255, u'type': u'uuid', u'description': u'Id of SSL certificate'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Delete a certificate to cloudstack'}, u'lbstickinesspolicy': {u'name': u'deleteLBStickinessPolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createLBStickinessPolicy'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the LB stickiness policy'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a LB stickiness policy.'}, u'staticroute': {u'name': u'deleteStaticRoute', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createStaticRoute', u'listStaticRoutes'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the static route'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a static route'}, u'traffictype': {u'name': u'deleteTrafficType', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'addTrafficType'], u'length': 255, u'type': u'uuid', u'description': u'traffic type id'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes traffic type of a physical network'}, u'host': {u'name': u'deleteHost', u'related': [], u'isasync': False, u'params': [{u'name': u'forced', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force delete the host. All HA enabled vms running on the host will be put to HA; HA disabled ones will be stopped'}, {u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}, {u'name': u'forcedestroylocalstorage', u'required': False, u'related': [], u'length': 255, u'type': u'boolean', u'description': u'Force destroy local storage on this host. All VMs created on this local storage will be destroyed'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a host.'}, u'user': {u'name': u'deleteUser', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'lockUser', u'disableUser', u'getUser', u'listUsers', u'updateUser'], u'length': 255, u'type': u'uuid', u'description': u'id of the user to be deleted'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a user for an account'}, u'vpc': {u'name': u'deleteVPC', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVPCs', u'createVPC', u'createVPC', u'listVPCs', u'updateVPC', u'restartVPC'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the VPC'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a VPC'}, u'srxfirewall': {u'name': u'deleteSrxFirewall', u'related': [], u'isasync': True, u'params': [{u'name': u'fwdeviceid', u'required': True, u'related': [u'listSrxFirewalls', u'configureSrxFirewall'], u'length': 255, u'type': u'uuid', u'description': u'srx firewall device ID'}], u'requiredparams': [u'fwdeviceid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u' delete a SRX firewall device'}, u'externalfirewall': {u'name': u'deleteExternalFirewall', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts'], u'length': 255, u'type': u'uuid', u'description': u'Id of the external firewall appliance.'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes an external firewall appliance.'}, u'tags': {u'name': u'deleteTags', u'related': [], u'isasync': True, u'params': [{u'name': u'resourcetype', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Delete tag by resource type'}, {u'name': u'tags', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'Delete tags matching key/value pairs'}, {u'name': u'resourceids', u'required': True, u'related': [], u'length': 255, u'type': u'list', u'description': u'Delete tags for resource id(s)'}], u'requiredparams': [u'resourcetype', u'resourceids'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deleting resource tag(s)'}, u'autoscalevmprofile': {u'name': u'deleteAutoScaleVmProfile', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listAutoScaleVmProfiles'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the autoscale profile'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a autoscale vm profile.'}, u'affinitygroup': {u'name': u'deleteAffinityGroup', u'related': [], u'isasync': True, u'params': [{u'name': u'name', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'The name of the affinity group. Mutually exclusive with id parameter'}, {u'name': u'id', u'required': False, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The ID of the affinity group. Mutually exclusive with name parameter'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID of account owning the affinity group'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account of the affinity group. Must be specified with domain ID'}], u'requiredparams': [], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes affinity group'}, u'volume': {u'name': u'deleteVolume', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVolumes', u'migrateVolume', u'uploadVolume', u'createVolume', u'detachVolume', u'attachVolume', u'uploadVolume', u'updateVolume', u'createVolume', u'resizeVolume'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the disk volume'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a detached disk volume.'}, u'account': {u'name': u'deleteAccount', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listAccounts', u'listAccounts', u'markDefaultZoneForAccount', u'disableAccount'], u'length': 255, u'type': u'uuid', u'description': u'Account id'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a account, and all users associated with this account'}, u'netscalerloadbalancer': {u'name': u'deleteNetscalerLoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'lbdeviceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'netscaler load balancer device ID'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u' delete a netscaler load balancer device'}, u'firewallrule': {u'name': u'deleteFirewallRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the firewall rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a firewall rule'}, u'networkoffering': {u'name': u'deleteNetworkOffering', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'createNetworkOffering', u'updateNetworkOffering'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network offering'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a network offering.'}, u'vpncustomergateway': {u'name': u'deleteVpnCustomerGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVpnCustomerGateways', u'updateVpnCustomerGateway'], u'length': 255, u'type': u'uuid', u'description': u'id of customer gateway'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Delete site to site vpn customer gateway'}, u'counter': {u'name': u'deleteCounter', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createCounter'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the counter'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a counter'}, u'lbhealthcheckpolicy': {u'name': u'deleteLBHealthCheckPolicy', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createLBHealthCheckPolicy', u'updateLBHealthCheckPolicy', u'listLBHealthCheckPolicies'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer HealthCheck policy'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a load balancer HealthCheck policy.'}, u'sshkeypair': {u'name': u'deleteSSHKeyPair', u'related': [], u'isasync': False, u'params': [{u'name': u'projectid', u'required': False, u'related': [u'createProject', u'updateProject'], u'length': 255, u'type': u'uuid', u'description': u'the project associated with keypair'}, {u'name': u'name', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'Name of the keypair'}, {u'name': u'domainid', u'required': False, u'related': [u'listDomains', u'listDomainChildren', u'updateDomain', u'createDomain'], u'length': 255, u'type': u'uuid', u'description': u'the domain ID associated with the keypair'}, {u'name': u'account', u'required': False, u'related': [], u'length': 255, u'type': u'string', u'description': u'the account associated with the keypair. Must be used with the domainId parameter.'}], u'requiredparams': [u'name'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a keypair by name'}, u'vmsnapshot': {u'name': u'deleteVMSnapshot', u'related': [], u'isasync': True, u'params': [{u'name': u'vmsnapshotid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'The ID of the VM snapshot'}], u'requiredparams': [u'vmsnapshotid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a vmsnapshot.'}, u'vlaniprange': {u'name': u'deleteVlanIpRange', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVlanIpRanges', u'dedicatePublicIpRange'], u'length': 255, u'type': u'uuid', u'description': u'the id of the VLAN IP range'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Creates a VLAN IP range.'}, u'f5loadbalancer': {u'name': u'deleteF5LoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'lbdeviceid', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'netscaler load balancer device ID'}], u'requiredparams': [u'lbdeviceid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u' delete a F5 load balancer device'}, u'snapshot': {u'name': u'deleteSnapshot', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createSnapshot', u'revertSnapshot'], u'length': 255, u'type': u'uuid', u'description': u'The ID of the snapshot'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a snapshot of a disk volume.'}, u'loadbalancer': {u'name': u'deleteLoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Load Balancer'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a load balancer'}, u'instancegroup': {u'name': u'deleteInstanceGroup', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the instance group'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a vm group'}, u'bigswitchvnsdevice': {u'name': u'deleteBigSwitchVnsDevice', u'related': [], u'isasync': True, u'params': [{u'name': u'vnsdeviceid', u'required': True, u'related': [u'listBigSwitchVnsDevices'], u'length': 255, u'type': u'uuid', u'description': u'BigSwitch device ID'}], u'requiredparams': [u'vnsdeviceid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u' delete a bigswitch vns device'}, u'imagestore': {u'name': u'deleteImageStore', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the image store ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes an image store .'}, u'egressfirewallrule': {u'name': u'deleteEgressFirewallRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'updatePortForwardingRule', u'createIpForwardingRule', u'listIpForwardingRules', u'listPortForwardingRules', u'createPortForwardingRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the firewall rule'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes an ggress firewall rule'}, u'networkserviceprovider': {u'name': u'deleteNetworkServiceProvider', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listTrafficTypes', u'addNetworkServiceProvider', u'updateNetworkServiceProvider'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the network service provider'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a Network Service Provider.'}, u'physicalnetwork': {u'name': u'deletePhysicalNetwork', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Physical network'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Deletes a Physical Network.'}, u'paloaltofirewall': {u'name': u'deletePaloAltoFirewall', u'related': [], u'isasync': True, u'params': [{u'name': u'fwdeviceid', u'required': True, u'related': [u'addPaloAltoFirewall', u'listPaloAltoFirewalls', u'configurePaloAltoFirewall'], u'length': 255, u'type': u'uuid', u'description': u'Palo Alto firewall device ID'}], u'requiredparams': [u'fwdeviceid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u' delete a Palo Alto firewall device'}, u'privategateway': {u'name': u'deletePrivateGateway', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'createPrivateGateway'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the private gateway'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Deletes a Private gateway'}}, u'assign': {u'togloballoadbalancerrule': {u'name': u'assignToGlobalLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'gslblbruleweightsmap', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u"Map of LB rule id's and corresponding weights (between 1-100) in the GSLB rule, if not specified weight of a LB rule is defaulted to 1. Specified as 'gslblbruleweightsmap[0].loadbalancerid=UUID&gslblbruleweightsmap[0].weight=10'"}, {u'name': u'loadbalancerrulelist', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'list', u'description': u'the list load balancer rules that will be assigned to gloabal load balacner rule'}, {u'name': u'id', u'required': True, u'related': [u'listGlobalLoadBalancerRules', u'updateGlobalLoadBalancerRule'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the global load balancer rule'}], u'requiredparams': [u'loadbalancerrulelist', u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Assign load balancer rule or list of load balancer rules to a global load balancer rules.'}, u'certtoloadbalancer': {u'name': u'assignCertToLoadBalancer', u'related': [], u'isasync': True, u'params': [{u'name': u'certid', u'required': True, u'related': [u'listSslCerts'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the certificate'}, {u'name': u'lbruleid', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}], u'requiredparams': [u'certid', u'lbruleid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Assigns a certificate to a Load Balancer Rule'}, u'virtualmachine': {u'name': u'assignVirtualMachine', u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'isasync': False, u'params': [{u'name': u'virtualmachineid', u'required': True, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'uuid', u'description': u'id of the VM to be moved'}, {u'name': u'networkids', u'required': False, u'related': [u'updateNetwork', u'listNetscalerLoadBalancerNetworks', u'createNetwork', u'updateNetwork', u'listNetworks'], u'length': 255, u'type': u'list', u'description': u'list of new network ids in which the moved VM will participate. In case no network ids are provided the VM will be part of the default network for that zone. In case there is no network yet created for the new account the default network will be created.'}, {u'name': u'account', u'required': True, u'related': [], u'length': 255, u'type': u'string', u'description': u'account name of the new VM owner.'}, {u'name': u'securitygroupids', u'required': False, u'related': [], u'length': 255, u'type': u'list', u'description': u'list of security group ids to be applied on the virtual machine. In case no security groups are provided the VM is part of the default security group.'}, {u'name': u'domainid', u'required': True, u'related': [u'listDomainChildren'], u'length': 255, u'type': u'uuid', u'description': u'domain id of the new VM owner.'}], u'requiredparams': [u'virtualmachineid', u'account', u'domainid'], u'response': [{u'type': u'boolean', u'name': u'isdynamicallyscalable', u'description': u'true if vm contains XS/VMWare tools inorder to support dynamic scaling of VM cpu/memory.'}, {u'type': u'long', u'name': u'diskkbswrite', u'description': u'the write (bytes) of disk on the vm'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the vm'}, {u'type': u'string', u'name': u'templatedisplaytext', u'description': u' an alternate display text of the template for the virtual machine'}, {u'type': u'integer', u'name': u'cpunumber', u'description': u'the number of cpu this virtual machine is running with'}, {u'type': u'boolean', u'name': u'haenable', u'description': u'true if high-availability is enabled, false otherwise'}, {u'type': u'string', u'name': u'serviceofferingid', u'description': u'the ID of the service offering of the virtual machine'}, {u'type': u'string', u'name': u'hostid', u'description': u'the ID of the host for the virtual machine'}, {u'type': u'long', u'name': u'diskioread', u'description': u'the read (io) of disk on the vm'}, {u'type': u'boolean', u'name': u'passwordenabled', u'description': u'true if the password rest feature is enabled, false otherwise'}, {u'type': u'string', u'name': u'isoname', u'description': u'the name of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'zonename', u'description': u'the name of the availability zone for the virtual machine'}, {u'type': u'string', u'name': u'diskofferingid', u'description': u'the ID of the disk offering of the virtual machine'}, {u'description': u'list of affinity groups associated with the virtual machine', u'type': u'set', u'response': [{u'type': u'string', u'name': u'account', u'description': u'the account owning the affinity group'}, {u'type': u'list', u'name': u'virtualmachineIds', u'description': u'virtual machine Ids associated with this affinity group '}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the affinity group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the affinity group'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the affinity group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the affinity group'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the affinity group'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the affinity group'}], u'name': u'affinitygroup'}, {u'type': u'string', u'name': u'templatename', u'description': u'the name of the template for the virtual machine'}, {u'type': u'long', u'name': u'rootdeviceid', u'description': u'device ID of the root volume'}, {u'type': u'long', u'name': u'networkkbswrite', u'description': u'the outgoing network traffic on the host'}, {u'type': u'long', u'name': u'networkkbsread', u'description': u'the incoming network traffic on the vm'}, {u'description': u'the list of nics associated with vm', u'type': u'set', u'response': [{u'type': u'boolean', u'name': u'isdefault', u'description': u'true if nic is default, false otherwise'}, {u'type': u'string', u'name': u'deviceid', u'description': u'device id for the network when plugged into the virtual machine'}, {u'type': u'string', u'name': u'networkid', u'description': u'the ID of the corresponding network'}, {u'type': u'string', u'name': u'type', u'description': u'the type of the nic'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the nic'}, {u'type': u'list', u'name': u'secondaryip', u'description': u'the Secondary ipv4 addr of nic'}, {u'type': u'string', u'name': u'gateway', u'description': u'the gateway of the nic'}, {u'type': u'string', u'name': u'netmask', u'description': u'the netmask of the nic'}, {u'type': u'string', u'name': u'virtualmachineid', u'description': u'Id of the vm to which the nic belongs'}, {u'type': u'string', u'name': u'ip6cidr', u'description': u'the cidr of IPv6 network'}, {u'type': u'string', u'name': u'ip6gateway', u'description': u'the gateway of IPv6 network'}, {u'type': u'string', u'name': u'networkname', u'description': u'the name of the corresponding network'}, {u'type': u'string', u'name': u'traffictype', u'description': u'the traffic type of the nic'}, {u'type': u'string', u'name': u'ipaddress', u'description': u'the ip address of the nic'}, {u'type': u'string', u'name': u'ip6address', u'description': u'the IPv6 address of network'}, {u'type': u'string', u'name': u'isolationuri', u'description': u'the isolation uri of the nic'}, {u'type': u'string', u'name': u'broadcasturi', u'description': u'the broadcast uri of the nic'}, {u'type': u'string', u'name': u'macaddress', u'description': u'true if nic is default, false otherwise'}], u'name': u'nic'}, {u'type': u'string', u'name': u'displayname', u'description': u'user generated name. The name of the virtual machine is returned if no displayname exists.'}, {u'type': u'string', u'name': u'serviceofferingname', u'description': u'the name of the service offering of the virtual machine'}, {u'description': u'list of security groups associated with the virtual machine', u'type': u'set', u'response': [{u'description': u'the list of ingress rules associated with the security group', u'type': u'set', u'response': [{u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}], u'name': u'ingressrule'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain name of the security group'}, {u'type': u'string', u'name': u'description', u'description': u'the description of the security group'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id of the group'}, {u'type': u'string', u'name': u'domainid', u'description': u'the domain ID of the security group'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the group'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the security group'}, {u'description': u'the list of egress rules associated with the security group', u'type': u'set', u'response': [{u'type': u'integer', u'name': u'endport', u'description': u'the ending IP of the security group rule '}, {u'type': u'string', u'name': u'securitygroupname', u'description': u'security group name'}, {u'type': u'integer', u'name': u'icmptype', u'description': u'the type of the ICMP message response'}, {u'type': u'string', u'name': u'account', u'description': u'account owning the security group rule'}, {u'type': u'integer', u'name': u'startport', u'description': u'the starting IP of the security group rule'}, {u'type': u'string', u'name': u'protocol', u'description': u'the protocol of the security group rule'}, {u'type': u'string', u'name': u'ruleid', u'description': u'the id of the security group rule'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}], u'name': u'tags'}, {u'type': u'string', u'name': u'cidr', u'description': u'the CIDR notation for the base IP address of the security group rule'}, {u'type': u'integer', u'name': u'icmpcode', u'description': u'the code for the ICMP message response'}], u'name': u'egressrule'}, {u'type': u'string', u'name': u'account', u'description': u'the account owning the security group'}, {u'description': u'the list of resource tags associated with the rule', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the security group'}], u'name': u'securitygroup'}, {u'type': u'string', u'name': u'isoid', u'description': u'the ID of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'cpuused', u'description': u"the amount of the vm's CPU currently used"}, {u'description': u'the list of resource tags associated with vm', u'type': u'set', u'response': [{u'type': u'string', u'name': u'customer', u'description': u'customer associated with the tag'}, {u'type': u'string', u'name': u'key', u'description': u'tag key name'}, {u'type': u'string', u'name': u'resourcetype', u'description': u'resource type'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain associated with the tag'}, {u'type': u'string', u'name': u'projectid', u'description': u'the project id the tag belongs to'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the tag'}, {u'type': u'string', u'name': u'value', u'description': u'tag value'}, {u'type': u'string', u'name': u'domain', u'description': u'the domain associated with the tag'}, {u'type': u'string', u'name': u'resourceid', u'description': u'id of the resource'}, {u'type': u'string', u'name': u'project', u'description': u'the project name where tag belongs to'}], u'name': u'tags'}, {u'type': u'string', u'name': u'vgpu', u'description': u'the vgpu type used by the virtual machine'}, {u'type': u'string', u'name': u'publicip', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'date', u'name': u'created', u'description': u'the date when this virtual machine was created'}, {u'type': u'string', u'name': u'hostname', u'description': u'the name of the host for the virtual machine'}, {u'type': u'string', u'name': u'instancename', u'description': u'instance name of the user vm; this parameter is returned to the ROOT admin only'}, {u'type': u'string', u'name': u'isodisplaytext', u'description': u'an alternate display text of the ISO attached to the virtual machine'}, {u'type': u'string', u'name': u'hypervisor', u'description': u'the hypervisor on which the template runs'}, {u'type': u'string', u'name': u'name', u'description': u'the name of the virtual machine'}, {u'type': u'string', u'name': u'account', u'description': u'the account associated with the virtual machine'}, {u'type': u'long', u'name': u'diskiowrite', u'description': u'the write (io) of disk on the vm'}, {u'type': u'string', u'name': u'domain', u'description': u'the name of the domain in which the virtual machine exists'}, {u'type': u'integer', u'name': u'cpuspeed', u'description': u'the speed of each cpu'}, {u'type': u'string', u'name': u'id', u'description': u'the ID of the virtual machine'}, {u'type': u'string', u'name': u'domainid', u'description': u'the ID of the domain in which the virtual machine exists'}, {u'type': u'string', u'name': u'rootdevicetype', u'description': u'device type of the root volume'}, {u'type': u'map', u'name': u'details', u'description': u'Vm details in key/value pairs.'}, {u'type': u'string', u'name': u'diskofferingname', u'description': u'the name of the disk offering of the virtual machine'}, {u'type': u'string', u'name': u'zoneid', u'description': u'the ID of the availablility zone for the virtual machine'}, {u'type': u'string', u'name': u'project', u'description': u'the project name of the vm'}, {u'type': u'string', u'name': u'publicipid', u'description': u'public IP address id associated with vm via Static nat rule'}, {u'type': u'string', u'name': u'guestosid', u'description': u'Os type ID of the virtual machine'}, {u'type': u'string', u'name': u'groupid', u'description': u'the group ID of the virtual machine'}, {u'type': u'string', u'name': u'password', u'description': u'the password (if exists) of the virtual machine'}, {u'type': u'string', u'name': u'group', u'description': u'the group name of the virtual machine'}, {u'type': u'long', u'name': u'diskkbsread', u'description': u'the read (bytes) of disk on the vm'}, {u'type': u'integer', u'name': u'memory', u'description': u'the memory allocated for the virtual machine'}, {u'type': u'string', u'name': u'keypair', u'description': u'ssh key-pair'}, {u'type': u'string', u'name': u'state', u'description': u'the state of the virtual machine'}, {u'type': u'string', u'name': u'templateid', u'description': u'the ID of the template for the virtual machine. A -1 is returned if the virtual machine was created from an ISO file.'}, {u'type': u'boolean', u'name': u'displayvm', u'description': u'an optional field whether to the display the vm to the end user or not.'}, {u'type': u'boolean', u'name': u'forvirtualnetwork', u'description': u'the virtual network for the service offering'}, {u'type': u'string', u'name': u'servicestate', u'description': u'State of the Service from LB rule'}, {u'type': u'long', u'name': u'ostypeid', u'description': u'OS type id of the vm'}], u'description': u'Change ownership of a VM from one account to another. This API is available for Basic zones with security groups and Advanced zones with guest networks. A root administrator can reassign a VM from any account to any other account in any domain. A domain administrator can reassign a VM to any account in the same domain.'}, u'toloadbalancerrule': {u'name': u'assignToLoadBalancerRule', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listIpForwardingRules'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the load balancer rule'}, {u'name': u'virtualmachineids', u'required': False, u'related': [u'listVirtualMachines', u'updateVirtualMachine', u'startVirtualMachine', u'migrateVirtualMachineWithVolume', u'revertToVMSnapshot', u'migrateVirtualMachine', u'changeServiceForVirtualMachine', u'updateVirtualMachine', u'addNicToVirtualMachine', u'listVirtualMachines', u'rebootVirtualMachine', u'removeNicFromVirtualMachine', u'changeServiceForVirtualMachine', u'destroyVirtualMachine', u'startVirtualMachine', u'revertToVMSnapshot', u'restoreVirtualMachine', u'stopVirtualMachine', u'destroyVirtualMachine', u'resetPasswordForVirtualMachine', u'assignVirtualMachine', u'detachIso', u'detachIso', u'stopVirtualMachine', u'attachIso', u'deployVirtualMachine', u'restoreVirtualMachine', u'resetSSHKeyForVirtualMachine', u'updateVMAffinityGroup', u'updateDefaultNicForVirtualMachine'], u'length': 255, u'type': u'list', u'description': u'the list of IDs of the virtual machine that are being assigned to the load balancer rule(i.e. virtualMachineIds=1,2,3)'}, {u'name': u'vmidipmap', u'required': False, u'related': [], u'length': 255, u'type': u'map', u'description': u'VM ID and IP map, vmidipmap[0].vmid=1 vmidipmap[0].ip=10.1.1.75'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Assigns virtual machine or a list of virtual machines to a load balancer rule.'}}, u'release': {u'publiciprange': {u'name': u'releasePublicIpRange', u'related': [], u'isasync': False, u'params': [{u'name': u'id', u'required': True, u'related': [u'listVlanIpRanges', u'dedicatePublicIpRange'], u'length': 255, u'type': u'uuid', u'description': u'the id of the Public IP range'}], u'requiredparams': [u'id'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Releases a Public IP range back to the system pool'}, u'hostreservation': {u'name': u'releaseHostReservation', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listHosts', u'updateHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the host ID'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Releases host reservation.'}, u'dedicatedcluster': {u'name': u'releaseDedicatedCluster', u'related': [], u'isasync': True, u'params': [{u'name': u'clusterid', u'required': True, u'related': [u'updateCluster'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Cluster'}], u'requiredparams': [u'clusterid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Release the dedication for cluster'}, u'dedicatedzone': {u'name': u'releaseDedicatedZone', u'related': [], u'isasync': True, u'params': [{u'name': u'zoneid', u'required': True, u'related': [u'updateZone', u'listZones', u'listZones', u'createZone'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Zone'}], u'requiredparams': [u'zoneid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Release dedication of zone'}, u'dedicatedhost': {u'name': u'releaseDedicatedHost', u'related': [], u'isasync': True, u'params': [{u'name': u'hostid', u'required': True, u'related': [u'listHosts', u'updateHost', u'addBaremetalHost', u'listExternalLoadBalancers', u'addHost', u'prepareHostForMaintenance'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the host'}], u'requiredparams': [u'hostid'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Release the dedication for host'}, u'dedicatedpod': {u'name': u'releaseDedicatedPod', u'related': [], u'isasync': True, u'params': [{u'name': u'podid', u'required': True, u'related': [u'createPod', u'updatePod'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the Pod'}], u'requiredparams': [u'podid'], u'response': [{u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}, {u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}], u'description': u'Release the dedication for the pod'}, u'dedicatedguestvlanrange': {u'name': u'releaseDedicatedGuestVlanRange', u'related': [], u'isasync': True, u'params': [{u'name': u'id', u'required': True, u'related': [u'listDedicatedGuestVlanRanges', u'dedicateGuestVlanRange'], u'length': 255, u'type': u'uuid', u'description': u'the ID of the dedicated guest vlan range'}], u'requiredparams': [u'id'], u'response': [{u'type': u'boolean', u'name': u'success', u'description': u'true if operation is executed successfully'}, {u'type': u'string', u'name': u'displaytext', u'description': u'any text associated with the success or failure'}], u'description': u'Releases a dedicated guest vlan range to the system'}}}